Package: scider
Type: Package
Title: Spatial cell-type inter-correlation by density in R
Version: 1.8.0
Authors@R: 
    c(person(given = "Mengbo",family = "Li", 
             role = c("aut"),
             email = "li.me@wehi.edu.au",
             comment = c(ORCID = "0000-0002-9666-5810")),
      person(given = "Ning", 
             family = "Liu",
             role = c("aut"),
             email = "liu.n@wehi.edu.au",
             comment = c(ORCID = "0000-0002-9487-9305")),
      person(given = "Quoc Hoang",
             family = "Nguyen",
             role = c("aut"),
             email = "nguyen.q@wehi.edu.au",
             comment = c(ORCID = "0009-0007-2828-7567")),
      person(given = "Yunshun",
             family = "Chen",
             role = c("aut", "cre"),
             email = "yuchen@wehi.edu.au",
             comment = c(ORCID = "0000-0003-4911-5653")))
Description: scider is an user-friendly R package providing functions 
    to model the global density of cells in a slide of spatial 
    transcriptomics data. All functions in the package are built 
    based on the SpatialExperiment object, allowing integration into 
    various spatial transcriptomics-related packages from Bioconductor. 
    After modelling density, the package allows for serveral 
    downstream analysis, including colocalization analysis, 
    boundary detection analysis and differential density analysis.
biocViews: Spatial, Transcriptomics
License: GPL-3 + file LICENSE
URL: https://github.com/ChenLaboratory/scider,
        https://chenlaboratory.github.io/scider/
BugReports: https://github.com/ChenLaboratory/scider/issues
Encoding: UTF-8
LazyData: false
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Imports: SpatialExperiment, SummarizedExperiment, spatstat.geom,
        spatstat.explore, sf, lwgeom, SpatialPack, ggplot2, stats,
        pheatmap, plotly, shiny, igraph, janitor, knitr, methods,
        utils, isoband, S4Vectors, grDevices, dbscan, hexDensity,
        hexbin, uwot, SingleCellExperiment, BiocNeighbors, irlba
Suggests: edgeR, testthat (>= 3.0.0)
Config/testthat/edition: 3
Depends: R (>= 4.3)
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/scider
git_branch: RELEASE_3_22
git_last_commit: 2a5b6a6
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 06:19:28 UTC; biocbuild
Author: Mengbo Li [aut] (ORCID: <https://orcid.org/0000-0002-9666-5810>),
  Ning Liu [aut] (ORCID: <https://orcid.org/0000-0002-9487-9305>),
  Quoc Hoang Nguyen [aut] (ORCID:
    <https://orcid.org/0009-0007-2828-7567>),
  Yunshun Chen [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4911-5653>)
Maintainer: Yunshun Chen <yuchen@wehi.edu.au>

# scider: Spatial cell-type inter-correlation by density in R. <img src="man/figures/scider_sticker.png" align="right" alt="" width="120" />

[![R-CMD-check](https://github.com/ChenLaboratory/scider/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/ChenLaboratory/scider/actions)
[![Codecov test coverage](https://codecov.io/gh/ChenLaboratory/scider/branch/devel/graph/badge.svg)](https://app.codecov.io/gh/ChenLaboratory/scider?branch=devel)

*scider* implements functions to analyse spatial transcriptomics 
data with cell type annotations by performing cell type 
correlation via density estimation and cell type co-localization 
via real number distance. Functions include density 
estimation, statistical modelling and visualizations.

Install released version form Bioconductor

```
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("scider")
```


Install development version from GitHub

```
library(devtools)   
devtools::install_github("ChenLaboratory/scider")
```

#' Scale and straighten out Visium coordinates
#' @param spe A SpatialExperiment object.
#' @param distPoint Numeric. Desired point to point distance.
#' @details This function rescale the distance between points to 100um (or other
#' value) to matchthe real distance. In addition, Visium spots have a slight 
#' tilt to them which this function will also fix
#' @export
realignVisium <- function(spe,
                          distPoint = 100) {
  if (is.null(spe$array_col) || is.null(spe$array_row)) {
    stop("spe must have array_col and array_row in its colData.")
  }
  
  # Temporarily scale array_col and array_row by c(1/2,sqrt(3)/2) to match 
  # square arrangement
  old_array_col <- spe@colData$array_col
  old_array_row <- spe@colData$array_row
  spe@colData$array_col <- old_array_col/2
  spe@colData$array_row <- old_array_row/2*sqrt(3)
  spe <- realignVisiumHD(spe,distPoint)
  spe@colData$array_col <- old_array_col
  spe@colData$array_row <- old_array_row
  return(spe)
}

#' Scale and straighten out VisiumHD coordinates
#' @param spe A SpatialExperiment object.
#' @param distPoint Numeric. Desired point to point distance. If NULL, will try 
#' to determine the bin level of spe and use that.
#' @details This function rescale the distance between points to 8um (or other
#' value) to matchthe real distance. In addition, Visium spots have a slight 
#' tilt to them which this function will also fix
#' @export
realignVisiumHD <- function(spe,
                            distPoint = NULL) {
  if (is.null(spe$array_col) || is.null(spe$array_row)) {
    stop("spe must have array_col and array_row in its colData.")
  }
  
  if (is.null(distPoint)) {
    ## Figuring out binsize (2, 8, or 16um).
    distPoint <- .guessVisiumHDBin(spe)
    if (is.null(distPoint)) {
      stop("Couldn't determine distPoint. Please provide one.")
    }
    message(paste0("Using distPoint = ",distPoint))
  }
  
  ## Getting scale factor pxl/um.
  # Use average of 100 distance pairs (one is not too accurate. all is too much).
  n_points <- min(200,ncol(spe)-ncol(spe)%%2)
  coords <- as.matrix(spatialCoords(spe))
  colrow <- as.matrix(spe@colData[,c("array_col","array_row")])
  
  pxl_dist <- coords[1:(n_points/2),]-coords[(n_points/2+1):n_points,]
  pxl_dist <- sqrt(rowSums(pxl_dist^2))
  
  um_dist <- colrow[1:(n_points/2),]-colrow[(n_points/2+1):n_points,]
  um_dist <- sqrt(rowSums(um_dist^2))*distPoint
  scale_factor <- mean(pxl_dist/um_dist)
  
  ## Scaling and realignment
  dim_names <- dimnames(spatialCoords(spe))
  spatialCoords(spe) <- sweep(cbind((colData(spe)$array_col)*distPoint,
                                    (colData(spe)$array_row)*distPoint),
                              2,
                              coords[1,]/scale_factor-colrow[1,]*distPoint,
                              "+")
  dimnames(spatialCoords(spe)) <- dim_names
  
  imgData(spe)$scaleFactor = imgData(spe)$scaleFactor*scale_factor
  return(spe)
}

.guessVisiumHDBin <- function(spe) {
  bin <- NULL
  # check colnames 
  text <- colnames(spe)[1]
  match <- regexpr("^s_(002|008|016)um",text)
  match_loc <- which(match!=-1)[1]
  if (!is.na(match_loc)) {
    bin <- substr(text[match_loc],match[match_loc]+2,match[match_loc]+4)
  } else if (!is.null(spe$bin_size)) {
    # No matches. check for spe$bin_size (VisiumIO).
    bin <- spe$bin_size[1]
  } else {
    # No matches. check colnames of colData (Seurat).
    text <- colnames(spe@colData)
    match <- regexpr("(002|008|016)um",text)
    match_loc <- which(match!=-1)[1]
    if (!is.na(match_loc)) {
      bin <- substr(text[match_loc],match[match_loc],match[match_loc]+2)
    }
  }
  return(as.integer(bin))
}

#' Plot model statistics using heatmap.
#'
#' @param model.result A dataFrame object.
#' @param stats Character value. Choose either coefficient or t.
#' Coefficient by default.
#' @param roi Character value. By default is all. The specific
#' ROIs to be plotted.
#' @param cell.type Character value. By default is all. The cell types
#' to be plotted.
#' @param silent Do not draw the plot
#' (useful when using the gtable output). 
#' @return A pheatmap object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi)
#'
#' model_result <- corDensity(spe, roi = coi)
#'
#' plotCorHeatmap(model_result$ROI)
#'
plotCorHeatmap <- function(model.result,
                           stats = c("cor.coef", "t", "p.Pos", "p.Neg"),
                           roi = "all",
                           cell.type = "all", 
                           silent = FALSE) {
    if (!all(c("cor.coef", "p.Pos", "p.Neg") %in%
        colnames(model.result))) {
        stop("Please run corDensity before using this function.")
    }

    fit_dat <- model.result

    stats <- match.arg(stats)
    # if (length(stats) != 1) {
    #     stats <- "cor.coef"
    # } else if (!(stats %in% c("cor.coef", "t", "p.Pos", "p.Neg"))) {
    #     stop("stats can only allow either cor.coef, t, p.Pos and p.Neg.")
    # }

    if (all(cell.type != "all")) {
        cell.type <- janitor::make_clean_names(cell.type, case = "sentence")
        if (length(cell.type) < 2L) {
            stop("cell.type must be either all or length larger than 1.")
        }
        if (!all(cell.type %in% unique(c(
            fit_dat$celltype1,
            fit_dat$celltype2
        )))) {
            stop("cell.type must be all in celltype1 or celltype2 columns.")
        }

        fit_dat <- fit_dat[(fit_dat$celltype1 %in% cell.type) &
            (fit_dat$celltype2 %in% cell.type), ]
    }

    if (!("ROI" %in% colnames(fit_dat))) {
        fit_dat <- fit_dat
        title <- paste0("Statistics (", stats, ")")
        filled_data <- plot_type1_transformation(fit_dat, stats)
    } else {
        if (all(roi != "all")) {
            if (length(roi) == 1L) {
                if (!(roi %in% fit_dat[["ROI"]])) {
                    stop("roi is not in the ROI column.")
                }
                fit_dat <- fit_dat[fit_dat$ROI == roi, ]
                title <- paste0("Statistics (", stats, ") of ROI #", roi)
                filled_data <- plot_type1_transformation(fit_dat, stats)
            } else {
                if (!all(roi %in% fit_dat[["ROI"]])) {
                    stop("rois are not all in the ROI column.")
                }
                fit_dat <- fit_dat[fit_dat$ROI %in% roi, ]
                title <- paste0(
                    "Statistics (", stats, ") of ROI #",
                    paste(roi, collapse = ",")
                )
                filled_data <- plot_type2_transformation(fit_dat, stats)
            }
        } else {
            title <- paste0("Statistics (", stats, ")")
            filled_data <- plot_type2_transformation(fit_dat, stats)
        }
    }

    paletteLength <- 100
    hmColor <- rev(colorRampPalette(c(
        "#ED254EFF", "#EF6079FF",
        "#F1F4FFFF", "#97B3D0FF",
        "#011936FF"
    ))(paletteLength))
    
    max_val <- max(abs(filled_data))
    
    myBreaks <- seq(-max_val, 
                    max_val, 
                    length.out = paletteLength + 1)

    if (nrow(filled_data) == 1L) {
        pheatmap::pheatmap(filled_data,
            angle_col = 45, border_color = "white",
            color = hmColor, breaks = myBreaks,
            main = title, cluster_rows = FALSE, 
            silent = silent
        )
    } else {
        pheatmap::pheatmap(filled_data,
            angle_col = 45, border_color = "white",
            color = hmColor, breaks = myBreaks,
            silent = silent, 
            main = title
        )
    }
}


fill_symmetric_na <- function(mat) {
    is_na <- is.na(mat)
    mat[is_na] <- t(mat)[is_na]
    return(mat)
}

plot_type1_transformation <- function(fit_dat_sub, stats) {
    plot_dat <- fit_dat_sub[, c("celltype1", "celltype2", stats)]
    cts <- unique(c(plot_dat$celltype1, plot_dat$celltype2))
    sup_dat <- data.frame(
        "celltype1" = cts,
        "celltype2" = cts
    )
    sup_dat[, stats] <- 0
    plot_dat <- rbind(plot_dat, sup_dat)
    plot_dat <- reshape(plot_dat,
        idvar = "celltype1",
        timevar = "celltype2",
        direction = "wide"
    ) |>
        as.data.frame(optional = TRUE) |>
        col2rownames("celltype1")
    colnames(plot_dat) <- gsub(
        paste0("^", stats, "\\."), "",
        colnames(plot_dat)
    )
    plot_dat <- plot_dat[colnames(plot_dat), ]
    filled_data <- fill_symmetric_na(plot_dat)
    return(filled_data)
}

plot_type2_transformation <- function(fit_dat, stats) {
    fit_dat <- as.data.frame(fit_dat[, c(
        "celltype1", "celltype2",
        "ROI", stats
    )])
    fit_dat[["pair"]] <- paste0(
        fit_dat[["celltype1"]], "-",
        fit_dat[["celltype2"]]
    )
    fit_dat <- fit_dat[, c("pair", "ROI", stats)]
    filled_data <- reshape(fit_dat,
        idvar = "pair", timevar = "ROI",
        direction = "wide"
    ) |>
        col2rownames("pair")
    colnames(filled_data) <- gsub(
        paste0("^", stats, "\\."), "ROI#",
        colnames(filled_data)
    )
    return(filled_data)
}

test_that("plotCorHeatmap works", {
    data("xenium_bc_spe")
    coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")
    spe <- gridDensity(spe, coi = coi)
    spe <- findROI(spe, coi = coi, method = "walktrap")
    result <- corDensity(spe, roi = coi)
    #result <- result$ROI

    expect_silent(plotCorHeatmap(result$ROI))
    expect_silent(plotCorHeatmap(result$overall))
    expect_silent(plotCorHeatmap(result$ROI, stats = "t"))
    expect_error(plotCorHeatmap(result$overall, stats = "xyz"))

    expect_error(plotCorHeatmap(result$ROI, roi = "x"))
    expect_silent(plotCorHeatmap(result$ROI, roi = "1"))
    expect_silent(plotCorHeatmap(result$ROI, roi = c("1", "2", "3")))
    expect_error(plotCorHeatmap(result$ROI, cell.type = "x"))
    expect_silent(plotCorHeatmap(result$ROI,
        cell.type = c(
            "Breast cancer",
            "Fibroblasts"
        )
    ))
})

#' Test for density correlation between two cell types.
#'
#' @param spe A SpatialExperiment object.
#' @param coi Character vector for cell types of interest for density 
#' correlation analysis. Default is NULL, which is to consider all cell types
#' previously calculated in the gridDensity() step. 
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. Default is NULL for no subsetting cell types by ROI
#' @param probs A numeric scalar. The threshold of proportion that used to
#' filter grids by density when ROIs have not been identified previously.
#' Ignored if 'roi' is present in the 'metadata' component of spe. Default to 0.85.
#' @param trace Logical. If TRUE, print the process of testing. Default to FALSE.
#'
#' @return A DataFrame containing the testing results.
#' @export
#' 
#' @importFrom SpatialPack modified.ttest
#' @importFrom stats pt
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi, method = "walktrap")
#'
#' result <- corDensity(spe, roi = coi)
#'
corDensity <- function(spe, coi = NULL, roi = NULL, probs = 0.85, trace = FALSE) {
  if (!("grid_density" %in% names(spe@metadata))) {
    stop("Please run gridDensity before using this function.")
  }

  dens_dat <- as.data.frame(spe@metadata$grid_density)

  # get cell type info
  den_cols <- colnames(dens_dat)[grepl("density_", colnames(dens_dat))]
  den_cols <- den_cols[den_cols != "density_overall"]

  if(any(!is.null(coi))){
    coi_clean <- paste0("density_", janitor::make_clean_names(coi))
    coi.exist <- coi_clean %in% den_cols
    if(any(!coi.exist))
      stop(paste0(paste(coi[!coi.exist], collapse=", "), " not found in the data."))
    den_cols <- den_cols[den_cols %in% coi_clean]
  }

  nCT <- length(den_cols)
  if (nCT < 2) stop("Please run gridDensity for at least two of the cell types specified in 'coi'.")

  # construct data table
  if (is.null(roi)) {
    dens_dat$density_coi_average <- rowMeans(as.matrix(dens_dat[, which(colnames(dens_dat) %in% den_cols), drop = FALSE]))
    kp <- dens_dat$density_coi_average >= quantile(dens_dat$density_coi_average, probs = probs)
    dens_dat_filter <- dens_dat[kp, ]
    rois <- data.frame(component=gl(1,sum(kp)),
                       members=dens_dat_filter$node,
                       x=dens_dat_filter$node_x,
                       y=dens_dat_filter$node_y)
  } else {
    roi <- gsub("_roi$", "", roi)
    roi <- janitor::make_clean_names(roi)
    roi <- paste(c(sort(roi),"roi"), collapse="_")
    if (is.null(spe@metadata[[roi]])) {
      stop(paste(
        roi, " is not found in metadata of spe. Please run findROI() first."
      ))
    }
    rois <- as.data.frame(spe@metadata[[roi]])
  }

  model_data <- merge(rois, dens_dat,
                      by.x = "members",
                      by.y = "node", all.x = TRUE, sort = FALSE
  )
  component <- factor(model_data$component)
  nGrids <- table(component)
  cpnts <- names(nGrids)
  nCpnts <- length(cpnts)

  nRows <- choose(nCT, 2) * nCpnts
  result.ROI <- data.frame(
    "celltype1" = rep("", nRows),
    "celltype2" = rep("", nRows),
    "ROI" = 0,
    "ngrid" = 0,
    "cor.coef" = 0,
    "t" = 0,
    "df" = 0,
    "p.Pos" = 0,
    "p.Neg" = 0
  )

  result.overall <- result.ROI[seq_len(choose(nCT, 2)), c(1, 2, 5, 8, 9)]

  for (i in seq_len((nCT - 1))) {
    for (j in (i + 1):nCT) {
      ct1 <- den_cols[i]
      ct2 <- den_cols[j]
      n1 <- janitor::make_clean_names(ct1,
                                      case = "sentence",
                                      replace = c("density" = "")
                                      )
      n2 <- janitor::make_clean_names(ct2,
                                      case = "sentence",
                                      replace = c("density" = "")
                                      )
      m <- choose(nCT, 2) - (choose(nCT - j, 1) + choose(nCT - i, 2))
      
      for (k in seq_len(nCpnts)) {
        if (trace) cat(paste("i =", i, ", j =", j, ", ROI", k, "\n"))
        data <- model_data[model_data$component == cpnts[k], c(ct1, ct2, "x", "y")]

        res <- modified.ttest(x=data[,1], y=data[,2],
                              coords=data[,c("x","y")], nclass=7)
        if(res$dof < 0) {
          res <- modified.ttest(x=data[,1], y=data[,2],
                                coords=data[,c("x","y")], nclass=1)
          res$dof <- 1
        }
        tstat <- sqrt( res$Fstat * res$dof ) * sign(res$corr)
        
        ind <- (m - 1) * nCpnts + k
        result.ROI[ind, "celltype1"] <- n1
        result.ROI[ind, "celltype2"] <- n2
        result.ROI[ind, "ROI"] <- cpnts[k]
        result.ROI[ind, "ngrid"] <- nGrids[k]
        result.ROI[ind, "cor.coef"] <- res$corr
        result.ROI[ind, "t"] <- tstat
        result.ROI[ind, "df"] <- res$dof
        result.ROI[ind, "p.Pos"] <- pt(tstat, df=res$dof, lower.tail = FALSE)
        result.ROI[ind, "p.Neg"] <- pt(tstat, df=res$dof, lower.tail = TRUE)
      }
      
      # summarize test results across ROIs
      sel <- (m - 1) * nCpnts + seq_len(nCpnts)
      out.cor.coef <- result.ROI$cor.coef[sel]
      out.p.Pos <- result.ROI$p.Pos[sel]
      out.p.Neg <- result.ROI$p.Neg[sel]
      
      result.overall[m, "celltype1"] <- n1
      result.overall[m, "celltype2"] <- n2
      result.overall[m, "cor.coef"] <- tanh(mean(atanh(out.cor.coef)))
      result.overall[m, "p.Pos"] <- pchisq(-2 * sum(log(out.p.Pos)),
                                           df = 2 * nCpnts, lower.tail = FALSE)
      result.overall[m, "p.Neg"] <- pchisq(-2 * sum(log(out.p.Neg)),
                                           df = 2 * nCpnts, lower.tail = FALSE)
    }
  }
  
  result.ROI <- S4Vectors::DataFrame(result.ROI)
  result.overall <- S4Vectors::DataFrame(result.overall)

  if(!is.null(roi))
    output <- list(ROI = result.ROI, overall = result.overall)
  else
    output <- result.ROI[,-3]
    
  return(output)
}

test_that("corDensity works", {
    data("xenium_bc_spe")

    spe <- gridDensity(spe)

    coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")

    spe <- findROI(spe, coi = coi)

    result <- corDensity(spe, roi = coi)
    
    expect_true(is(result, "list"))
    
    expect_true(identical(length(result), 2L))

    expect_true(all(c("celltype1", "celltype2", "cor.coef") %in% names(result$ROI)))
    
    expect_true(all(c("celltype1", "celltype2", "cor.coef") %in% names(result$overall)))
})

#' Calculate areas between every two density levels
#'
#' @param spe A SpatialExperiment object.
#' @param contour_name Name of contour in spe@metadata
#'
#' @return A list of sf objects, each representing the region between
#' two contour density levels.
#'

getContourRegions <- function(spe, contour_name) {
  contour_data <- spe@metadata[[contour_name]]
  levs <- unique(contour_data$cutoff)
  nlevs <- length(levs)
  
  # calculate regions for each level
  if (is.null(spe@metadata[[contour_name]])) stop("Have to calculate
                                           contours first!")
  dens_cols <- S4Vectors::metadata(contour_data)$densities
  dens <- as.data.frame(spe@metadata$grid_density)
  dens$density_coi_average <- rowMeans(dens[, which(colnames(dens) %in%
                                                      dens_cols),
                                            drop = FALSE
  ])
  
  # Canvas.
  grid_info <- spe@metadata$grid_info
  if (grid_info$grid_type=="hex") {
    # Hexagonal canvas' sides are jagged.
    x_l <- rep_len(c(grid_info$xlim[1],grid_info$xlim[1]+grid_info$xstep/2),
                   grid_info$dims[2])
    x_r <- x_l + grid_info$xstep*(grid_info$dims[1]-1)
    y <- grid_info$ylim[1]+grid_info$ystep*(seq_len(grid_info$dims[2])-1)
    canvas_sf <- sf::st_polygon(list(matrix(c(
      x_l,rev(x_r),x_l[1],
      y,rev(y),y[1]
    ),ncol=2)))
  } else {# Square
    range_x <- spe@metadata$grid_info$xcol[c(1,length(spe@metadata$grid_info$xcol))]
    range_y <- spe@metadata$grid_info$yrow[c(1,length(spe@metadata$grid_info$yrow))]
    canvas_sf <- sf::st_polygon(list(matrix(c(
      range_x[c(1,1,2,2,1)],
      range_y[c(1,2,2,1,1)]),
      ncol=2)))
  }
  
  # Turn contour into sf. each multilinestring is a contour level
  pieces <- split.data.frame(as.matrix(contour_data[,c("x","y","piece")]),contour_data$level)
  pieces_sf <- sf::st_as_sfc(lapply(pieces, function(i){
    sf::st_multilinestring(split.data.frame(i[,c("x","y")],i[,"piece"]))
  }))

  # Split canvas into regions using all contours
  canvas_sf <- sf::st_snap(canvas_sf,pieces_sf,tolerance = spe@metadata$grid_info$xstep*0.01)
  regions <- lwgeom::st_split(canvas_sf,pieces_sf)|>
    sf::st_collection_extract("POLYGON")
  
  ## Assign regions to contour level.
  interval <- vector(length=length(pieces_sf))
  inds <- sf::st_intersects(regions, pieces_sf)
  n_touched <- lengths(inds)
  # Case 1: Regions intersect 2 contour levels
  interval[n_touched==2] <- sapply(inds[n_touched==2],min)
  # Case 2: Regions intersect only 1 contour levels
  grids_pts_sf <- sf::st_as_sf(dens, coords = c("x_grid","y_grid"))
  interval[n_touched==1] <- findInterval(
    sapply(sf::st_intersects(regions[n_touched==1], grids_pts_sf), 
           function(i) mean(grids_pts_sf$density_coi_average[i])
           ),
    levs)
  
  # Combine regions with the same contour level
  all_areas <- lapply(seq_len(nlevs), function(ii) {
    sf::st_as_sf(sf::st_combine(regions[interval==ii]))
  })
  names(all_areas) <- as.character(seq_len(nlevs))
  all_areas
}

#' Plot ROIs on spatial.
#'
#' @param spe A SpatialExperiment object.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. All cell types are chosen if NULL or 'overall'.
#' @param id Character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to cell_type by default.
#' @param label Logical. Show ROI label or not.
#' @param show.legend Logical. Show legend or not.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Parameters pass to \link[scider]{plotSpatial}
#'
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi, method = "walktrap", steps = 5)
#'
#' plotROI(spe, roi = coi, pt.size = 0.3, pt.alpha = 0.2)
#'
plotROI <- function(spe,
                    roi = NULL,
                    id = "cell_type",
                    label = TRUE,
                    show.legend = FALSE, 
                    reverseY = NULL,
                    ...) {
  roi_clean <- `if`(is.null(roi),"overall",cleanName(roi))
  roi_clean_name <- paste(c(roi_clean,"roi"), collapse="_")
  
  if (is.null(spe@metadata[[roi_clean_name]])) {
    stop("ROI of interest doesn't exist. Please run findROI(), or specify 'roi'.")
  }
  
  rois <- as.data.frame(spe@metadata[[roi_clean_name]])
  
  # Filter background points to roi only.
  if (roi_clean_name != "overall_roi" &&
      id %in% colnames(spe@colData) &&
      any(spe@colData[,id] %in% roi)) {
    spe <- spe[, spe@colData[,id] %in% roi]
  }
  
  nROIs <- nlevels(rois$component)
  col.p <- selectColor(nROIs)
  
  # Get centres of ROIS
  sf <- grid2sf(spe, rois$x,rois$y)
  sf <- lapply(unique(rois$component), function(xx) {
    sf::st_union(sf::st_sfc(sf[rois$component == xx]))
  })
  names(sf) <- as.character(unique(rois$component))
  rois_center <- do.call(rbind, lapply(sf, function(rr) {
    center <- sf::st_point_on_surface(rr)
    as.data.frame(sf::st_coordinates(center))
  }))
  rois_center <- as.data.frame(rois_center)
  rois_center$component <- names(sf)
  
  # Turn sf into a dataframe for geom_polygon
  # Dealing with MULTIPOLYGON (which can happen with mergeROI)
  sf <- lapply(sf, function(xx) sf::st_cast(xx,"POLYGON"))
  poly_groups <- list(rep.int(1:length(sf),lengths(sf)))
  sf <- as.data.frame(sf::st_coordinates(do.call(c,sf)))
  sf$component <- rep.int(rois_center$component,
                          stats::aggregate(
                            tabulate(sf$L2),
                            by=poly_groups,
                            FUN=sum)[[2]])
  # Plotting
  p <- plotSpatial(spe, reverseY=reverseY, ...) +
    geom_polygon(
      data = sf,
      aes(
        x=X,
        y=Y,
        group = L2,
        fill = component,
        alpha = 0.6,
        subgroup = L1
      ),color=NA,
      inherit.aes = F) +
    scale_fill_manual(values = col.p) +
    ggtitle(paste0("ROI (", paste(roi_clean, collapse=", "), ")"))
  p <- update_bound(p, y=sf$Y)

  if (isFALSE(show.legend)) {
    p <- p +
      theme(legend.position = "none")
  }
  
  if (label) {
    p <- p +
      annotate("text",
               x = rois_center$X, y = rois_center$Y,
               label = rois_center$component, color = "black", fontface = 2
      )
  }
  
  return(p)
}


utils::globalVariables(c("xcoord", "ycoord", "component"))

test_that("plotROI works", {
    data("xenium_bc_spe")
    coi <- c("Breast cancer", "Fibroblasts")
    spe <- gridDensity(spe, coi = coi)
    expect_error(plotROI(spe))

    spe <- findROI(spe, coi = coi, method = "walktrap", steps = 5)

    expect_silent(plotROI(spe, roi = coi, pt.size = 0.3, pt.alpha = 0.2))
    expect_silent(plotROI(spe, roi = coi))
    expect_silent(plotROI(spe, roi = coi, show.legend = TRUE))
    #expect_error(plotROI(spe, roi = coi, id = "xyz"))
})

#' Plot cells based on spatial coordinates.
#'
#' @param spe A SpatialExperiment object.
#' @param group.by values to group points by. Must be in colData of spe. 
#' If NULL, will try with 'cols' if available.
#' @param feature Feature to group polygons by. Must be in rownames(spe).
#' @param assay Name of assay to use for plotting feature.
#' @param type Transformation to apply for the group/feature. Options are "raw"
#' , "log", "cpm", "logcpm", or a function that accepts and returns a vector of 
#' the same length.
#' @param cols Colour palette. Can be a vector of colours or a function 
#' that accepts an integer n and return n colours.
#' @param pt.shape shape of points.
#' @param pt.size size of points.
#' @param pt.alpha alpha of points between 0 and 1.
#' @param label label for the legend
#' @param cols.scale vector of position for color if colors should not be 
#' evenly positioned. See \link[ggplot2]{scale_color_gradientn}. Only applicable for continuous values.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Parameters pass to plotImage
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' plotSpatial(spe, group.by = "cell_type", pt.size = 0.5, pt.alpha = 0.6)
#'
plotSpatial <- function(spe, 
                        group.by = NULL,
                        feature = NULL,
                        assay = "counts",
                        type = c("raw","log","cpm","logcpm"),
                        cols = NULL,
                        pt.shape = 16, 
                        pt.size = 0.3, 
                        pt.alpha = 0.5,
                        label = NULL,
                        cols.scale = NULL,
                        reverseY = NULL,
                        ...) {
  toplot <- as.data.frame(SpatialExperiment::spatialCoords(spe))
  colnames(toplot) <- c("x", "y")

  cdata <- as.data.frame(SummarizedExperiment::colData(spe))
  
  if ("cell_id" %in% colnames(cdata)) {
    cdata <- cdata[, -which(colnames(cdata) == "cell_id")]
  }
  
  toplot <- cbind(toplot, cdata) |>
    rownames2col("cell_id")
  
  group <- col.p <- NULL
  
  # Groups. Order is: colData -> assays -> cols
  if (!is.null(group.by) && group.by %in% colnames(toplot)) {
    group <- toplot[[group.by]]
    if (is.null(label)) label <- group.by
  } else if (!is.null(feature) && feature %in% rownames(spe)) {
    group <- SummarizedExperiment::assay(spe,assay)[feature,]
    if (is.null(label)) label <- feature
  } else if (!is.null(cols) && !is.function(cols)) {
    group <- factor(rep_len(cols,nrow(toplot)),levels=unique(cols))
    col.p <- rep_len(unique(cols), length(unique(cols)))
  }
  
  # Type
  if (is.character(type)) {
    type <- switch(match.arg(type),
                   raw = NULL,
                   log = function(x) {log2(x+1)},
                   cpm = function(x) {
                     (x+0.5)/colSums(as.matrix(spe@assays@data[[assay]]))*1e6
                   },
                   logcpm = function(x) {
                     log2((x+0.5)/colSums(as.matrix(spe@assays@data[[assay]]))*1e6)
                   })
  }
  if(is.function(type)) {
    tryCatch({group <- type(group)},
             error = function(e){
               message("Error when applying 'type'. Skipping 'type'.")
             })
  }
  isContinuous <- is.numeric(group)
  
  # Colours
  if (!is.null(group) && is.null(col.p)) {
    n_colour <- length(unique(group))
    if (is.null(cols)) { # Default palette
      col.p <- `if`(isContinuous, col.spec, selectColor(n_colour))
    } else if (is.function(cols)) { # cols is function
      col.p <- cols(n_colour)
    } else { # cols is vector
      col.p <- `if`(isContinuous, cols, rep_len(cols,n_colour))
    }
  }
  
  # Plotting
  p <- plotImage(spe, reverseY=reverseY, ...) +
    ggplot2::geom_point(
      data = toplot,
      aes(x=x, y=y, color=!!group), # !! prevent name-clashing if toplot$group exists
      shape = pt.shape,
      size = pt.size,
      alpha = pt.alpha,
    ) +
    labs(x = "x", y = "y", color = label) +
    theme_classic()
  p <- update_bound(p,
                    x = toplot[,"x"],
                    y = toplot[,"y"])
  
  if (isContinuous) {
    p <- p + scale_color_gradientn(colours = rev(col.p), values = cols.scale)
  } else {
    p <- p + scale_color_manual(values = col.p) +
      guides(colour = guide_legend(override.aes = list(
        shape = 16,
        size = 5
      )))
  }
  return(p)
}

utils::globalVariables(c("x", "y"))

test_that("plotSpatial works", {
    data("xenium_bc_spe")


    expect_silent(plotSpatial(spe,
        group.by = "cell_type",
        pt.shape = ".",
        pt.size = 0.3, pt.alpha = 0.2
    ))
    expect_silent(plotSpatial(spe))

    expect_silent(plotSpatial(spe, reverseY = TRUE))
})

#' Plot density correlation between two cell types
#'
#' @param spe A SpatialExperiment object.
#' @param celltype1 Cell type 1 to compare.
#' @param celltype2 Cell type 2 to compare.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. Default is NULL for no facetting by ROI 
#' @param probs A numeric scalar. The threshold of proportion that used to
#' filter grids by density when ROIs have not been identified previously.
#' Ignored if 'roi' is present in the 'metadata' component of spe. Default to 0.85.
#' @param fit Character. Options are "spline" and "linear".
#' @param df Integer. Degrees of freedom of the spline fit.
#' Default to 3 (i.e., a cubic spline fit).
#' @param pt.shape shape of points.
#' @param pt.size size of points.
#' @param pt.alpha alpha of points between 0 and 1.
#' @param line.type shape of line.
#' @param line.width size of line.
#' @param line.alpha alpha of line between 0 and 1.
#'
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi, method = "walktrap")
#'
#' plotDensCor(spe, celltype1 = "Breast cancer", celltype2 = "Fibroblasts", roi = coi)
#'
plotDensCor <- function(spe, celltype1 = NULL, celltype2 = NULL,
                        roi = NULL, probs = 0.85,
                        fit = c("spline", "linear"), df = 3, 
                        pt.shape = 21, 
                        pt.size = 1.5, 
                        pt.alpha = 1,
                        line.type = 1,
                        line.width = 1,
                        line.alpha = 1) {
    if (!("grid_density" %in% names(spe@metadata))) {
        stop("Please run gridDensity before using this function.")
    }
    fit <- match.arg(fit)
    
    dens_dat <- as.data.frame(spe@metadata$grid_density)
    
    # clean names
    ct1 <- paste0("density_", janitor::make_clean_names(celltype1))
    ct2 <- paste0("density_", janitor::make_clean_names(celltype2))
    
    if(! ct1 %in% colnames(dens_dat))
        stop(paste0(ct1, " is not found in the data, or its density has not been computed."))
    if(! ct2 %in% colnames(dens_dat))
        stop(paste0(ct2, " is not found in the data, or its density has not been computed."))
    
    if (is.null(roi)) {
        dens_dat$density_coi_average <- (dens_dat[[ct1]]+dens_dat[[ct2]])/2
        kp <- dens_dat$density_coi_average >= quantile(dens_dat$density_coi_average, probs = probs)
        dens_dat_filter <- dens_dat[kp, ]
        rois <- data.frame(component=gl(1,sum(kp)), 
                           members=dens_dat_filter$node)
    } else {
        roi <- cleanName(roi)
        # roi <- gsub("_roi$", "", roi)
        # roi <- janitor::make_clean_names(roi)
        roi <- paste(c(roi,"roi"), collapse="_")
        if (is.null(spe@metadata[[roi]])) {
            stop(paste(
                roi, " is not found in metadata of spe. Please run
                findROI() first."
            ))
        }
        rois <- as.data.frame(spe@metadata[[roi]])
    }
    
    plotdf <- merge(rois, dens_dat,
                    by.x = "members", by.y = "node",
                    all.x = TRUE, sort = FALSE
    )
    plotdf <- plotdf[, c("component", c(ct1, ct2))]
    
    p <- ggplot2::ggplot(plotdf, ggplot2::aes(.data[[ct1]], .data[[ct2]])) +
        ggplot2::geom_point(shape = pt.shape,
                            size = pt.size,
                            alpha = pt.alpha,
                            fill = "royalblue") +
        geom_line(stat="smooth", method = "lm",
                  formula = switch(fit,
                                   spline = y ~ splines::ns(x, df = df),
                                   linear = y ~ x),
                  color = "red", se = FALSE,
                  linetype=line.type,
                  linewidth=line.width,
                  alpha=line.alpha) +
        theme_classic()
    if (!is.null(roi)) {
        p <- p + ggplot2::facet_wrap(~component,
                                    scales = "free",
                                    labeller = ggplot2::labeller(component = function(label) {
                                        paste0("ROI #", label)
                                    }))
    }
    return(p)
}
utils::globalVariables(c("component"))

test_that("plotDensCor works", {
    data("xenium_bc_spe")
    coi <- c("Breast cancer", "Fibroblasts")
    spe <- gridDensity(spe, coi = coi)
    spe <- findROI(spe, coi = coi, method = "walktrap")

    expect_silent(plotDensCor(spe,
        celltype1 = "Breast cancer",
        celltype2 = "Fibroblasts"
    ))
    expect_error(plotDensCor(spe,
        celltype1 = "xyz",
        celltype2 = "Fibroblasts"
    ))
    expect_silent(plotDensCor(spe,
        celltype1 = "Breast cancer",
        celltype2 = "Fibroblasts", roi = coi
    ))
    expect_silent(plotDensCor(spe,
        celltype1 = "Breast cancer",
        celltype2 = "Fibroblasts", fit = "linear"
    ))
    expect_silent(plotDensCor(spe,
        celltype1 = "Breast cancer",
        celltype2 = "Fibroblasts", df = 2
    ))
})

#' Find ROIs based on cell type-specific densities via graph-based method.
#'
#' @param spe A SpatialExperiment object.
#' @param coi A character vector of cell types of interest (COIs).
#' Default to all cell types.
#' @param probs A numeric scalar. The threshold of proportion that used to
#'  filter grids by density. Default to 0.85.
#' @param min.density A numeric value. The cut-off value used to filter grids
#' by density. Default is NULL and overwrites probs.
#' @param ngrid.min An integer. The minimum number of grids required for
#' defining a ROI. Default to 20.
#' @param method The community dectection method to be used, possible options
#' are greedy, walktrap, connected, hdbscan, eigen or dbscan. 
#' Default to greedy, can be abbreviated.
#' @param diag.nodes Logical. Set this to TRUE to allow diagonal grid points
#' to be adjacent nodes.
#' @param sequential.roi.name Logical. Set this to FALSE if you want the
#' original ROI name before
#' filtering are retained.
#' @param zoom.in Logical. For very large ROIs, whether to zoom in and try
#' to get more refined ROIs. 
#' @param zoom.in.size A numeric scaler. Smallest size of an ROI to be able
#' to zoom in. Default is 500L. 
#' @param ... Other parameters that passed to walktrap.community when method =
#' "walktrap".
#'
#' @return A SpatialExperiment object.
#' @export
#'
#' @importFrom dbscan hdbscan
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi, method = "walktrap")
#'
findROI <- function(spe, coi = NULL,
                    probs = 0.85,
                    min.density = NULL, 
                    ngrid.min = 20,
                    method = c("greedy", "walktrap", "connected", "hdbscan", "eigen", "dbscan"),
                    diag.nodes = FALSE,
                    sequential.roi.name = TRUE, 
                    zoom.in = FALSE, zoom.in.size = 500L,
                    ...) {

  grid_data <- spe@metadata$grid_density
  grid_type <- spe@metadata$grid_info$grid_type

  coi_clean <- `if`(is.null(coi),"overall",cleanName(coi))
  dens_cols <- paste("density", coi_clean, sep = "_")

  if (!all(dens_cols %in% colnames(grid_data))) {
    stop("Density of COI is not yet computed.")
  }

  method <- match.arg(method)

  grid_data$density_coi_average <- rowSums(as.matrix(grid_data[, which(colnames(grid_data) %in% dens_cols), drop = FALSE]))

  if (!is.null(min.density)) {
    message("Overwriting the probs argument. Grids are filtered by the min.density value. ")
    kp <- grid_data$density_coi_average >= min.density
  } else {
    kp <- grid_data$density_coi_average >= quantile(grid_data$density_coi_average, probs = probs)
  }
  grid_data_filter <- grid_data[kp, ]

  # clustering approach
  if (identical(method, "hdbscan")) {
    message(paste("For hdbscan, using minPts = ", ngrid.min, sep = ""))
    cl <- dbscan::hdbscan(grid_data_filter[, c("x_grid", "y_grid")], minPts = ngrid.min) #, ...)

    if(max(cl$cluster)==0) {
      stop("No clusters detected. Try a different method.")
    }
    
    cls <- setdiff(sort(unique(cl$cluster)), 0)
    g_community <- lapply(cls, function(cc) { grid_data_filter$node[cl$cluster == cc] })
  } else if (identical(method, "dbscan")) {
    message(paste("For dbscan, using minPts = ", ngrid.min, sep = ""))

    eps <- `if` (grid_type=="hex",
                2*diff(spe@metadata$grid_info$xlim)/spe@metadata$grid_info$xbins,
                sum(spe@metadata$grid_info$xstep, spe@metadata$grid_info$ystep))
    cl <- dbscan::dbscan(grid_data_filter[, c("x_grid", "y_grid")],
                         eps = eps,
                         weights = grid_data_filter[["density_coi_average"]],
                         minPts = ngrid.min)

    if(max(cl$cluster)==0) {
      stop("No clusters detected. Try a different method.")
    }

    cls <- setdiff(sort(unique(cl$cluster)), 0)
    g_community <- lapply(cls, function(cc) { grid_data_filter$node[cl$cluster == cc] })
  } else {
    # network approaches
    g <- make_graph_new(grid_data_filter$node_x,
                     grid_data_filter$node_y,
                     graph_type = {
                       if(grid_type=="hex") "hex"
                       else if (diag.nodes) "diag"
                       else "square"
                     })

    w <- grid_data_filter$density_coi_average
    igraph::E(g)$weight <- (w[igraph::tail_of(g,igraph::E(g))] +
                         w[igraph::head_of(g,igraph::E(g))])/2
    
    if (diag.nodes) {
      is_diag <- !is.na(igraph::E(g)$diag)
      igraph::E(g)$weight[is_diag] <- igraph::E(g)$weight[is_diag]/sqrt(2)
    }
    igraph::V(g)$name <- grid_data_filter$node
    
    g_community <- switch (method,
                           walktrap = igraph::cluster_walktrap(g, ...),
                           connected = igraph::groups(igraph::components(g)),
                           eigen = igraph::cluster_leading_eigen(g),
                           greedy = igraph::cluster_fast_greedy(g))
    if (zoom.in) {
      connected_groups <- igraph::groups(igraph::components(g))
      g_community <- lapply(names(connected_groups), function(ind) {
        this_grp <- connected_groups[[ind]]
        if (length(this_grp) > zoom.in.size) {
          subg <- igraph::induced_subgraph(g, this_grp)
          suppressWarnings(subg_community <- igraph::cluster_leading_eigen(subg))
          subg_community <- igraph::communities(subg_community)
          names(subg_community) <- paste(ind, names(subg_community), sep = "-")
        } else {
          subg_community <- list(this_grp)
          names(subg_community) <- ind
        }
        return(subg_community)
      })
      g_community <- do.call(c, g_community)
    }
  }
  
  component_list <- do.call(rbind, lapply(
    seq_along(g_community),
    function(ii) {
      data.frame(component = ii, members = g_community[[ii]])
    }
  ))

  component_list <- cbind(
    component_list,
    do.call(rbind, strsplit(component_list$members, split = "-"))
  )
  colnames(component_list)[3:4] <- c("x", "y")

  if (grid_type=="hex") {
    component_list$xcoord <- sort(unique00(spe@metadata$grid_density$x_grid))[
      as.numeric(component_list$x)*2 - as.numeric(component_list$y)%%2
    ]
    component_list$ycoord <- sort(unique00(spe@metadata$grid_density$y_grid))[
      as.numeric(component_list$y)
    ]
  } else {
    component_list$xcoord <- spe@metadata$grid_info$xcol[
      as.numeric(component_list$x)
    ]
    component_list$ycoord <- spe@metadata$grid_info$yrow[
      as.numeric(component_list$y)
    ]
  }
  component_list$component <- as.factor(component_list$component)

  # filtering ROIs based on ngrid.min
  filtered <- names(which(table(component_list$component) >= ngrid.min))
  rois_filtered <- component_list[component_list$component %in% filtered, ]
  
  if (sequential.roi.name) {
    rois_filtered$component <- factor(rank(rois_filtered$component),
                                      labels = seq_along(unique(rois_filtered$component))
    )
  }
  
  coi_clean_output <- paste(c(coi_clean,"roi"), collapse="_")
  # spe@metadata$coi <- coi
  # spe@metadata$ngrid.min <- ngrid.min
  rois_filtered <- S4Vectors::DataFrame(rois_filtered)
  S4Vectors::metadata(rois_filtered) <- list(densities = dens_cols)
  spe@metadata[[coi_clean_output]] <- rois_filtered

  return(spe)
}

# Faster graph maker
#
# @param node_x integer vector of node column
# @param node_y integer vector of node row. Must be same length as node_x
# @param grid_type options of 'square' for square lattice, 'diag' for square lattice 
# with diagonal, and 'hex' for hexagonal lattice.
# 
# Names of vertices are sequential, going row by row:
#     4| 13  14  15  16
#     3| 9   10  11  12
# row 2| 5   6   7   8
#     1| 1   2   3   4
#      ---------------
#        1   2   3   4
#             col 
make_graph_new <- function(node_x,node_y,graph_type = c("square","diag","hex")) {
  # hex & igraph both go row-by-row but spatstat goes col-by-col
  if(graph_type!="hex") {
    temp<-node_x
    node_x<-node_y
    node_y<-temp
  }
  range_x <- range(node_x)
  range_y <- range(node_y)
  nx <- diff(range_x)+1
  ny <- diff(range_y)+1
  g <- igraph::make_lattice(dimvector=c(nx,ny))
  # Add edges as needed
  switch(match.arg(graph_type),
         hex = {
           new_edges <- rep(seq_len(nx*(ny-1))[-(nx*seq_len(ny-1))],each = 2)
           if(range_y[1]%%2==1){
             new_edges <- new_edges + rep_len(c(rep.int(c(1,nx),nx-1),
                                                rep.int(c(0,nx+1),nx-1)),
                                              length(new_edges))
           } else{
             new_edges <- new_edges + rep_len(c(rep.int(c(0,nx+1),nx-1),
                                                rep.int(c(1,nx),nx-1)),
                                              length(new_edges))
           }
           g <- igraph::add_edges(g, new_edges)
         },
         diag = {
           new_edges <- rep(seq_len(nx*(ny-1))[-(nx*seq_len(ny-1))],each = 4)
           new_edges <- new_edges + c(0, nx+1, 1, nx)
           g <- igraph::add_edges(g, new_edges, attr = list(diag = TRUE))
         })
  ## Remove filtered vertices
  # This change the row/col into index compatible with vertices in g
  keep_vertices <- node_x - range_x[1] + 1 + (node_y - range_y[1])*nx
  g <- g - seq_len(length(g))[-keep_vertices]
  return(g)
}

test_that("spe2PB works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    coi <- "Breast cancer"
    spe <- findROI(spe, coi = coi)
    spe <- allocateCells(spe)

    y <- spe2PB(spe)

    expect_lt(ncol(y$counts), ncol(spe))

    expect_error(spe2PB(spe, group.id = "xyz"))
})

test_that("multiplication works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    spe <- findROI(spe, coi = c("Breast cancer", "Fibroblasts"))
    spe <- getContour(spe, coi = "Breast cancer")
    spe <- allocateCells(spe)

    expect_silent(plotCellCompo(spe, contour = "Breast cancer"))

    expect_silent(plotCellCompo(spe, contour = "Breast cancer", roi = c("Breast cancer", "Fibroblasts")))

    expect_error(plotCellCompo(spe, contour = "xyz"))

    expect_error(plotCellCompo(spe, contour = "Breast cancer", id = "xyz"))


    # expect_silent(plotCellCompo(spe,
    #     contour = "Breast cancer",
    #     level.name = "breast_cancer_contour"
    # ))
    # 
    # expect_error(plotCellCompo(spe,
    #     contour = "Breast cancer",
    #     level.name = "xyz_contour"
    # ))
})

test_that("findROI works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    coi <- c("Breast cancer", "Fibroblasts")
    spe1 <- findROI(spe, coi = coi, method = "walktrap")

    #expect_true(all(c("coi", "ngrid.min", "roi") %in% names(spe1@metadata)))
    expect_true(is(spe1@metadata$breast_cancer_fibroblasts_roi, "DFrame"))
    #expect_equal(spe1@metadata$coi, coi)

    spe2 <- findROI(spe,
        coi = coi, method = "walktrap",
        probs = 0.9,
        ngrid.min = 30
    )

    expect_lt(nrow(spe2@metadata$breast_cancer_fibroblasts_roi), nrow(spe1@metadata$breast_cancer_fibroblasts_roi))

    expect_error(findROI(spe, coi = coi, method = "xyz"))
    expect_silent(findROI(spe, coi = coi, method = "connected"))

    spe3 <- findROI(spe, coi = coi, diag.nodes = TRUE)

    expect_gt(nrow(spe3@metadata$breast_cancer_fibroblasts_roi), nrow(spe1@metadata$breast_cancer_fibroblasts_roi))
})

test_that("mergeROI works", {
    data("xenium_bc_spe")
    coi <- c("Breast cancer", "Fibroblasts")
    spe <- gridDensity(spe, coi = coi)
    spe <- findROI(spe, coi = coi, method = "walktrap")
    spe1 <- mergeROI(spe, roi = coi, list("1-2" = 1:2))

    expect_false("component_before_merge" %in% names(spe@metadata$breast_cancer_fibroblasts_roi))
    expect_true("component_before_merge" %in% names(spe1@metadata$breast_cancer_fibroblasts_roi))
    expect_false("1-2" %in% spe@metadata$breast_cancer_fibroblasts_roi$component)
    expect_true("1-2" %in% spe1@metadata$breast_cancer_fibroblasts_roi$component)
})

test_that("allocateCells works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    coi <- "Breast cancer"
    spe <- findROI(spe, coi = coi)

    spe1 <- allocateCells(spe)

    expect_gt(ncol(spe1@colData), ncol(spe@colData))

    expect_true("breast_cancer_roi" %in% names(spe1@colData))

    spe <- getContour(spe, coi)

    spe2 <- allocateCells(spe)

    expect_gt(ncol(spe2@colData), ncol(spe1@colData))

    expect_false("breast_cancer_contour" %in% names(spe1@colData))

    expect_true("breast_cancer_contour" %in% names(spe2@colData))
})

#' Construct a neighbour list from grid coordinates.
#'
#' @param spe A SpatialExperiment object.
#' @param n Integer. Search for neighbours within (...). Either the number of 
#' neighbors or radius
#' @param radius Numeric. Search for neighbours within the radius.
#' @param diagonal Whether to consider diagonal connection if using square grid
#' @param dist_func Options for distance-based weight. "idw" for inverse 
#' distance, "exp" for exponential decay, "binary" for constant weight, and 
#' "raw" for raw distance.
#' @param scale Numeric scaler for weight scaling.
#' @param dist_type Options of using euclidean or manhattan for distance calculation
#' @param standardisation Options for weight standardisation. "none" for 
#' nothing, and "row" for dividing weights by number of neighbours.
#' @param nbrs_name Name of the neighbour list to be stored. Default to be "grid".
#' @param cpu_threads Number of cpu threads for parallel computation.
#' @return A SpatialExperiment object with neighbour list stored in 
#' \code{spe@metadata$nbrs$grid[[nbrs_name]]}
#' 
#' @details
#' If n is used, distance is scaled to unit distance
#' @export
#' @examples
#' 
#' data("xenium_bc_spe")
#' spe <- gridDensity(spe)
#' spe <- findNbrsGrid(spe,n=3)
findNbrsGrid <- function(spe,
                         n = 1,
                         radius = NULL,
                         diagonal = FALSE,
                         dist_func = c("idw", "exp","binary","none"),
                         dist_type = c("euclidean","manhattan"),
                         standardisation = c("row","none"),
                         scale = 1,
                         nbrs_name = NULL,
                         cpu_threads = 6) {
  dist_func <- match.arg(dist_func)
  standardisation <- match.arg(standardisation)
  get_dist <- dist_func != "binary"
  if (!is.null(radius)) { # radius
    coords <- as.matrix(spe@metadata$grid_density[c("x_grid","y_grid")])
    # Fudge radius a bit due to floating point error with grid coordinates
    radius = radius*1.01
    nbrs <- BiocNeighbors::findNeighbors(X=coords,
                                         threshold = radius,
                                         get.distance = get_dist,
                                         num.threads = cpu_threads)
    if (get_dist) names(nbrs)[2] <- "weight"
  } else { # n
    coords <- as.matrix(spe@metadata$grid_density[c("node_x","node_y")])
    
    if (spe@metadata$grid_info$grid_type=="square") {
      if (diagonal) {
        nbrs_pattern = cbind(rep(seq.int(0,n),each=n),
                             rep.int(seq.int(1,n),n+1))
      } else {
        nbrs_pattern = cbind(rep.int(seq.int(0,n-1),times=seq.int(n,1)),
                             sequence(seq.int(n,1)))
      }
      nbrs_pattern = rbind(nbrs_pattern,
                           matrix(c(-nbrs_pattern[,2],nbrs_pattern[,1]),ncol=2))
      nbrs_pattern = rbind(nbrs_pattern,-nbrs_pattern)
      
      if(get_dist) {
        dist <- switch(match.arg(dist_type),
                       euclidean = sqrt(rowSums(nbrs_pattern**2)),
                       manhattan = `if`(diagonal,
                                        pmax(abs(nbrs_pattern[,1]),
                                             abs(nbrs_pattern[,2])),
                                        rowSums(abs(nbrs_pattern))))
      }
    } else {# hex
      # Convert coords to axial 
      coords[,1] = coords[,1] - (coords[,2] + bitwAnd(coords[,2],1))/2
      # Generate 1/3 of the nbrs then rotate 120 twices.
      nbrs_pattern <- matrix(c(rep(1:n,each=n+1),
                               rep.int((0:-n),times=n)),
                             ncol=2)
      nbrs_pattern <- rbind(
        nbrs_pattern,
        matrix(c(0-rowSums(nbrs_pattern),nbrs_pattern[,1]),ncol=2),
        matrix(c(nbrs_pattern[,2],0-rowSums(nbrs_pattern)),ncol=2)
      )
      
      if(get_dist) {
        dist <- switch(match.arg(dist_type),
                       euclidean = sqrt((rowSums(nbrs_pattern^2)+(0-rowSums(nbrs_pattern))^2)/2),
                       manhattan = (rowSums(abs(nbrs_pattern))+abs(rowSums(nbrs_pattern)))/2)
      }
    }
    nc = nrow(coords)
    np = nrow(nbrs_pattern)
    nbrs_all <- coords[rep(seq_len(nc),each=np),] + 
      nbrs_pattern[rep.int(seq_len(np),nc),]
    
    # Find which nbrs_all exist and which indices they should be.
    index = match(coord_hash(nbrs_all[,1],nbrs_all[,2]),
                  coord_hash(coords[,1],coords[,2]))
    keep = !is.na(index)
    f = factor(rep(seq_len(nc),each=np)[keep],seq_len(nc))
    index = index[keep]
    
    # dist 
    nbrs <- list(index = split(index,f))
    if (get_dist) {
      dist = rep.int(dist,nc)
      dist = dist[keep]
      nbrs$weight <- split(dist,f)
    }
  }
  # Transform weight based on dist_func.
  nbrs$weight <- switch(dist_func,
                        "idw" = lapply(nbrs$weight, function(i) scale/i),
                        "exp" = lapply(nbrs$weight, function(i) exp(-i/scale)),
                        "binary" = lapply(lengths(nbrs$index), function(i) rep.int(1,i)),
                        "none" = nbrs$weight)
  # standardization
  nbrs$weight <- switch(standardisation,
                        "row" = lapply(nbrs$weight, function(i) i/length(i)),
                        "none" = nbrs$weight)
  
  # Not really needed but for consistency
  names(nbrs$index) <- NULL
  names(nbrs$weight) <- NULL
  
  nbrs_name <- nbrs_name %||% "grid"
  spe@metadata$nbrs$grid[[nbrs_name]] <- nbrs
  return(spe)
}

#' Hash two 15-bytes signed integers into one 32-bytes integer.
#' @param a,b Integer vectors of same lengths. Can be negative.
#' @details
#' Should work for a,b in range (-2^14, 2^14-1) which is good enough for our 
#' purpose. 
#' 
#' Integer in R is 32-bytes but reserve 1 byte for NA
coord_hash <- function(a,b) {
  return(bitwOr(bitwShiftL(a+16384,16),b+16384))
}

#' Select region of interest from plot
#'
#' @param data A data.frame object.
#' @param x.col Column name of the x coordinates.
#' @param y.col Column name of the y coordinates.
#'
#' @return A data.frame object in the global environment.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe_b <- spe[, SummarizedExperiment::colData(spe)$cell_type == "B cells"]
#'
#' dat <- as.data.frame(SpatialExperiment::spatialCoords(spe_b))
#'
#' # selectRegion(dat, x.col = "x_centroid", y.col = "y_centroid")
#'
selectRegion <- function(data, x.col = "x", y.col = "y") {
    ui <- fluidPage(
        sidebarLayout(
            sidebarPanel(
                sliderInput("point_size", "Point Size:",
                    min = 1,
                    max = 10, value = 5
                ),
                selectInput("color_by", "Color Points by:",
                    choices = names(data),
                    selected = NULL
                ),
                actionButton("export_region", "Export Selected Points")
            ),
            mainPanel(
                style = "display: flex; flex-direction: column;
                align-items: center;",
                plotly::plotlyOutput("scatterplot", height = "60vh"),
                verbatimTextOutput("sel_points")
            )
        )
    )

    data <- as.data.frame(data)

    server <- function(input, output) {
        x <- reactiveVal(NULL)

        output$scatterplot <- renderPlotly({
            color_var <- input$color_by

            p <- plot_ly(data,
                x = ~ get(x.col), y = ~ get(y.col), type = "scatter",
                mode = "markers", marker = list(size = input$point_size)
            )

            if (!is.null(color_var)) {
                if (is.numeric(data[[color_var]])) {
                    p <- add_markers(p, color = ~ get(color_var))
                } else {
                    color_palette <- grDevices::colorRampPalette(col.spec)(
                        nlevels(factor(data[[color_var]])))
                    p <- add_markers(p,
                        color = ~ factor(data[[color_var]]),
                        colors = color_palette
                    )
                }
            }

            p <- layout(p,
                dragmode = "select",
                xaxis = list(title = "X"),
                yaxis = list(title = "Y"),
                showlegend = FALSE
            )
        })

        observeEvent(event_data("plotly_selected"), {
            sel_indices <- event_data("plotly_selected")$pointNumber
            sel_points <- data[sel_indices, ]
            x(sel_points)
        })

        output$sel_points <- renderPrint({
            x()
        })

        observeEvent(input$export_region, {
            sel_points <- x()
            if (!is.null(sel_points)) {
                sel_region <- as.data.frame(sel_points)
                pos <- 1
                assign("sel_region", sel_region, envir = as.environment(pos))
                # envir <- as.environment(sel_region)
                # assign("sel_region", sel_region, envir = envir)
                message("Selected region exported as 'sel_region'
                in the global environment.\n")
            }
        })
    }

    shinyApp(ui, server)
}

test_that("selectRegion works", {
    data("xenium_bc_spe")
    spe_b <- spe[, SummarizedExperiment::colData(spe)$cell_type == "B cells"]
    dat <- as.data.frame(SpatialExperiment::spatialCoords(spe_b))

    expect_silent(selectRegion(dat,
        x.col = "x_centroid",
        y.col = "y_centroid"
    ))
})

#' Manually merge ROIs
#'
#' @param spe A SpatialExperiment object.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. All cell types are chosen if NULL or 'overall'.
#' @param merge.list A (named) list of vectors of ROI ids to be merged.
#' Each vector in the list should be of length greater than or
#' equal to 2. If no name is specified, the merged ROI will be
#' named by concatenating ROIs being merged.
#' @param remove.ids Optional. A vector of ROI ids to be removed. 
#' @param id Character. The name of the column in \code{spe@metadata$roi}
#' that stores the ROIs to be merged. Default is "component".
#' @param rename Logical. If TRUE, names of merge.list are ignored.
#' ROIs will be given a new name. For the unmerged ROIs, their new
#' names are not necessarily the same as those before merging.
#'
#' @return A SpatialExperiment object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' spe <- findROI(spe, coi = coi, method = "walktrap")
#'
#' spe <- mergeROI(spe, roi = coi, list("1-2" = 1:2))
#'
mergeROI <- function(spe, 
                     roi = NULL,
                     merge.list = NULL, 
                     remove.ids = NULL, 
                     id = "component",
                     rename = FALSE) {
  roi_clean <- `if`(is.null(roi),"overall",cleanName(roi))
  roi_clean <- paste(c(roi_clean,"roi"), collapse="_")
  # check ROI exists
  if (is.null(spe@metadata[[roi_clean]])) {
    stop("ROI not yet computed!")
  }

  # check input
  to_be_merged <- spe@metadata[[roi_clean]][[id]]

  # remove ROIs first
  if (!is.null(remove.ids)) {
    remove.ids <- as.character(remove.ids)
    to_be_removed <- to_be_merged
    if (sum(!(remove.ids %in% to_be_removed)) > 0.5) {
      stop(paste0("Some ROIs are not present in spe@metadata$",roi_clean,"$component. Check remove.ids"))
    }
    message(paste("Removing ROIs: ", paste0(remove.ids, collapse = ", "), sep = ""))
    remove_ind <- as.character(spe@metadata[[roi_clean]][[id]]) %in% remove.ids
    spe@metadata[[roi_clean]] <- spe@metadata[[roi_clean]][!remove_ind, ]
    to_be_merged <- spe@metadata[[roi_clean]][[id]]
  }
  
  if (is.null(merge.list)) {
    message("No ROIs are merged. ")
    ROI_merged <- spe@metadata$roi[[id]]
  }

  if (any(!(unlist(merge.list) %in% to_be_merged))) {
    stop(paste0("Some ROIs are not present in spe@metadata$",roi_clean,"$component or have been removed.
         Check merge.list and remove.ids!"))
  }
  if (any(table(unlist(merge.list)) > 1L)) {
    stop("Each ROI can only be merged once. Check input list!")
  }
  list_sizes <- vapply(merge.list, function(rr) {
    length(unique(rr))
  }, numeric(length = 1L))
  if (any(list_sizes < 2L)) {
    stop("Each vector in the list must have at least 2 unique ROI IDs to merge!")
  }

  # give names to the list if not input
  if (length(names(merge.list)) < length(merge.list)) {
    names(merge.list) <- vapply(merge.list, function(rr) {
      paste0(sort(rr), collapse = "-")
    }, character(length = 1L))
  }

  # keep a copy of the original ROI list
  if (id == "component") {
    ROI_merged <-
      spe@metadata[[roi_clean]][["component_before_merge"]] <-
      spe@metadata[[roi_clean]]$component
  } else {
    ROI_merged <- spe@metadata[[roi_clean]][[id]]
  }
  
  # merge ROIs
  ROI_merged <- as.character(ROI_merged)
  for (mm in names(merge.list)) {
    ROI_merged[ROI_merged %in% as.character(merge.list[[mm]])] <- mm
  }
  if (!rename) {
    # re-order by merged ROI then individual ROIs
    roi_levels <- unique(ROI_merged)
    roi_levels <- c(
      sort(names(merge.list)),
      as.character(sort(
        as.numeric(roi_levels[!(roi_levels %in% names(merge.list))])
      ))
    )
    ROI_merged <- factor(ROI_merged, levels = roi_levels)
  } else {
    ROI_merged <- factor(rank(ROI_merged),
                         labels = seq(length(unique(ROI_merged)))
                         )
  }
  spe@metadata[[roi_clean]]$component <- ROI_merged
  return(spe)
}

#' Perform kernel density estimation on SpatialExperiment
#'
#' @param xy A numeric matrix of spatial coordinates.
#' @param kernel The smoothing kernel. Options are gaussian, epanechnikov,
#' quartic or disc.
#' @param bandwidth The smoothing bandwidth. By default performing automatic
#' bandwidth selection using cross-validation using function
#' spatstat.explore::bw.diggle.
#' @param weights Optional weights to be attached to the points.
#' @param ngrid.x Number of grids in the x-direction.
#' @param xlim The range of the x-coordinates of the image.
#' @param ylim The range of the y-coordinates of the image.
#' @param diggle Logical. If TRUE, use the Jones-Diggle improved edge
#' correction. See spatstat.explore::density.ppp() for details.
#' @param gridInfo Logical. If TRUE, then the grid information is also returned.
#'
#' @return Output from spatstat.explore::density.ppp.
#'
#'
computeDensity <- function(xy,
                           kernel = c("gaussian", "epanechnikov", "quartic", "disc"),
                           bandwidth = NULL, weights = NULL,
                           ngrid.x = NULL,
                           xlim = NULL, ylim = NULL, diggle = FALSE,
                           gridInfo=FALSE) {
  kernel <- match.arg(kernel)
  
  y <- ppp(xy[, 1], xy[, 2], xlim, ylim)
  
  # Using ngrid instead of grid.length.x for backward consistency
  grid.length.x <- diff(xlim)/ngrid.x
  ngrid.x <- round(ngrid.x)
  ngrid.y <- round(diff(ylim)/grid.length.x)
  
  density_est <- density.ppp(y,
                             sigma = bandwidth,
                             kernel = kernel, weights = weights,
                             dimyx = c(ngrid.y, ngrid.x),
                             diggle = diggle
  )
  grid_density <- density_est$v * density_est$xstep * density_est$ystep
  # Reshape data from wide to long
  rownames(grid_density) <- density_est$yrow
  colnames(grid_density) <- density_est$xcol
  grid_density <- as.data.frame(grid_density) |>
    rownames2col("y_grid")
  
  reshaped_dat <- stats::reshape(grid_density,
                                 direction = "long",
                                 varying = names(grid_density)[(names(grid_density) != "y_grid")],
                                 v.names = "density",
                                 timevar = "x_grid",
                                 times = names(grid_density)[(names(grid_density) != "y_grid")]
  )
  
  reshaped_dat <- reshaped_dat[, names(reshaped_dat) != "id"]
  rownames(reshaped_dat) <- NULL
  grid_density <- as.data.frame(vapply(
    reshaped_dat, as.numeric,
    numeric(nrow(reshaped_dat))
  ))
  grid_density <- grid_density[order(
    grid_density$x_grid,
    grid_density$y_grid
  ), ]
  
  if (gridInfo) {
    ngrid.x <- density_est$dim[2]
    ngrid.y <- density_est$dim[1]
    grid_density = grid_density[, c(2, 1)]
    # horizontal ind
    grid_density$node_x <- rep(seq_len(ngrid.x),each = ngrid.y)
    # vertical ind
    grid_density$node_y <- rep(seq_len(ngrid.y),ngrid.x)
    grid_density$node <- paste(grid_density$node_x,
                               grid_density$node_y,
                               sep = "-")
    return(list(
      grid_density = S4Vectors::DataFrame(grid_density),
      grid_info = list(
        dims = c(ngrid.x, ngrid.y),
        xlim = xlim,
        ylim = ylim,
        xcol = density_est$xcol,
        yrow = density_est$yrow,
        xstep = density_est$xstep,
        ystep = density_est$ystep,
        bandwidth = bandwidth,
        grid_type = "square"
      )
    ))
  } else {
    # Multiply by area
    return(grid_density$density)
  }
}

#' Perform log normalization for counts
#'
#' @param spe A SpatialExperiment object.
#' @param transformation Choice of transformation. "Log" for log1p
#' @param scale.factor Factor to multiply the count of each cell by. A single 
#' value or a numeric vector equal to number of cells
#' @param assay Name of assay in spe to perform the transformation on
#' @param name Name of the transformed assay
#' @return A SpatialExperiment object 
#' @export
#' @examples
#' data("xenium_bc_spe")
#' spe <- normalizeAssay(spe)
normalizeAssay <- function(spe,
                           transformation = c("log"),
                           scale.factor = 1e6,
                           assay = "counts",
                           name = "logcounts") {
  assay <- as.matrix(SummarizedExperiment::assay(spe,assay))
  library_size <- colSums(assay)/scale.factor
  assay <- t(t(assay)/library_size)
  switch(match.arg(transformation),
         log = {
           assay <- log1p(assay)
         })
  SummarizedExperiment::assay(spe,name) <- assay
  return(spe)
}

#' Cluster cells in spe using graph methods.
#'
#' @param spe A SpatialExperiment object.
#' @param nbrs_name Name of neighbour list for clustering. If NULL, will use 
#' the newest one in spe@metadata$nbrs$cell or create one if none are available.
#' @param method Clustering methods. Options are leiden and louvain.
#' @param resolution Higher resolution for more clusters and lower for fewer 
#' clusters. See \link[igraph]{cluster_leiden} and \link[igraph]{cluster_louvain} 
#' @param cluster_name Name to store the clusters in spe's 
#' \link[SummarizedExperiment]{colData}
#' @param seed seed for clustering
#' @param ... Other clustering arguments for \link[igraph]{cluster_leiden} or 
#' \link[igraph]{cluster_louvain} 
#' @return A spe with the clusters stored in \link[SingleCellExperiment]{reducedDims}.
#' @details
#' Cluster cells with igraph using SNN calculated by \link[scider]{findNbrsSNN}.
#' Any neighbour list in spe@metadata$nbrs$cell can also be used
#' @return A SpatialExperiment object
#' @export
#' @examples
#'
#' data("xenium_bc_spe")
#' spe <- normalizeAssay(spe)
#' spe <- runPCA(spe)
#' spe <- findNbrsSNN(spe,dimred="PCA")
#' spe <- getClusters(spe, resolution=0.5)

getClusters <- function(spe,
                        nbrs_name = NULL,
                        method = c("leiden", "louvain"),
                        resolution = 1,
                        cluster_name = "cluster",
                        seed = 1,
                        ...) {
  set.seed(seed)
  if (is.null(nbrs_name)){
    if (is.null(spe@metadata$nbrs$cell[[1]])) {
      message("No neighbour list found. Calculating snn.")
      spe <- findNbrsSNN(spe)
    }
    g <- spe@metadata$nbrs$cell[[length(spe@metadata$nbrs$cell)]]
  } else {
    g <- spe@metadata$nbrs$cell[[nbrs_name]]
  }
  g <- .nbrs2igraph(g)
  
  method <- match.arg(method)
  method.args <- list(...)
  method.args$resolution = resolution
  method.args$graph <- g
  if (method=="leiden" && is.null(method.args$objective_function)) {
    method.args$objective_function <- "modularity"
  }
  
  cluster <- do.call(switch(method,
                           leiden = igraph::cluster_leiden,
                           louvain = igraph::cluster_louvain),
                    method.args)
  
  # Rename clusters based on their sizes high to low
  count <- tabulate(cluster$membership)
  map <- order(order(count,decreasing=TRUE))
  spe[[cluster_name]] <- factor(map[cluster$membership])
  return(spe)
}


# Convert nbrs (in spe@metadata$nbrs) into igraph's graph 
# nbrs should be a list containing index & weight
.nbrs2igraph <- function(nbrs, directed=FALSE){
  interleaves <- as.vector(
    rbind(rep.int(seq_along(nbrs$index),times=lengths(nbrs$index)),
          unlist(nbrs$index)))
  g <- igraph::make_graph(interleaves,directed=directed)
  igraph::E(g)$weight = unlist(nbrs$weight)

  g <- igraph::simplify(g,edge.attr.comb = "first")
  return(g)
}

#' UMAP using uwot. Parameters are set to be similar to Seurat's
#'
#' @param spe A SpatialExperiment object.
#' @param n_neighbors,n_components,metric,min_dist See \link[uwot]{umap}
#' @param assay Name of assay for UMAP. Incompatible with dimred.
#' @param dimred Name of the dimensionality reduction (e.g. PCA) for UMAP. Incompatible with assay
#' @param n_dimred Integer scalar or vector specifying the dimensions to use if dimred is specified.
#' @param name Name to store the UMAP in the spe's \link[SingleCellExperiment]{reducedDims}.
#' @param ... Other parameters to be passed to \link[uwot]{umap}.
#' @return A SpatialExperiment with the UMAP stored in \link[SingleCellExperiment]{reducedDims}.
#' @export
#' @details
#' By default, runUMAP uses PCA (from \link[scider]{runPCA}). If that's 
#' unavailable, it falls back to logcounts, then counts assay. 
#' @examples
#'
#' data("xenium_bc_spe")
#' spe <- runPCA(spe)
#' spe <- runUMAP(spe,dimred="PCA",n_dimred=10)
runUMAP <- function(spe,
                    n_neighbors=30,
                    n_components=2,
                    metric="cosine",
                    min_dist=0.3,
                    assay=NULL,
                    dimred="PCA",
                    n_dimred=NULL,
                    name="UMAP",
                    ...) {
    # Getting default data for UMAP  
    if (missing(assay) && missing(dimred) && 
        (!dimred %in% SingleCellExperiment::reducedDimNames(spe))) {
        dimred=NULL
        if (is.null(spe@assays@data[["logcounts"]])) {
          assay <- "counts"
        } else {
          assay <- "logcounts"
        }
        warning(paste("PCA not found. Switching to",assay,"assay instead."))
    }
    
    if (!is.null(dimred)) {
        mat <- SingleCellExperiment::reducedDim(spe,dimred)
        if (!is.null(n_dimred)) {
            if(length(n_dimred)==1L) {
                n_dimred <- seq_len(n_dimred)
            }
            mat <- mat[,n_dimred,drop=FALSE]
        }
    } else {
        mat <- spe@assays@data[[assay]]
        mat <- t(as.matrix(mat))
    }
    
    out <- uwot::umap(X=mat,
                      n_neighbors = n_neighbors,
                      n_components = n_components,
                      metric=metric,
                      min_dist=min_dist,
                      ...)
    colnames(out) <- paste0("UMAP", seq_len(ncol(out)))
    
    SingleCellExperiment::reducedDim(spe,name) <- out
    return(spe)
}

removeROI <- function (spe, remove.list, id = "component", rename = FALSE) 
{
  if (is.null(spe@metadata$roi)) {
    stop("ROI not yet computed!")
  }
  if (id == "component") {
    to_be_removed <- unique(spe@metadata$roi$component)
  }
  else {
    to_be_removed <- spe@metadata$roi[[id]]
  }
  if (any(!(unlist(remove.list) %in% to_be_removed))) {
    stop("Some ROIs are not present in spe@metadata$roi$component.\n
         Check remove.list")
  }
  if (any(table(unlist(remove.list)) > 1L)) {
    remove.list <- unique(remove.list)
  }
  
  remove_ind <- as.character(spe@metadata$roi$component) %in% as.character(remove.list)
  spe@metadata$roi <- spe@metadata$roi[!remove_ind, ]
  
  if (!rename) {
    
    roi_levels <- levels(spe@metadata$roi$component)
    roi_levels <- setdiff(roi_levels, as.character(remove.list))
    spe@metadata$roi$component <- factor(spe@metadata$roi$component, levels = roi_levels)
    
  }
  else {
    
    spe@metadata$roi$component <- factor(rank(spe@metadata$roi$component), 
                                         labels = seq(length(unique(spe@metadata$roi$component))))
    
  }
  
  return(spe)
  
}

#' Plot background image of spe
#' @param spe A SpatialExperiment object.
#' @param image Logical. Whether to plot image (if present).
#' @param image_id,sample_id sample and image identifiers for scaling factor. 
#' See \link[SpatialExperiment]{scaleFactors} for default behavior.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param crop Whether to crop the plot to the spots.
#' @param image.alpha alpha of points between 0 and 1.
#' @return a ggplot object if there is a valid image, else NULL.
#' @export
plotImage <- function(spe,
                      image = TRUE,
                      image_id = NULL,
                      sample_id = NULL,
                      reverseY = NULL,
                      crop=TRUE,
                      image.alpha = 1) {
  img <- SpatialExperiment::imgRaster(spe,sample_id,image_id)
  reverseY <- reverseY %||% !is.null(img)
  # No image
  if(is.null(img) || !image || image.alpha==0) {
    if (!(missing(image_id)&&missing(sample_id))) message("image not found")
    p <- ggplot2::ggplot()+ggplot2::coord_fixed()
    if (reverseY) p <- p + ggplot2::scale_y_reverse()
    return(p)
  }
  
  # Scaling image
  scale <- SpatialExperiment::scaleFactors(spe,sample_id,image_id)
  xlim <- c(0,ncol(img)/scale)
  ylim <- c(0,nrow(img)/scale)
  p <- ggplot2::ggplot() 
  # Image alpha
  if (image.alpha!=1) {
    img = grDevices::as.raster(matrix(ggplot2::alpha(img,image.alpha),nrow=nrow(img),byrow=TRUE))
  }
  # ReverseY
  if (reverseY) {
    if (utils::packageVersion("ggplot2") >= package_version("4.0.0")) {
      p <- p + ggplot2::annotation_custom(grid::rasterGrob(img),
                                          xmin = xlim[1], xmax = xlim[2],
                                          ymin = ylim[1], ymax = ylim[2]) 
    } else {
      p <- p + ggplot2::annotation_custom(grid::rasterGrob(img),
                                          xmin = xlim[1], xmax = xlim[2],
                                          ymin = -ylim[1], ymax = -ylim[2])
    }
    p <- p + ggplot2::scale_y_reverse()
  } else {
    p <- p + 
      ggplot2::annotation_custom(grid::rasterGrob(img),
                                 xmin = xlim[1], xmax = xlim[2],
                                 ymin = ylim[1], ymax = ylim[2])
  }
  
  # Crop to points
  if (crop) {
    xlim <- range(SpatialExperiment::spatialCoords(spe)[,1])
    ylim<-range(SpatialExperiment::spatialCoords(spe)[,2])
    if (reverseY) ylim = rev(ylim)
  }
  p <- p + ggplot2::coord_fixed(xlim=xlim, ylim=ylim)
  return(p)
}

#' Update the x,y limits of a plot
#' @param p A ggplot() object
#' @param x,y Vectors of new x and y limits.
#' @return a ggplot object
update_bound <- function(p,x=NULL,y=NULL) {
  # Whether reverseY has been applied to p
  reverseY <- any(sapply(p$scales$scales, function(s) {
    inherits(s, "ScaleContinuousPosition") &&
      "y" %in% s$aesthetics &&
      "reverse" %in% s$trans$name
  }))
  p$coordinates$limits$x = range(p$coordinates$limits$x,x)
  p$coordinates$limits$y = range(p$coordinates$limits$y,y)
  
  if (reverseY) p$coordinates$limits$y <- rev(p$coordinates$limits$y)
  return(p)
}

#' Plotting LISA (e.g. moran)
#' @param spe A SpatialExperiment object.
#' @param lisa Output from localMoran
#' @param overlay Option of grid or point. Depend on whether 
#' \link[scider]{localMoran} is calculated at grid or point.
#' @param type Option of cluster or logpvalue for plotting lisa's cluster or 
#' p-value, respectively.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Parameters pass to \link[scider]{plotGrid} or 
#' \link[scider]{plotSpatial}, depending on overlay.
#' 
#' @return a ggplot object
#' @examples 
#' data("xenium_bc_spe")
#' spe <- gridDensity(spe, coi = "Breast cancer")
#' dat <- spe@metadata$grid_density$density_breast_cancer
#' spe <- findNbrsGrid(spe)
#' res <- localMoran(spe,data1=dat, at = "grid")
#' plotLISA(spe,lisa = res)
#' 
#' @export
plotLISA <- function(spe, lisa,
                     overlay=c("grid","point"),
                     type=c("cluster","logpvalue"),
                     reverseY=NULL,
                     ...) {
  # Checking if overlay is valid
  n_point <- nrow(spe@colData)
  n_grid <- nrow(spe@metadata$grid_density) %||% -1
  if (missing(overlay)) {
    if (length(lisa$lisa)==n_point) overlay<-"point"
    else if (length(lisa$lisa)==n_grid) overlay<-"grid"
    else stop("Length of lisa must be equal to either number of cells or grid points")
  } else {
    overlay <- match.arg(overlay)
    if (overlay=="grid" && length(lisa$lisa)!=n_grid && 
        length(lisa$lisa)==n_point) {
      overlay <- "point"
      message("Length of lisa not equal to number of grid points. Switching
              overlay to 'point'")
    } else if (overlay=="point" && length(lisa$lisa)!=n_point && 
               length(lisa$lisa)==n_grid) {
      overlay <- "grid"
      message("Length of lisa not equal to number of cells Switching
              overlay to 'grid'")
    } else {
      stop("Length of lisa must be equal to either number of cells or grid points")
    }
  }

  keep <- lisa$cluster!="Undefined"
  
  # Getting relevant data from lisa 
  type <- match.arg(type)
  if (type=="cluster") {
    dat <- lisa$cluster[keep]
    cols <- col.lisa[sort(unique(dat))]
    cols.scale <- NULL
  } else {
    dat <- log(lisa$p.value[keep])
    cols <- col.pval
    cols.scale <- c(0,1-log(0.05)/min(dat),1)
  }
  
  # Plot
  if (overlay=="grid") {
    spe@metadata$grid_density <- spe@metadata$grid_density[keep,]
    spe@metadata$grid_density$dat <- dat
    p <- plotGrid(spe,group.by="dat",cols=cols,label=type,
                  cols.scale=cols.scale, reverseY=reverseY, ...)
  } else {
    spe <- spe[,keep]
    spe$dat <- dat
    p <- plotSpatial(spe,group.by="dat", cols=cols, label=type,
                     cols.scale=cols.scale, reverseY=reverseY, ...)
    p <- update_bound(p,
                      x=SpatialExperiment::spatialCoords(spe)[,1],
                      y=SpatialExperiment::spatialCoords(spe)[,2])
  }
  return(p)
}

#' Convert x,y nodes to sf polygons
#' 
#' @param spe A SpatialExperiment object with grid density calculated
#' @param x vector of x nodes of the polygons
#' @param y vector of y nodes of the polygons
#' @param reverseY Reverse y coordinates. Can be numeric to specify the value to 
#' subtract y coordinates from (reverseY - y coords).
#' 
#' @return List of sf polygons
#' 
#' @details
#' Default is to generate sf polygons for all grid.
#' For plotting with geom_sf, use sf::st_as_sfc(grid2sf2(spe)) to convert list 
#' into Geometry Set.
grid2sf <- function(spe,
                    x=spe@metadata$grid_density$node_x,
                    y=spe@metadata$grid_density$node_y,
                    reverseY = FALSE) {
  if (is.null(spe@metadata$grid_info)) stop("Missing grid. Compute Density first")
  if (is.null(x) || is.null(y)) stop("Missing x or y")
  if (length(x) != length(x)) stop("x, y must be of equal length")
  
  x <- as.numeric(x)
  y <- as.numeric(y)
  
  nx <- spe@metadata$grid_info$dims[1]
  ny <- spe@metadata$grid_info$dims[2]
  
  `if`(spe@metadata$grid_info$grid_type=="hex",
       {# hexagon
         dx <- spe@metadata$grid_info$xstep/2
         dy <- spe@metadata$grid_info$ystep/3
         offset <- c(spe@metadata$grid_info$xlim[1] - dx,
                     spe@metadata$grid_info$ylim[1] - dy * 2)
         
         xc <- offset[1] + (0:(nx*2+1)) * dx
         yc <- offset[2] + (0:(ny*3+1)) * dy
         is_right <- rep_len(c(0,1),ny)
         
         make_poly <- function(col,row) {
           x_index <- 2*col+c(0,1,1,0,-1,-1,0)+is_right[row]
           y_index <- 3*row+c(2,1,-1,-2,-1,1,2)
           sf::st_polygon(list(matrix(c(xc[x_index],yc[y_index]),7)))
         }
       },
       {# square
         cellsize <- c(spe@metadata$grid_info$xstep,spe@metadata$grid_info$ystep)
         offset <- c(spe@metadata$grid_info$xlim[1],spe@metadata$grid_info$ylim[1])
         
         xc <- offset[1] + (0:nx) * cellsize[1]
         yc <- offset[2] + (0:ny) * cellsize[2]
         
         make_poly <- function(col,row) {
           x_index <- col + c(0,1,1,0,0)
           y_index <- row + c(0,0,1,1,0)
           sf::st_polygon(list(matrix(c(xc[x_index],yc[y_index]), 5)))
         }
       }
  )
  if (is.numeric(reverseY)) {
    yc <- reverseY - yc
  } else if (reverseY == TRUE) {
    # yc <- sum(range(yc)) - yc
    yc <- range(yc)[2] - yc
  }
  
  return(lapply(seq_along(x), function(ii) {
    make_poly(x[ii],y[ii])
  }))
}

#' Convert x,y nodes to data.frame of polygons
#' 
#' @param spe A SpatialExperiment object with grid density calculated
#' @param x vector of x nodes of the polygons
#' @param y vector of y nodes of the polygons
#' @param reverseY Reverse y coordinates. Can be numeric to specify the value to 
#' subtract y coordinates from (reverseY - y coords).
#' @param ... other elements to be stored as columns of the data.frame. Each one
#' must be a vector same length as x.
#' 
#' @return data.frame with X, Y, and L2. Points with the same L2 belong to the 
#' same polygons
#' 
#' @details
#' Basically grid2sf() but returns a data.frame for plotting with geom_polygon(),
#' which allows for scale_*_transform(), unlike geom_sf().
#' 
#' Column names are kept similar to sf::st_coordinates
grid2df <- function(spe,
                    x=spe@metadata$grid_density$node_x,
                    y=spe@metadata$grid_density$node_y,
                    reverseY = FALSE,
                    ...) {
  if (is.null(spe@metadata$grid_info)) stop("Missing grid. Compute Density first")
  if (is.null(x) || is.null(y)) stop("Missing x or y")
  if (length(x) != length(x)) stop("x, y must be of equal length")
  
  x <- as.numeric(x)
  y <- as.numeric(y)
  
  nx <- spe@metadata$grid_info$dims[1]
  ny <- spe@metadata$grid_info$dims[2]
  
  if (spe@metadata$grid_info$grid_type=="hex") {
    dx <- spe@metadata$grid_info$xstep/2
    dy <- spe@metadata$grid_info$ystep/3
    offset <- c(spe@metadata$grid_info$xlim[1] - dx,
                spe@metadata$grid_info$ylim[1] - dy * 2)
    
    xc <- offset[1] + (0:(nx*2+1)) * dx
    yc <- offset[2] + (0:(ny*3+1)) * dy
    
    n_vertices = 7
    x_pattern = c(0,1,1,0,-1,-1,0)
    y_pattern = c(2,1,-1,-2,-1,1,2)
    
    x <- 2*x + !y%%2
    y <- 3*y
  } else { # square
    dx <- c(spe@metadata$grid_info$xstep,spe@metadata$grid_info$ystep)
    offset <- c(spe@metadata$grid_info$xlim[1],spe@metadata$grid_info$ylim[1])
    
    xc <- offset[1] + (0:nx) * dx[1]
    yc <- offset[2] + (0:ny) * dx[2]
    
    n_vertices = 5
    x_pattern = c(0,1,1,0,0)
    y_pattern = c(0,0,1,1,0)
  }
  x <- xc[rep(x, each = n_vertices) + x_pattern]
  y <- yc[rep(y, each = n_vertices) + y_pattern]
  L2 <- rep(seq_len(length(x)/n_vertices),each=n_vertices)
  res <- data.frame(X=x,Y=y,L2=L2)
  
  lst <- lapply(list(...),function(ii) rep(ii,each=n_vertices))
  if (length(lst)) res <- cbind(res,lst)
  return(res)
}

#' Fast PCA using irlba.
#'
#' @param spe A SpatialExperiment object.
#' @param n_pcs Number of principal components to calculate
#' @param assay Name of assay used for PCA. See details for defaults.
#' @param centre Logical. Whether to centre the assay before PCA. 
#' @param scale Logical. Whether to scale the variance to 1 before PCA. 
#' @param name Name to store the PCA in the spe's \link[SingleCellExperiment]{reducedDims}
#' @param ... Other parameters to be passed to \link[irlba]{irlba}.
#' @return A SpatialExperiment with the PCA stored in \link[SingleCellExperiment]{reducedDims}.
#' @export
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- runPCA(spe)
#' @details
#' By default, runPCA uses logcounts assay (from \link[scider]{normalizeAssay}). 
#' If that's unavailable, it falls back to counts assay
#' 
#' @export
runPCA <- function(spe,
                   n_pcs=50,
                   assay="logcounts",
                   centre = TRUE,
                   scale = TRUE,
                   name="PCA",
                   ...) {
  if (missing(assay) && is.null(spe@assays@data[[assay]])) {
    assay <- "counts"
    message("Default assay logcounts not found. Switching to counts assay instead.")
  }
  mat <- spe@assays@data[[assay]]
  mat <- as.matrix(mat)
  n_cells = ncol(mat)
  sds = sqrt(rowSums((mat - rowMeans(mat))^2)/(n_cells-1))
  
  if (scale) {
    keep = sds!=0
    if (!all(keep)) {
      message(paste(c("Genes with 0 variance are excluded:",
                      rownames(mat)[!keep]),collapse=" "))
      }
    mat = mat[keep,]
    mat = mat/(sds[keep])
    sds <- rep.int(1,nrow(mat))
  }
  mat = t(mat)
  out <- irlba::irlba(mat, nv=n_pcs,
                      center=centre,
                      ...)
  pcs <- sweep(out$u, 2, out$d, "*")
  
  row.names(pcs) <- row.names(mat)
  colnames(pcs) <- paste0("PC", seq_len(ncol(pcs)))
  attr(pcs, "varExplained") <- out$d^2/(n_cells - 1)
  attr(pcs, "percentVar") <- attr(pcs, "varExplained")/sum(sds**2)*100
  SingleCellExperiment::reducedDim(spe,name) <- pcs
  return(spe)
}

#' Plot reduced dimensions.
#'
#' plotDR is the main function for plotting reduced dimension. Others are
#' wrapper functions for convenience.
#' @param spe A SpatialExperiment object.
#' @param dimred Name of the reduced dimension in \link[SingleCellExperiment]{reducedDims} 
#' @param dims Numeric vector length 2 for the dimensions to be plotted. Default to first two dimensions
#' @param group.by values to group points by. Must be in colData of spe. 
#' If NULL, will try with 'cols' if available.
#' @param cols Colour palette. Can be a vector of colours or a function 
#' that accepts an integer n and return n colours.
#' @param feature Feature to group polygons by. Must be in rownames(spe).
#' @param assay Name of assay to use for plotting feature.
#' @param pt.shape shape of points.

#' @param pt.size size of points.
#' @param pt.alpha alpha of points between 0 and 1.
#' @param label label for the legend
#' @param label.x label for the x-axis
#' @param label.y label for the y-axis
#' @param cols.scale vector of position for color if colors should not be 
#' evenly positioned. See \link[ggplot2]{scale_color_gradientn}. Only applicable for continuous values.
#' @param ... Additional arguments pass to plotDR
#' @return A ggplot object.
#' 
#' @rdname plotDR
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#' spe = runUMAP(spe)
#' plotDR(spe, group.by = "cell_type")
#'
plotDR <- function(spe, dimred = NULL,
                   dims = c(1,2),
                   group.by = NULL,
                   feature = NULL,
                   assay = "counts",
                   cols = NULL,
                   pt.shape = 16,
                   pt.size = 1,
                   pt.alpha = 0.6,
                   label = NULL,
                   label.x = NULL,
                   label.y = NULL,
                   cols.scale=NULL) {
  if(!length(SingleCellExperiment::reducedDim(spe))) {
    stop("No dimensionality reduction found.")
  }
  dimred <- dimred %||% SingleCellExperiment::reducedDimNames(spe)[[1]]
  
  toplot <- as.data.frame(SingleCellExperiment::reducedDim(spe,dimred)[,dims])
  colnames(toplot) <- c("x", "y")
  cdata <- as.data.frame(SummarizedExperiment::colData(spe))
  toplot <- cbind(toplot, cdata)
  
  group <- col.p <- NULL
  # Groups. Order is: colData -> assays -> cols
  if (!is.null(group.by) && group.by %in% colnames(toplot)) {
    group <- toplot[[group.by]]
    if (is.null(label)) label <- group.by
  } else if (!is.null(feature) && feature %in% rownames(spe)) {
    group <- SummarizedExperiment::assay(spe,assay)[feature,]
    if (is.null(label)) label <- feature
  } else if (!is.null(cols) && !is.function(cols)) {
    group <- factor(rep_len(cols,nrow(toplot)),levels=unique(cols))
    col.p <- rep_len(unique(cols), length(unique(cols)))
  }
  isContinuous <- is.numeric(group)
  
  # Colours
  if (!is.null(group) && is.null(col.p)) {
    n_colour <- length(unique(group))
    if (is.null(cols)) { # Default palette
      col.p <- `if`(isContinuous, col.spec, selectColor(n_colour))
    } else if (is.function(cols)) { # cols is function
      col.p <- cols(n_colour)
    } else { # cols is vector
      col.p <- `if`(isContinuous, cols, rep_len(cols,n_colour))
    }
  }

  #labels
  label.x <- label.x %||% paste(dimred,dims[1])
  label.y <- label.y %||% paste(dimred,dims[2])
  
  # !!group prevents name-clashing in case toplot also has a 'group' column
  p <- ggplot2::ggplot(toplot,aes(x=x, y=y, color=!!group)) +
    ggplot2::geom_point(
      shape = pt.shape,
      size = pt.size,
      alpha = pt.alpha,
    ) +
    labs(x = label.x, y = label.y, color = label) +
    theme_classic()
  if (isContinuous) {
    p <- p + scale_color_gradientn(colours = rev(col.p), values = cols.scale)
  } else {
    p <- p + scale_color_manual(values = col.p) +
      guides(colour = guide_legend(override.aes = list(
        shape = 16,
        size = 5
      )))
  }
  return(p)
}

#' @rdname plotDR
#' @aliases plotUMAP
#' 
#' @export
plotUMAP <- function (spe,dimred="UMAP",...) {
  plotDR(spe,dimred,...)
}

#' @rdname plotDR
#' @aliases plotPCA
#' 
#' @export
plotPCA <- function (spe,dimred="PCA",...) {
  args <- list(...)
  args$dims = args$dims %||% c(1,2)
  dims = attr(SingleCellExperiment::reducedDim(spe,dimred),"percentVar")[args$dims]
  if (!is.null(dims)) {
    dims = round(dims)
    args$label.x <- args$label.x %||% paste0(dimred," (",dims[1],"%)")
    args$label.y <- args$label.y %||% paste0(dimred," (",dims[2],"%)")
  }
  
  args$spe = spe
  args$dimred = dimred
  do.call(plotDR,args)
}

rownames2col <- function(df, rn = "rowname") {
    stopifnot(is.data.frame(df))
    df[[rn]] <- rownames(df)
    rownames(df) <- NULL
    return(df)
}

col2rownames <- function(df, rn = "rowname") {
    stopifnot(is.data.frame(df))
    df <- as.data.frame(df)
    rownames(df) <- df[[rn]]
    df[[rn]] <- NULL
    return(df)
}

col.spec <- c(
    "#D53E4F", "#F46D43", "#FDAE61",
    "#FEE08B", "#FFFFBF", "#E6F598", "#ABDDA4",
    "#66C2A5", "#3288BD", "#5E4FA2"
)

col.pMedium <- c(
    "#729ECE", "#FF9E4A", "#67BF5C", "#ED665D", "#AD8BC9",
    "#A8786E", "#ED97CA", "#A2A2A2", "#CDCC5D", "#6DCCDA"
)

col.pDark <- c(
    "#1F77B4", "#FF7F0E", "#2CA02C", "#D62728", "#9467BD",
    "#8C564B", "#E377C2", "#7F7F7F", "#BCBD22", "#17BECF"
)

col.pLight <- c(
    "#AEC7E8", "#FFBB78", "#98DF8A", "#FF9896", "#C5B0D5",
    "#C49C94", "#F7B6D2", "#C7C7C7", "#DBDB8D", "#9EDAE5"
)

col.p10 <- col.pMedium
col.p20 <- c(col.pDark, col.pLight)
col.p30 <- c(col.pDark, col.pLight, col.pMedium)

selectColor <- function(n) {
    if (n <= 10) {
        return(col.p10[seq_len(n)])
    } else if (n <= 20) {
        return(col.p20[seq_len(n)])
    } else if (n <= 30) {
        return(col.p30[seq_len(n)])
    } else {
        return(rep_len(col.p30, n))
    }
}

col.lisa <- c("#eeeeee", "#FF0000", "#0000FF", "#a7adf9",
              "#f4ada8", "#464646", "#999999")
col.pval <- c("#3644E5", "#FFFFBF", "#FF5D53")

contour_brks <- getFromNamespace("contour_breaks", "ggplot2")
unique00 <- getFromNamespace("unique0", "ggplot2")
data_frame00 <- getFromNamespace("data_frame0", "ggplot2")

colsum <- function(x, group, reorder = TRUE,...){
  return(t(rowsum(t(x), group, reorder = reorder, ...)))
}

# Clean up vector of names. If "overall" is in names (after cleaning up) then 
# also removes "overall" from it if more than 1 names.
cleanName <- function(names) {
  names <- janitor::make_clean_names(names)
  names <- gsub("^density_|_contour$|_roi$","",names)
  if ("overall" %in% names && length(names)>1) names <- names[names!="overall"]
  names <- sort(names)
  return(names)
}

#' Plot cell type composition in each density level of cell of interest.
#'
#' @param spe A SpatialExperiment object.
#' @param contour A character vector of cell type(s) on which the 
#' contour density level is calculated. If NULL, it looks for 
#' 'overall_contour' in colData(spe). Default to NULL.
#' @param id A character. The name of the column of colData(spe)
#' containing the cell type identifiers. Set to 'cell_type' by default.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. Default is NULL for no plotting by ROI
#' @param self.included Logical. Whether to include all the cell types in the plot. 
#' Default to TRUE. If FALSE, the cell types specified in 'contour' will not
#' be included in the plot.
#'
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#' coi <- "Breast cancer"
#' spe <- gridDensity(spe, coi = coi)
#' spe <- findROI(spe, coi = coi)
#' spe <- getContour(spe, coi = coi)
#' spe <- allocateCells(spe, contour = coi)
#' plotCellCompo(spe, contour = "Breast cancer")
#' plotCellCompo(spe, contour = "Breast cancer", roi = coi)
#'
plotCellCompo <- function(spe, 
                          contour = NULL, 
                          id = "cell_type",
                          roi = NULL, 
                          self.included = TRUE) {
    dat <- as.data.frame(colData(spe))
    
    if (!(id %in% colnames(dat))) {
        stop("Input 'id' is expected to be in the column names of the colData(spe).")
    }
    
    # ROI
    roi.name <- NULL
    if (!is.null(roi)) {
        roi.name <- paste(c(cleanName(roi),"roi"), collapse = "_")
        if (!roi.name %in% names(spe@colData)) {
            stop(paste(
                roi.name, " is not found in colData of spe. Please run
                allocateCells() with 'to.roi=TRUE' first."
            ))
        }
    } 
    # Contour. Default to overall_contour if both contour & ROI are NULL 
    if (!is.null(contour)) {
        level.name <- paste(c(cleanName(contour),"contour"), collapse="_")
    } else {
        level.name <- `if`(is.null(roi),"overall_contour",NULL)
    }
    if(!(is.null(level.name) || level.name %in% names(spe@colData)))
        stop("Specified contour not detected in colData(spe). Please run 
             'getContour' and 'allocateCells' first.")
    
    dat <- dat[, c(id, level.name, roi.name)]
    
    # if ((!all(contour %in% dat[[id]]) && level.name != "overall_contour") ||
    #     (!all(roi %in% dat[[id]]) && roi.name != "overall_roi")) {
    #     stop(paste("The cell type(s) on which the",
    #                `if`(is.null(contour),"ROI","contour"),
    #                "was computed is not found in colData(spe)[[id]]."))
    # }

    if (!self.included) dat <- dat[! dat[[id]] %in% (contour%||%roi),]
    
    if (is.null(roi)) {
        toplot <- calc_proportions(dat, level.name, id)
    } else if (is.null(contour)) {
        toplot <- calc_proportions(dat, roi.name, id)
    } else {
        dat <- dat[dat[[roi.name]] != "no_roi", ]
        
        grouped_data <- split(dat, as.character(dat[[roi.name]]))
        
        proportions_by_roi <- lapply(grouped_data, function(group) {
            calc_proportions(group, level.name, id, roi.name)
        })
        
        toplot <- do.call(rbind, proportions_by_roi)
    }
    col.p <- selectColor(length(unique(toplot[[id]])))

    p <- ggplot(toplot, aes(
        x= .data[[level.name%||%roi.name]],
        y = Proportion,
        fill = .data[[id]]
    )) +
        geom_bar(stat = "identity") +
        scale_fill_manual("Cell type", values = col.p) +
        ggtitle(paste0("Cell type composition at each density level of ", 
                       paste(contour, collapse=", "))) +
        theme_classic()
    if (is.null(roi.name)||is.null(level.name)) {
        return(p)
    } else {
        p <- p +
            facet_wrap(roi.name)
        
        return(p)
    }
}

calc_proportions <- function(x, level.name, id, roi.name = NULL) {
    cell_count <- table(x[[level.name]], x[[id]])
    cell_prop <- data.frame(prop.table(cell_count, margin = 1))
    colnames(cell_prop) <- c(level.name, id, "Proportion")
    cell_prop <- cell_prop[!is.na(cell_prop$Proportion), ]
    if (!is.null(roi.name)) {
        cell_prop[[roi.name]] <- unique(x[[roi.name]])
    }
    return(cell_prop)
}

utils::globalVariables(c("Proportion", "cell_type"))

#' Perform kernel density estimation on SpatialExperiment 
#'
#' @param xy A numeric matrix of spatial coordinates.
#' @param kernel The smoothing kernel. Options are gaussian, epanechnikov,
#' quartic or disc. ONLY GAUSSIAN IS IMPLEMENTED
#' @param bandwidth The smoothing bandwidth. By default performing automatic
#' bandwidth selection using cross-validation using function
#' spatstat.explore::bw.diggle.
#' @param weights Optional weights to be attached to the points.
#' @param ngrid.x Number of grids in the x-direction. 
#' @param xlim The range of the x-coordinates of the image.
#' @param ylim The range of the y-coordinates of the image.
#' @param diggle Logical. If TRUE, use the Jones-Diggle improved edge
#' correction. See spatstat.explore::density.ppp() for details.
#' @param gridInfo Logical. If TRUE, then the grid information is also returned.
#'
#' @return Output from spatstat.explore::density.ppp.
#'
#'
computeDensityHex <- function(xy,
                              kernel = c("gaussian"),
                              bandwidth = NULL, weights = NULL,
                              ngrid.x = NULL,
                              xlim = NULL, ylim = NULL, diggle = FALSE,
                              gridInfo=FALSE) {
  kernel <- match.arg(kernel)
  
  density_est <- hexDensity::hexDensity(xy,
                                        bandwidth = bandwidth,
                                        weight = weights,
                                        xbins = ngrid.x,
                                        edge = !gridInfo,
                                        diggle = diggle,
                                        xbnds = xlim,
                                        ybnds = ylim)
  if (gridInfo) {
    coords <- hexbin::hcell2xy(density_est)
    node_x <- (density_est@cell-1)%%density_est@dimen[2]+1
    node_y <- (density_est@cell-1)%/%density_est@dimen[2]+1
    # Max of node_y might be 1 or 2 less than dimen[1] which is ok for 
    # hexbin/hexDensity but can be a bit unintuitive to work with. 
    density_est@dimen[1] <- max(node_y) 
    return(list(
      grid_density = S4Vectors::DataFrame(x_grid=coords$x,
                                          y_grid=coords$y,
                                          node_x=node_x,
                                          node_y=node_y,
                                          node=paste(node_x,node_y,sep="-")),
      grid_info = list(
        dims = density_est@dimen[2:1],
        xlim = xlim,
        ylim = ylim,
        xstep = diff(xlim)/density_est@xbins,
        ystep = (diff(ylim)*sqrt(3))/(2*density_est@shape*density_est@xbins),
        xbins = density_est@xbins,
        shape = density_est@shape,
        bandwidth = bandwidth,
        grid_type = "hex"
      )
    ))
  } else {
    # Multiply by area
    return(density_est@count*((diff(density_est@xbnds)/ngrid.x)**2*sqrt(3)/2))
  }
}

#' Build a niche assay based on the profile of neighbouring cells
#'
#' @param spe A SpatialExperiment object
#' @param at Option of cell or grid neighbourhood
#' @param nbrs_name Name of the neighbour list in \code{spe@metadata$grid[[at]]}
#' @param group.by Character vector to group neighbours cell by. Should be in 
#' either colData(spe) or spe@metadata$grid_density, depending 
#' on "at". Multiple groups can be used. See details
#' @param use_weight Whether to scale each nbr based on its weight
#' @details
#' For numerical group, result will be sum of nbrs for each cell. For
#' categorical group (factor/string), result will be counts of nbrs belonging in 
#' category
#' @return A matrix where rows are cells/grid points and cols are groups based 
#' on group.by 
#' @export
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- findNbrsSpatial(spe,k=30)
#' niche = getNiche(spe,at="cell",group.by="cell_type")
getNiche <- function(spe,
                     at=c("cell","grid"),
                     nbrs_name = NULL,
                     group.by,
                     use_weight = FALSE) {
  at = match.arg(at)
  # some check for group.by + meaningful error messages
  if (at=="cell") {
    groups <- spe@colData[group.by]
    # row_names <- colnames(spe)
  } else { # grid
    groups <- spe@metadata$grid_density[group.by]
    # row_names <- rownames(spe@metadata$grid_density)
  }
  groups = as.data.frame(groups)
  n_row = nrow(groups)
  groups = cbind(seq_len(n_row),groups)
  
  # Convert categorical/factor/string groups to wide matrix
  groups_matrix = matrix(ncol=0,nrow=n_row,dimnames=list(rownames(groups)))
  for (i in 2:ncol(groups)) {
    if (is.numeric(groups[[i]])) {
      groups_matrix = cbind(groups_matrix,groups[[i]])
    } else {
      groups_matrix = cbind(groups_matrix,+(table(groups[c(1,i)])!=0))
    }
  }
  
  nbrs <- spe@metadata$nbrs[[at]][[nbrs_name%||%length(spe@metadata$nbrs[[at]])]]
  # Aggregate each group for cells based on their nbrs
  for (g in 1:ncol(groups_matrix)) {
    group = groups_matrix[,g]
    if (use_weight) {
      niche <- lapply(seq_along(nbrs$index),function(i){
        sum(group[nbrs$index[[i]]]*nbrs$weight[[i]])
      })
    } else {
      niche <- lapply(nbrs$index,function(i){
        sum(group[i])
      })
    }
    groups_matrix[,g] = unlist(niche)
  }
  
  return(groups_matrix)
}

#' Given a 'SpatialExperiment' data object, create pseudo-bulk
#' samples using the colData information and return a DGEList object
#'
#' @param spe A SpatialExperiment object.
#' @param by.group Logical. Whether to perform pseudo-bulking by group.
#' TRUE by default.
#' @param group.id Character. The column name of the colData(spe) that
#' contains the group information. Default to 'cell_type'.
#' @param keep.groups Vector. Values from group.id to include in pseudo-
#' bulking. Default is NULL, where all cells are included in pseudo-bulking.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed.
#' If NULL, then no pseudo-bulking will be performed based on roi.
#' Default to NULL.
#' @param roi.only Logical. Whether to filter out pseudo-bulk samples formed
#' by cells not in any ROIs. TRUE by default.
#' @param contour Character. The name of the group or cell type on which
#' the contour level is computed.
#' If NULL, then no pseudo-bulking will be performed based on contour level.
#' Default to NULL.
#'
#' @return An edgeR::DGEList object where each library (column) is a
#' pseudo-bulk sample.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' coi <- "Breast cancer"
#'
#' spe <- findROI(spe, coi = coi)
#'
#' spe <- allocateCells(spe, to.contour=FALSE)
#'
#' y <- spe2PB(spe, roi = coi)
#'
spe2PB <- function(spe,
                   by.group = TRUE,
                   group.id = "cell_type",
		   keep.groups = NULL, 
                   roi = NULL,
                   roi.only = TRUE,
                   contour = NULL) {
    if (!requireNamespace("SpatialExperiment", quietly = TRUE)) {
        stop("SpatialExperiment is required but is not installed
         (or can't be loaded)")
    }
    
    if (!requireNamespace("edgeR", quietly = TRUE)) {
        stop("edgeR is required but is not installed (or can't be loaded)")
    }
    
    if (!is(spe, "SpatialExperiment")) {
        stop("spe is not of the SpatialExperiment class")
    }

    if (by.group | !is.null(keep.groups)) {
        if (!group.id %in% names(spe@colData)) {
            stop(paste(group.id, "is not found in colData of spe."))
        }
    }

    # subset to only groups we want to keep
    if (!is.null(keep.groups)) {
        if (length(setdiff(keep.groups, spe@colData[, group.id])) > 0.5) {
            stop(paste("Some values in keep.groups do not exist in", group.id))
        }
        kp <- spe@colData[, group.id] %in% keep.groups
        spe <- spe[, kp]
    }

    # Check 'counts'
    counts <- as.matrix(spe@assays@data$counts)
    if (is.null(counts)) stop("spe doesn't contain raw RNA counts")
    
    # Check 'colData'
    cData <- spe@colData
    
    grp <- rois <- clvl <- c()
    
    if (by.group) {
        if (!group.id %in% names(cData)) {
            message(paste(group.id, "is not found in colData of spe. Proceed without group.id."))
        } else {
            grp <- cData[, group.id]
        }
    }
    
    if (!is.null(roi)) {
        roi <- cleanName(roi)
        roi <- paste(c(roi,"roi"), collapse="_")
        if (!roi %in% names(cData)) {
            message(paste(
                roi, " is not found in colData of spe. Proceed without ROIs."
            ))
        } else {
            rois <- paste0("ROI", cData[, roi])
        }
    }
    
    if (!is.null(contour)) {
        
        cont <- cleanName(contour)
        cont <- paste(c(cont,"contour"), collapse="_")
        if (!cont %in% names(cData)) {
            message(paste(
                contour,
                " contour level is not found in colData of spe. Proceed without contour."
            ))
        } else {
            clvl <- paste0("Lv", cData[, cont])
            if (length(table(clvl)) == 1) {
                warning("Only 1 contour level found. Please check
                whether the contour information is specified correctly.")
            }
        }
    }
    
    if (is.null(grp) && is.null(rois) && is.null(clvl)) {
        stop("At least one of the following is required:
        group, ROI, or contour information.")
    }
    
    # Check gene information
    if (ncol(SummarizedExperiment::rowData(spe)) == 0) {
        genes <- data.frame(genes = rownames(spe))
    } else {
        genes <- as.data.frame(SummarizedExperiment::rowData(spe))
    }
    
    # Pseudo-bulk counts
    combo <- c(if (!is.null(grp)) "grp", 
               if (!is.null(rois)) "rois", 
               if (!is.null(clvl)) "clvl")
    eval( parse(text=paste0('group <- paste(', paste(combo, collapse=","), ',sep ="_")') ))
    group <- factor(group)
    # group_mat <- Matrix::sparse.model.matrix(~ 0 + group)
    group_mat <- stats::model.matrix(~ 0 + group)
    colnames(group_mat) <- gsub("^group", "", colnames(group_mat))
    counts.pb <- counts %*% group_mat
    
    # Pseudo-bulk sample information
    sample.pb <- data.frame()[seq_len(ncol(counts.pb)), ]
    sample.pb$n.cells <- as.vector(table(group))
    
    if (!is.null(grp)) {
        grp.pb <- gsub("_ROI.*$", "", levels(group))
        grp.pb <- gsub("_Lv.*$", "", grp.pb)
        sample.pb$group <- grp.pb
    }
    if (!is.null(rois)) {
        rois.pb <- gsub("^.*ROI", "", levels(group))
        rois.pb <- gsub("_.*$", "", rois.pb)
        sample.pb$ROI <- rois.pb
        if (roi.only) keep <- rois.pb != "None"
    }
    if (!is.null(clvl)) {
        clvl.pb <- gsub("^.*Lv", "", levels(group))
        sample.pb$contour.level <- clvl.pb
    }
    
    names(sample.pb) <- gsub("group", group.id, names(sample.pb))
    
    # DGEList
    dge <- edgeR::DGEList(
        counts = as.matrix(counts.pb),
        samples = sample.pb, genes = genes
    )
    if (!is.null(rois) && roi.only) dge <- dge[, keep]
    
    return(dge)
}

#' Construct a distance-based neighbour list from cell coordinates.
#'
#' @param spe A SpatialExperiment object.
#' @param k Integer scalar for number of nearest neighbours to find. Can be used
#' with radius. See details.
#' @param radius Numeric for maximum distance to search for neighbours. Can be 
#' with k. See details
#' @param dist_func Options for distance-based weight. "idw" for inverse 
#' distance, "exp" for exponential decay, "binary" for constant weight, and 
#' "none" for raw euclidean distance.
#' @param standardisation Options for weight standardisation. "none" for 
#' nothing, and "row" for dividing weights by number of neighbours.
#' @param scale Numeric scaler for weight scaling.
#' @param nbrs_name Name of the neighbour list to be stored. Default to be "spatial".
#' @param cpu_threads Number of cpu threads for parallel computation.
#' @return A SpatialExperiment object with neighbour list stored in 
#' \code{spe@metadata$nbrs$cell[[nbrs_name]]}
#' @details
#' if only \code{k} is provided, neighbours are found using 
#' \link[BiocNeighbors]{findKNN}. If only \code{radius} is provided, neighbours are 
#' found using \link[BiocNeighbors]{findNeighbors}. If both are provided, then 
#' knn is done first then neighbours are filtered to only those within radius.
#' 
#' @export
#' @examples
#' 
#' data("xenium_bc_spe")
#' spe <- findNbrsSpatial(spe,k=20,radius=100)
findNbrsSpatial <- function(spe,
                           k = NULL,
                           radius = NULL,
                           dist_func = c("idw", "exp","binary","none"),
                           standardisation = c("none","row"),
                           scale = 1,
                           nbrs_name = NULL,
                           cpu_threads = 6) {
  if (is.null(k) && is.null(radius)) stop("k or radius is needed")
  dist_func <- match.arg(dist_func)
  standardisation <- match.arg(standardisation)
  
  get_dist <- dist_func != "binary"
  coords <- SpatialExperiment::spatialCoords(spe)
  coords <- as.matrix(coords)
  
  # Make nbrs list
  if (!is.null(k)) {# knn + radius
    knn <- BiocNeighbors::findKNN(X=coords,
                                  k=k,
                                  get.distance = get_dist || !is.null(radius),
                                  num.threads = cpu_threads)
    # Filter radius if provided. 
    n_row = nrow(coords)
    keep = `if`(is.null(knn$distance) || is.null(radius),
                matrix(TRUE,n_row,k),
                (knn$distance) <= (radius%||%Inf))
    knn$index <- knn$index[keep]
    knn$distance <- knn$distance[keep]
    
    # Convert to nbrs list
    f <- factor(row(keep)[keep],seq_len(n_row))
    nbrs <- list(index = split(knn$index,f),
                 weight = if(get_dist) split(knn$distance,f))
    # Not really needed but for consistency
    names(nbrs$index) <- NULL
    names(nbrs$weight) <- NULL
    
  } else {# radius only
    nbrs <- BiocNeighbors::findNeighbors(X=coords,
                                        threshold = radius,
                                        get.distance = get_dist,
                                        num.threads = cpu_threads)
    if (get_dist) names(nbrs)[2] <- "weight"
  }
  # Transform weight based on dist_func.
  nbrs$weight <- switch(dist_func,
                        "idw" = lapply(nbrs$weight, function(i) scale/i),
                        "exp" = lapply(nbrs$weight, function(i) exp(-i/scale)),
                        "binary" = lapply(lengths(nbrs$index), function(i) rep.int(1,i)),
                        "raw" = nbrs$weight) 
  # standardization
  nbrs$weight <- switch(standardisation,
                        "row" = lapply(nbrs$weight, function(i) i/length(i)),
                        "none" = nbrs$weight)
  
  
  if (is.null(nbrs_name)) {
    nbrs_name <- "spatial"
  }
  spe@metadata$nbrs$cell[[nbrs_name]] <- nbrs
  return(spe)
}

#' Plot contour lines.
#'
#' @param spe A SpatialExperiment object.
#' @param coi A character vector of cell types of interest (COIs). 
#' All cell types are chosen if NULL or 'overall'.
#' @param overlay Character vector. Options are 'cell' (plot overlay on cells),
#' 'density' (overlay on density), or 'none'. Default to 'cell'.
#' @param id A character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to 'cell_type' by default.
#' @param sub.level Character vector. Subset on specific level.
#' @param line.type shape of contour. See 'ggplot2::geom_path()'.
#' @param line.width size of contour.
#' @param line.alpha alpha of contour between 0 and 1.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Aesthetic mappings to pass to \link[scider]{plotSpatial}, 
#' \link[scider]{plotDensity}, or \link[scider]{plotImage}, depending on 
#' the overlay.
#'
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' coi <- "Breast cancer"
#'
#' spe <- getContour(spe, coi = coi)
#'
#' plotContour(spe, coi = coi, line.width = 0.3, pt.alpha = 0.2)
#'
plotContour <- function(spe,
                        coi = NULL,
                        overlay = c("cell", "density", "none"),
                        id = "cell_type",
                        sub.level = NULL, 
                        line.type = 1,
                        line.width = 0.5,
                        line.alpha = 1,
                        reverseY = NULL,
                        ...) {
  coi_clean <- `if`(is.null(coi),"overall",cleanName(coi))
  contour_name <- paste(c(coi_clean,"contour"), collapse="_")

  if (!contour_name %in% names(spe@metadata)) {
    stop("Contour of interest doesn't exist. Please run getContour() first!")
  }
  
  contour_data <- as.data.frame(spe@metadata[[contour_name]])
  levs_drawn <- sort(unique(contour_data$level))
  levs_legend <- if (0 %in% levs_drawn) levs_drawn else c(0, levs_drawn)
  
  overlay <- overlay[1]
  if (overlay == "cell") {
    sub <- TRUE
    if (contour_name != "overall_roi" &&
        id %in% colnames(spe@colData) &&
        any(spe@colData[,id] %in% coi)) {
      sub <- spe@colData[[id]] %in% coi
    }
    p <- plotSpatial(spe[, sub],reverseY=reverseY,...)
  } else if (overlay == "density") {
    p <- plotDensity(spe, coi = coi,reverseY=reverseY,...)
  } else if (overlay == "none") {
    p <- plotImage(spe,reverseY=reverseY,...)
  } else {
    stop("Invalid 'overlay'.")
  }
  col.p <- grDevices::colorRampPalette(col.spec)(length(levs_legend))
  col.p <- rev(col.p)
  names(col.p) <- levs_legend
  
  if (is.null(sub.level)) {
    suppressMessages(p <- p +
                       ggplot2::geom_path(
                         data = contour_data,
                         ggplot2::aes(
                           x = x, y = y, group = group,
                           color = factor(level,
                                          levels = levs_legend)
                         ),
                         linewidth=line.width,
                         linetype=line.type,
                         alpha=line.alpha
                       ) +
                       ggplot2::scale_color_manual(name = "Density level", values = col.p,
                                                   breaks = levs_legend, drop = FALSE))
  } else {
    if (length(sub.level) == 1L & sub.level %in% contour_data$level) {
      suppressMessages(p <- p +
                         ggplot2::geom_path(
                           data = contour_data,
                           ggplot2::aes(
                             x = x, y = y, group = group,
                             color = level == sub.level
                           ),
                           linewidth=line.width,
                           linetype=line.type,
                           alpha=line.alpha
                         ) +
                         ggplot2::scale_color_manual(
                           name = paste0("level", sub.level, " density"),
                           values = c("royalblue", "tomato2")
                         ))
    } else {
      stop("The length sub.level is expected to be 1 and
           should be included in contour_data$level.")
    }
  }
  p <- update_bound(p,
                    x=SpatialExperiment::spatialCoords(spe)[, 1],
                    y=SpatialExperiment::spatialCoords(spe)[, 2])
  p <- p +
    ggplot2::theme_classic() +
    ggplot2::labs(x = "x", y = "y") +
    ggplot2::ggtitle(paste(coi_clean, collapse=", "))
  return(p)
}

utils::globalVariables(c("x", "y", "group", "level"))

test_that("plotContour works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    coi <- "Breast cancer"
    spe <- getContour(spe, coi = coi)

    expect_silent(plotContour(spe, coi = coi))

    expect_silent(plotContour(spe, coi = coi, line.width = 0.3, pt.alpha = 0.2))

    expect_error(plotContour(spe, coi = "xyz"))

    #expect_error(plotContour(spe, coi = coi, id = "xyz"))

    expect_error(plotContour(spe, coi = coi, overlay = "xyz"))

    #expect_silent(plotContour(spe, coi = coi, overlay = "density"))

    #expect_silent(plotContour(spe, coi = coi, overlay = "density", sub.level = "1"))

    expect_silent(plotContour(spe, coi = coi, sub.level = "1"))

    expect_error(plotContour(spe, coi = coi, sub.level = "xyz"))
})

#' Plot grid-based density.
#'
#' @param spe A SpatialExperiment object.
#' @param coi A character vector of cell types of interest (COIs) to be plotted.
#' Default to all cell types.
#' @param probs Numeric value between 0 and 1, used for filtering
#' uninformative grid, default is 0.5.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Parameters pass to \link[scider]{plotGrid}
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' plotDensity(spe, coi = "Breast cancer")
#'
#' plotDensity(spe, coi = "Fibroblasts")
#'
plotDensity <- function(spe, coi = NULL, probs = 0.5, reverseY=NULL,...) {
  coi_clean <- `if`(is.null(coi),"overall",cleanName(coi))
  dens_cols <- paste("density", coi_clean, sep = "_")
  
  if (!all(dens_cols %in% colnames(spe@metadata$grid_density))) {
    stop("Density of COI is not yet computed.")
  }
  spe@metadata$grid_density$density_coi_average <- rowSums(as.matrix(
    spe@metadata$grid_density[, dens_cols, drop = FALSE]
  ))
  plotGrid(spe,
           group.by="density_coi_average",
           probs=probs,
           label="Density",
           reverseY=reverseY,
           ...) +
    ggtitle(paste(coi_clean, collapse=", "))
}

utils::globalVariables(c("x_grid", "y_grid", "density_coi_average"))

test_that("plotDensity works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)

    expect_silent(plotDensity(spe, coi = "Breast cancer"))
    expect_silent(plotDensity(spe, coi = "Fibroblasts"))
    expect_error(plotDensity(spe, coi = "xxx"))
    expect_silent(plotDensity(spe, coi = "Fibroblasts", probs = 0.5))
    expect_error(plotDensity(spe, coi = "Fibroblasts", probs = "xx"))
})

#' Visualising an sf object (for internal use only at the moment)
#'
#' @param spe A SpatialExperiment object.
#' @param coi A character vector of length 1 of the cell type of interest.
#' @param id A character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to cell_type by default.
#' @param overlay Character vector. Either plot overlay on density or cells.
#' @param sub.level Numeric vector of length 1 or 2, identifies which
#' density level to plot. When length is 1, plot the density region above
#' this level. When length is 2, plot the density region
#' between the two levels.
#'
#' @return A ggplot object.
#'
plotContourRegion <- function(spe,
                              coi,
                              id = "cell_type",
                              overlay = c("density", "cell"),
                              sub.level) {
    if (length(coi) > 1L) {
        stop("coi must be of length 1!")
    }

    if (!(coi %in% colData(spe)[[id]])) {
        stop("coi not in colData(spe)[[id]]!")
    }

    if (!(length(sub.level) %in% c(1L, 2L))) {
        stop("sub.level must be of either length 1 or 2!")
    }

    coi_clean <- cleanName(coi)
    coi_clean_contour <- paste(coi_clean, "contour", sep = "_")
    coi_clean_density <- paste("density", coi_clean, sep = "_")

    if (!coi_clean_contour %in% names(spe@metadata)) {
        stop("Contour of coi doesn't exist. Please run getContour() first!")
    }

    contour_data <- as.data.frame(spe@metadata[[coi_clean_contour]])
    levs <- unique(contour_data$level)
    nlevs <- length(levs)

    if (any(!(sub.level %in% levs))) {
        stop("Non-existing level(s) in sub.level! Check
         unique(spe@metadata$`contour_data`$level).")
    }

    if (length(overlay) == 2) {
        overlay <- "density"
    }

    xlim <- spe@metadata$grid_info$xlim
    ylim <- spe@metadata$grid_info$ylim
    plot.xlim <- xlim + c(-1e-10, 1e-10)
    plot.ylim <- ylim + c(-1e-10, 1e-10)
    w <- spe@metadata$grid_info$xstep
    h <- spe@metadata$grid_info$ystep

    if (length(sub.level) == 1L) {
        density_at_level <- unique(
            contour_data$cutoff[contour_data$level == sub.level]
        )
    }
    if (length(sub.level) == 2L) {
        density_at_level <- unique(
            contour_data$cutoff[contour_data$level %in% sub.level]
        )
        density_at_level <- sort(density_at_level, decreasing = FALSE)
    }

    if (overlay == "cell") {
        sub <- grep(coi, colData(spe)[[id]])
        p <- ggplot() +
            geom_point(
                data = as.data.frame(spatialCoords(spe[, sub])),
                aes(x = x_centroid, y = y_centroid), size = 0.02,
                stroke = 0.2, alpha = 0.4
            )
    } else if (overlay == "density") {
        dens_df <- as.data.frame(spe@metadata$grid_density)
        colnames(dens_df)[
            which(colnames(dens_df) == coi_clean_density)
        ] <- "density"
        if (length(sub.level) == 1L) {
            kp_grids <- dens_df$density >= density_at_level
            kp_isolines <- contour_data$level == sub.level
            lev_name <- sub.level
        }
        if (length(sub.level) == 2L) {
            kp_grids <- dens_df$density >= density_at_level[1] &
                dens_df$density < density_at_level[2]
            kp_isolines <- contour_data$level %in% sub.level
            lev_name <- paste0(sub.level, collapse = "-")
        }
        p <- ggplot() +
            geom_tile(data = dens_df[kp_grids, ], aes(
                x = x_grid,
                y = y_grid, width = w,
                height = h
            ), fill = "lightgrey") +
            geom_path(data = contour_data[kp_isolines, ], aes(
                x = x, y = y,
                group = group
            )) +
            ggtitle(paste("Level = ", lev_name, sep = ""))
    } else {
        stop("Overlay should either be cell or density.")
    }

    # overlay the sf region
    if (length(sub.level) == 1L) {
        area <- contour2sf(spe,
            contour = coi_clean_contour,
            cutoff = density_at_level
        )
        p <- p + geom_sf(
            data = area, alpha = 0.2, fill = "tomato",
            linewidth = 0.04
        )
    }
    if (length(sub.level) == 2L) {
        area_low <- contour2sf(spe,
            contour = coi_clean_contour,
            cutoff = density_at_level[1]
        )
        area_high <- contour2sf(spe,
            contour = coi_clean_contour,
            cutoff = density_at_level[2]
        )
        area_diff <- sf::st_difference(area_low, area_high)
        if (overlay == "cell") {
            p <- p + geom_sf(
                data = area_diff, alpha = 0.4,
                fill = "tomato", linewidth = 0.2
            )
        }
        if (overlay == "density") {
            p <- p + geom_sf(
                data = area_diff, alpha = 0.2,
                fill = "tomato", linewidth = 0.04
            )
        }
    }

    p <- p +
        scale_x_continuous(limits = plot.xlim) +
        scale_y_continuous(limits = plot.ylim) + labs(x = "x", y = "y")

    return(p)
}

utils::globalVariables(c(
    "x_centroid", "y_centroid", "x_grid",
    "y_grid", "x", "y",
    "group"
))

#' Construct a SNN neighbour list from assay.
#'
#' @param spe A SpatialExperiment object.
#' @param assay Name of assay for clustering. Incompatible with dimred.
#' @param dimred Name of the dimensionality reduction (e.g. PCA) for clustering.
#' Incompatible with assay
#' @param n_dimred Integer scalar or vector specifying the dimensions to use if dimred is specified.
#' @param k Integer scalar for number of nearest neighbors to find.
#' @param BNPARAM \link[BiocNeighbors]{BiocNeighborParam} object specifying the nearest neighbor algorithm. Default is Annoy.
#' @param type Type of weighting scheme for shared neighbors. Options are rank, number, and jaccard.
#' type="rank" is defined in Xu and Su (2015).
#' @param nbrs_name Name of the neighbour list to be stored in spe. Default to be 
#' assay/dimred + "_snn".
#' @param cpu_threads Number of cpu threads for parallel computation.
#' @return A spe with the clusters stored in \link[SingleCellExperiment]{reducedDims}.
#' @details
#' Construct a SNN neighbour list using either the spe's assay or reduced 
#' dimension and store it in spe@metadata$nbrs$cell
#' 
#' neighbour list contain
#' @return A SpatialExperiment object
#' @export
#' @examples
#' 
#' data("xenium_bc_spe")
#' spe <- runPCA(spe)
#' spe <- findNbrsSNN(spe,dimred="PCA")
findNbrsSNN <- function(spe,
                        assay = NULL,
                        dimred = "PCA",
                        n_dimred = 10,
                        k = 20,
                        BNPARAM = BiocNeighbors::AnnoyParam(),
                        type = c("rank", "number", "jaccard"),
                        nbrs_name = NULL,
                        cpu_threads = 6) {
  # Getting default data  
  if (missing(assay) && missing(dimred) && 
      (!dimred %in% SingleCellExperiment::reducedDimNames(spe))) {
    dimred=NULL
    if (is.null(spe@assays@data[["logcounts"]])) {
      assay <- "counts"
    } else {
      assay <- "logcounts"
    }
    warning(paste("PCA not found. Switching to",assay,"assay instead."))
  }

  if (!is.null(dimred)) {
    mat <- SingleCellExperiment::reducedDim(spe,dimred)
    if (!is.null(n_dimred)) {
      if(length(n_dimred)==1L) {
        n_dimred <- seq_len(n_dimred)
      }
      mat <- as.matrix(mat[,n_dimred,drop=FALSE])
    }
  } else {
    mat <- t(as.matrix(SummarizedExperiment::assay(spe,assay)))
  }
  
  # KNN
  print("Getting K-nearest neighbour")
  knn.args <- list(X=mat,
                     k=k,
                     num.threads=cpu_threads,
                     get.distance=FALSE,
                     BNPARAM=BNPARAM
  )
  knn <- do.call(BiocNeighbors::findKNN,knn.args)
  
  # SNN
  print("Getting shared nearest neighbour")
  type <- match.arg(type)
  snn <- .Call("C_findSNN",t(knn$index-1),k,nrow(mat),type,cpu_threads)
  snn$index <- lapply(snn$index,"+",1L)

  if (is.null(nbrs_name)) {
    if(is.null(dimred)) nbrs_name <- paste0(assay,"_snn")
    else nbrs_name <- paste0(dimred,"_snn")
  }
  spe@metadata$nbrs$cell[[nbrs_name]] <- snn
  return(spe)
}

#' Merge sel_region from the selectRegion function to SpatialExperiment.
#'
#' @param spe A SpatialExperiment object.
#' @param sel_region A dataframe object. Can be generated from
#' function selectRegion.
#'
#' @return A SpatialExperiment object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")
#'
#' spe <- gridDensity(spe, coi = coi)
#'
#' sel_region <- data.frame(
#'     "node" = seq(10),
#'     "node_x" = seq(10),
#'     "node_y" = seq(10)
#' )
#'
#' spe1 <- postSelRegion(spe, sel_region)
#'
postSelRegion <- function(spe, sel_region) {
    if (!(all(c("node", "node_x", "node_y") %in% colnames(sel_region)))) {
        stop("sel_region should have column node, node_x and node_y.")
    }

    if (!("grid_info" %in% names(spe@metadata))) {
        stop("grid_info is expected in the metadat of spe.")
    }

    components <- S4Vectors::DataFrame(data.frame(
        "component" = "user_defined",
        "members" = sel_region[, "node"],
        "x" = sel_region[, "node_x"],
        "y" = sel_region[, "node_y"]
    ))

    components$xcoord <- spe@metadata$grid_info$xcol[as.numeric(components$x)]
    components$ycoord <- spe@metadata$grid_info$yrow[as.numeric(components$y)]

    spe@metadata$roi <- components

    return(spe)
}

test_that("postSelRegion works", {
    data("xenium_bc_spe")
    coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")

    spe <- gridDensity(spe, coi = coi)

    sel_region <- data.frame(
        "node" = seq(10),
        "node_x" = seq(10),
        "node_y" = seq(10)
    )
    spe1 <- postSelRegion(spe, sel_region)

    expect_true("user_defined" %in% spe1@metadata$roi$component)
})

#' Check which cells are in which regions
#'
#' @param spe A SpatialExperiment object.
#' @param region List or an sf object that represents a region or an ROI.
#' @param name_to Colname in colData(spe) to store the annotation.
#' @param NA_level Label for cells not falling in any of the regions.
#' Default to 0.
#' @param levels Factor levels.
#'
#' @return A SpatialExperiment object. The region information of each cell is
#' stored in the colData.
#'
#'
cellsInRegion <- function(spe, region, name_to,
                          NA_level = "0", levels = NULL) {
    if (is.null(names(region))) {
        warning("The region input is unnamed! We recommend a named list of
            region object(s) as input!")
    }
    if (is.null(NA_level)) {
        stop("Need to specify `NA_level` as labels for cells not
             in any of the regions!")
    }

    # all cells
    xy_allcells <- sf::st_as_sf(as.data.frame(SpatialExperiment::spatialCoords(spe)),
        coords = c(1,2) #c("x_centroid", "y_centroid")
    )

    # calculate overlaps
    region_names <- names(region) %||% as.character(seq_along(region))
    region <- do.call(rbind,region)
    isIn <- sf::st_intersects(region,xy_allcells)

    # annotate colData
    to_append <- rep_len(NA_level, nrow(colData(spe)))
    for (i in seq_along(region_names)) {
        to_append[isIn[[i]]] <- region_names[i]
    }

    if (is.null(levels)) {
        # levels <- unique(to_append)[order(as.numeric(unique(to_append)))]
        val <- unique(to_append)[unique(to_append) != NA_level]
        levels <- c(NA_level, val[order(as.numeric(val))])
        colData(spe)[[name_to]] <- factor(to_append, levels = levels)
    }
    return(spe)
}

#' Calculate local Moran for 1 to 2 variables.
#'
#' @param spe A SpatialExperiment object.
#' @param data1 Numeric vector 1. Must be same length as number of grid points
#' or cells, depending on 'at'.
#' @param data2 Numeric vector 2 for bivariate local Moran. Must be same length as data1.
#' @param at Option of grid or cell for where to look for neighbour list
#' @param nbrs_name Name of the neighbour list in \code{spe@metadata$grid[[at]]}
#' for Moran's I. If NULL, will use the newest neighbour list.
#' @param hhonly Only high-high clusters, which is more interpretable. Other 
#' clusters (e.g. "Low-Low","High-Low",...) will be assigned as undefined.
#' @param significance_cutoff Cutoff for p-value to filter non-significant clusters
#' @param permutations Number of permutations for p-value.
#' @param seed Integer. For random permutations.
#' @param cpu_threads The number of cpu threads used for parallel computation.
#' 
#' @return List of lisa_value, clusters, and pseudo p-value.
#' @examples
#' data("xenium_bc_spe")
#'
#' ## At grid.
#' spe <- gridDensity(spe, coi = "Breast cancer")
#' dat <- spe@metadata$grid_density$density_breast_cancer
#' spe <- findNbrsGrid(spe)
#' res <- localMoran(spe,data1=dat, at = "grid")
#' 
#' ## At cell.
#' dat <- as.numeric(spe$cell_type=="Breast cancer")
#' spe <- findNbrsSpatial(spe,k=20)
#' res <- localMoran(spe,data1=dat,at="cell")
#' @export
#' 
localMoran <- function(spe, data1, data2=data1[],
                       at=c("grid","cell"),
                       nbrs_name = NULL,
                       hhonly = FALSE,
                       significance_cutoff = 0.05,
                       permutations = 999,
                       seed = 123456789,
                       cpu_threads=6) {
  stopifnot(length(data1)==length(data2),
            is.numeric(data1),
            is.numeric(data2))
  at <- match.arg(at)
  nbrs <- spe@metadata$nbrs[[at]][[nbrs_name %||% length(spe@metadata$nbrs[[at]])]]
  
  if (length(data1) != length(nbrs$index)) {
    stop(paste0("length of data must be same as no. of ",at,"s"))
  }
  
  r <- .Call("C_localMoran",
             nbrs$index,
             lengths(nbrs$index),
             nbrs$weight,
             data1,
             data2,
             significance_cutoff,
             permutations,
             seed,
             cpu_threads,
             hhonly)

  # Turn cluster from int to factor 
  r$cluster <- factor(r$cluster,
                      levels = 0:6,
                      labels = c("Not significant","High-High","Low-Low","Low-High",
                                 "High-Low","Undefined","Neighborless"))
  return(r)
}

#' Calculate global Moran for 1 to 2 variables.
#'
#' @param spe A SpatialExperiment object.
#' @param data1 Numeric vector 1. Must be same length as 
#' nrow(spe@metadata$grid_density) or spatialCoords(spe), depending on 'at'.
#' @param data2 Numeric vector 2 for bivariate local Moran. Must be same length as data1.
#' @param at Option of grid or cell for where to look for neighbour list
#' @param nbrs_name Name of the neighbour list in \code{spe@metadata$grid[[at]]}
#' for Moran's I
#' @param permutations Number of permutations for p-value.
#' @param seed Integer. For random permutations.
#' @param cpu_threads (optional) The number of cpu threads used for parallel
#' LISA computation
#' @return List with global lisa, p.value, and vector of permuted lisa.
#' @export
#' 
#' @examples
#' data("xenium_bc_spe")
#'
#' ## At grid.
#' spe <- gridDensity(spe, coi = "Breast cancer")
#' dat <- spe@metadata$grid_density$density_breast_cancer
#' spe <- findNbrsGrid(spe)
#' res <- globalMoran(spe,data1 = dat,at="grid")
#' res$lisa
#' ## At cell.
#' dat <- as.numeric(spe$cell_type=="Breast cancer")
#' spe <- findNbrsSpatial(spe,k=10)
#' res <- globalMoran(spe,data1 = dat,at="cell")
#' res$lisa
#' @export
globalMoran <- function(spe, data1, data2=data1[],
                        at=c("grid","cell"),
                        nbrs_name = NULL,
                        permutations = 999,
                        seed = 123456789,
                        cpu_threads=6) {
  stopifnot(length(data1)==length(data2),
            is.numeric(data1),
            is.numeric(data2))
  at <- match.arg(at)
  nbrs <- spe@metadata$nbrs[[at]][[nbrs_name %||% length(spe@metadata$nbrs[[at]])]]
  
  if (length(data1) != length(nbrs$index)) {
    stop(paste0("length of data must be same as no. of ",at,"s"))
  }
  
  r <- .Call("C_globalMoran",
             nbrs$index,
             lengths(nbrs$index),
             nbrs$weight,
             data1,
             data2,
             permutations,
             seed,
             cpu_threads)
}

#' Annotate all cells with contour level of cell type-specific density.
#'
#' @param spe A SpatialExperiment object.
#' @param to.roi Logical. Whether to allocate cells to ROIs.
#' @param roi Character. The name of the group or cell type on which
#' the roi is computed. If NULL, then the cell allocation will 
#' be performed for all detected roi Default to NULL.
#' @param to.contour Logical. Whether to allocate cells to contour levels.
#' @param contour Character. The name of the group or cell type on which
#' the contour level is computed. If NULL, then the cell allocation will 
#' be performed for all detected contours. Default to NULL.
#' 
#' @return A SpatialExperiment object. An extra column is added to the colData.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#' spe <- gridDensity(spe)
#' coi <- "Breast cancer"
#' spe <- findROI(spe, coi = coi)
#' spe <- getContour(spe, coi = coi)
#' spe <- allocateCells(spe, contour = coi)
#'
allocateCells <- function(spe,
                          to.roi = TRUE,
                          roi = NULL,
                          to.contour = TRUE,
                          contour = NULL) {
    if (to.roi) {
        if (is.null(roi)) {
            roi_clean <- grep("_roi$", names(spe@metadata),value = TRUE)
        } else {
            roi_clean <- cleanName(roi)
            roi_clean <- paste(c(roi_clean,"roi"), collapse="_")
            if (!roi_clean %in% names(spe@metadata)) roi_clean <- NULL
        }
        
        if(length(roi_clean) == 0){
            message("No roi detected. Proceed without roi.")
        } else {
            for (r in roi_clean) {
                message(paste(
                    "Assigning cells to ROIs defined by",
                    janitor::make_clean_names(r,case="sentence",replace = c("_roi$"="")), 
                    "\n"
                ))
                rois <- spe@metadata[[r]]
                sf <- grid2sf(spe, rois$x,rois$y)
                # Unioning sf polygons with same ROIs
                all_areas <- lapply(unique(rois$component), function(xx) {
                    sf::st_as_sf(sf::st_union(sf::st_sfc(sf[rois$component == xx]),is_coverage = TRUE))
                })
                names(all_areas) <- unique(rois$component)
                
                spe <- cellsInRegion(spe, all_areas,
                                     name_to = r,
                                     NA_level = "None", levels = NULL
                )
            }
        }
    }
    
    if (to.contour) {
        if (is.null(contour)) {
            contour_clean <- grep("_contour$", names(spe@metadata),value = TRUE)
        } else {
            contour_clean <- cleanName(contour)
            contour_clean <- paste(c(contour_clean,"contour"), collapse="_")
            if (!contour_clean %in% names(spe@metadata)) contour_clean <- NULL
        }
      
        if (length(contour_clean)==0) {
            message("No contour detected. Proceed without contour.")
        } else {
            for (cc in contour_clean) {
                message(paste(
                    "Assigning cells to contour levels of",
                    janitor::make_clean_names(cc,case="sentence",replace = c("_contour$"="")), 
                    "\n"
                ))
            
            all_areas <- getContourRegions(spe, contour_name = cc)
            
            spe <- cellsInRegion(spe, all_areas, name_to = cc,
                                 NA_level = 0, levels = NULL)
            }
        }
    }
    
    return(spe)
}

#' Perform kernel density estimation on SpatialExperiment for
#' cell types of interest
#'
#' @param spe A SpatialExperiment object.
#' @param id A character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to cell_type by default. Set to NULL for overall density.
#' @param coi A character vector of cell types of interest (COIs).
#' Default to all cell types.
#' @param feature Feature(s) to calculate density with. Must be in rownames(spe).
#' @param assay Name of assay to use for finding feature(s).
#' @param kernel The smoothing kernel. Options are "gaussian",
#' "epanechnikov", "quartic" or "disc". For hexagonal grid, only Gaussian is implemented
#' @param bandwidth The smoothing bandwidth. By default performing
#' automatic bandwidth selection using cross-validation using
#' function spatstat.explore::bw.diggle.
#' @param ngrid.x Number of grids in the x-direction. Ignored when
#' 'grid.length.x' is specified. Default to NULL.
#' @param grid.length.x Grid length in the x-direction. If both 
#' 'ngrid.x' and 'grid.length.x' are NULL, then 'grid.length.x'
#' is set to 100 (micron) by default.
#' @param diggle Logical. If TRUE, use the Jones-Diggle improved edge
#' correction. See spatstat.explore::density.ppp() for details.
#' @param grid.type Type of grid can be either hexagon or square.
#' @param isVisium Logical. If TRUE, fit hexagonal grids to Visium spots by 
#' replacing spatial coords with array rows & array cols. 
#' @param filterToVisiumSpot Logical. If TRUE, filter grid polygons to only 
#' those with a Visium spot underneath.
#'
#' @return A SpatialExperiment object. Grid density estimates for
#' all cell type of interest are stored in spe@metadata$grid_density.
#' Grid information is stored in spe@metadata$grid_info
#'
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
gridDensity <- function(spe,
                        id = if (isVisium) NULL else "cell_type",
                        coi = NULL,
                        feature = NULL,
                        assay = "counts",
                        kernel = "gaussian",
                        bandwidth = NULL,
                        ngrid.x = NULL,
                        grid.length.x = NULL,
                        diggle = FALSE,
                        grid.type = c("hex", "square"),
                        isVisium = FALSE,
                        filterToVisiumSpot = isVisium) {
  grid.type <- match.arg(grid.type)
  
  # Checks for Visium
  if (isVisium) {
    if (grid.type == "square") {
      grid.type <- "hex"
      message("Switching grid.type to hex for Visium")
    }
    if (is.null(spe$array_col) || 
        is.null(spe$array_row) ||
        is.null(spe$in_tissue)) {
      stop("Visium must have array_col, array_row, and in_tissue in colData")
    }
    
    # Scale the distances between points to 100 units and straighten the row/col
    spe <- realignVisium(spe)
  }
  
  weights <- matrix(ncol=0,nrow=ncol(spe))
  # id weight
  if (!is.null(id)) {
    if (!id %in% colnames(colData(spe))) { 
      message(paste(id, "is not a column of the colData. Skipping",id))
    }
    if (!all(coi %in% unique(spe@colData[[id]]))) {
      stop(paste(
        paste0(coi[!coi %in% unique(spe@colData[[id]])],collapse = ", "), 
        "not found in data!"))
    }
    
    if (is.numeric(spe[[id]])) {
      w <- matrix(spe[[id]],ncol=1,dimnames=list(NULL,id))
      w[is.na(w)] <- 0
    } else { # One-hot matrix
      f <- as.factor(spe[[id]])
      w <- matrix(0,nrow=ncol(spe),ncol=nlevels(f),dimnames=list(NULL,levels(f)))
      for (i in seq_along(f)) {
        w[i,f[i]] = 1
      }
      if (!is.null(coi)) w <- w[,coi,drop=FALSE]
    }
    weights <- cbind(weights,w)
  }
  # features weight
  f_not <- !(feature %in% rownames(spe))
  if (any(f_not)) {
    message(paste(paste0(feature[f_not],collapse = ", "),
                  "not found in rownames. Skipping them"))
    feature <- feature[!f_not]
  }
  if (!is.null(feature)) {
    w <- t(as.matrix(SummarizedExperiment::assay(spe,assay)[feature,,drop=FALSE]))
    # w <- t(as.matrix(spe@assays@data[[assay]][feature,,drop=FALSE]))
    weights <- cbind(weights,w)
  }
  # overall weight
  if (isVisium) {
    weights <- cbind(weights,overall=spe$in_tissue)
  } else {
    weights <- cbind(weights,overall=rep.int(1,nrow(weights)))
  }
  clean_names <- paste("density",
                       janitor::make_clean_names(colnames(weights)),
                       sep="_")
  
  # Cells' coords
  spatialCoordsNames(spe) <- c("x_centroid", "y_centroid")
  coord <- spatialCoords(spe)
  xlim <- range(coord[,"x_centroid"])
  ylim <- range(coord[,"y_centroid"])
  
  # Grid size. If both are provided, use grid.length.x
  if (!is.null(ngrid.x) && !is.null(grid.length.x)) {
    ngrid.x <- NULL
  }
  ngrid.x <- ngrid.x %||% (diff(xlim)/(grid.length.x %||% 100))
  
  
  if (isVisium) {
    one_to_one <- isTRUE(all.equal(ngrid.x,diff(range(spe$array_col))/2))
    if (!one_to_one) {
      message("For Visium, grid.length.x should be a divisible by 100 to exactly align each spot to a hexagon")
    }
  }
    
    
  
  # Calculate bandwidth
  if (is.null(bandwidth)) {
    if (!is.null(spe@metadata$grid_info$bandwidth)) {
      bandwidth <- spe@metadata$grid_info$bandwidth
      message("Reusing existing bandwidth for kernel smoothing!")
    } else {
      pts <- ppp(coord[, 1], coord[, 2], xlim, ylim)
      bandwidth <- bw.diggle(pts) * 4
    }
  }
  
  # Reset when the function is rerun again
  # spe@metadata$grid_density <- spe@metadata$grid_info <- NULL
  densFunc <- `if`(grid.type=="hex",computeDensityHex,computeDensity)
  # Set up info about the grid
  res <- densFunc(x = coord,
                  kernel = kernel,
                  bandwidth = bandwidth,
                  ngrid.x = ngrid.x,
                  xlim = xlim,
                  ylim = ylim,
                  gridInfo = TRUE)
  spe@metadata$grid_density <- res$grid_density
  spe@metadata$grid_info <- res$grid_info
  # Add densities
  for (ii in seq_len(ncol(weights))) {
    spe@metadata$grid_density <- cbind(
      spe@metadata$grid_density,
      densFunc(x = coord,
               kernel = kernel,
               bandwidth = bandwidth,
               weights = weights[,ii],
               ngrid.x = ngrid.x,
               xlim = xlim,
               ylim = ylim,
               diggle = diggle))
    colnames(spe@metadata$grid_density)[ncol(spe@metadata$grid_density)] = clean_names[[ii]]
  }
  
  if (grid.type=="hex") {
    # Filter grid_density to same as Visium spot.
    if (filterToVisiumSpot && isVisium && one_to_one) {
      hcellsInTissue <- hexDensity::xy2hcell(x=coord,
                                             xbins=spe@metadata$grid_info$xbins,
                                             xbnds=xlim,
                                             ybnds=ylim,
                                             shape=spe@metadata$grid_info$shape)
      hcellsInTissue <- sort(unique(hcellsInTissue))
      spe@metadata$grid_density <- spe@metadata$grid_density[hcellsInTissue,]
      spe@metadata$grid_info$gridLevelAnalysis <- TRUE
    }
    
    if (isVisium) spe@metadata$grid_info$isVisium <- TRUE
  }
  
  return(spe)
}

test_that("gridDensity works", {
    data("xenium_bc_spe")

    spe1 <- gridDensity(spe)

    expect_equal(length(spe@metadata), 0)

    expect_gt(length(spe1@metadata), 0)

    expect_true("grid_density" %in% names(spe1@metadata))

    expect_true("grid_info" %in% names(spe1@metadata))

    expect_silent(gridDensity(spe, coi = c("Breast cancer", "Fibroblasts")))

    expect_error(gridDensity(spe, coi = c("breast cancer", "fibroblast")))

    expect_error(gridDensity(spe,
        coi = c("Breast cancer", "Fibroblasts"),
        id = "cell_typess"
    ))

    expect_error(gridDensity(spe, kernel = "xyz"))

    expect_silent(gridDensity(spe, bandwidth = 100))
})

test_that("getContour works", {
    data("xenium_bc_spe")
    spe <- gridDensity(spe)
    coi <- "Breast cancer"
    spe1 <- getContour(spe, coi = coi)

    expect_false("breast_cancer_contour" %in% names(spe@metadata))
    expect_true("breast_cancer_contour" %in% names(spe1@metadata))

    expect_error(getContour(spe, coi = "xyz"))
    expect_silent(getContour(spe, coi = coi, bins = 50, equal.cell=FALSE))
})

#' Draw a contour region on some density level
#'
#' @param spe A SpatialExperiment object.
#' @param contour Name in metadata.
#' @param cutoff A numeric scalar specifying the density cutoff.
#'
#' @return An sf object of the contour region of the specified level.
#'
contour2sf <- function(spe, contour, cutoff) {
    if (!requireNamespace("sf", quietly = TRUE)) stop("sf required but is not
                                                    available")
    if (!requireNamespace("lwgeom", quietly = TRUE)) stop("lwgeom required but
                                                        is not available")

    if (is.null(spe@metadata[[contour]])) stop("Have to calculate
                                             contours first!")

    clines <- as.data.frame(spe@metadata[[contour]])
    xlim <- range(clines$x)
    ylim <- range(clines$y)
    lims <- c(xmin = xlim[1], ymin = ylim[1], xmax = xlim[2], ymax = ylim[2])
    canvas_sf <- sf::st_sf(sf::st_as_sfc(sf::st_bbox(lims)))
    levs <- sort(unique(clines$cutoff))
    lev_code <- findInterval(cutoff, levs, rightmost.closed = FALSE)
    clines_lev <- clines[clines$cutoff == cutoff, c("x", "y", "piece")]
    # grid_area <- spe@metadata$grid_info$xstep * spe@metadata$grid_info$ystep

    dens_cols <- S4Vectors::metadata(spe@metadata[[contour]])$densities
    dens <- as.data.frame(spe@metadata$grid_density)
    dens$density_coi_average <- rowMeans(dens[, which(colnames(dens) %in%
        dens_cols),
    drop = FALSE
    ])

    # grid centroid points
    grids_pts_sf <- dens[, c(
        "node", "x_grid",
        "y_grid", "density_coi_average"
    )]
    grids_pts_sf <- sf::st_as_sf(grids_pts_sf, coords = c(
        "x_grid",
        "y_grid"
    ))

    # all pieces
    all_clines_sf <- lapply(unique(clines_lev$piece), function(pp) {
        line_piece <- clines_lev[clines_lev$piece == pp, ]
        sf::st_as_sf(line_piece, coords = c("x", "y")) |>
            sf::st_combine() |>
            sf::st_multilinestring() |>
            sf::st_combine()
    })
    names(all_clines_sf) <- unique(clines_lev$piece)

    clines_lev_sf <- lapply(names(all_clines_sf), function(pp) {
        line_piece_sf <- all_clines_sf[[pp]]
        # check if the region is at boundary
        bbox <- sf::st_bbox(line_piece_sf)
        bbox_sf <- sf::st_sf(sf::st_as_sfc(bbox))

        if (any(bbox == lims)) {
            # if the line intersects with parallel boundaries
            touch_which_boundary <- substr(names(bbox)[bbox == lims],
                start = 1,
                stop = 1
            )
            if (length(touch_which_boundary) >= 2L &
                any(table(touch_which_boundary) == 2L)) {
                bbox_parabound <- bbox_sf
            } else {
                bbox_parabound <- NULL
            }
            regions <- lwgeom::st_split(bbox_sf, line_piece_sf) |>
                sf::st_collection_extract("POLYGON")
            other_clines_ind <- which(names(all_clines_sf) != as.character(pp))
            if (length(other_clines_ind) > 0L) {
                other_clines_sf <- do.call(
                    rbind,
                    lapply(
                        all_clines_sf[other_clines_ind],
                        sf::st_sf
                    )
                )

                whether_cross <- c(sf::st_crosses(other_clines_sf,
                    bbox_sf,
                    sparse = FALSE
                ) |
                    sf::st_covered_by(other_clines_sf, bbox_sf,
                        sparse = FALSE
                    ))
                if (any(whether_cross)) {
                    sub_region_ind <- sf::st_intersects(regions,
                        other_clines_sf[
                            whether_cross,
                        ],
                        sparse = FALSE
                    )
                    sub_region_ind <- which(rowSums(sub_region_ind) > 0L)
                    subregions <- lapply(sub_region_ind, function(subr) {
                        lwgeom::st_split(
                            regions[sub_region_ind, ],
                            sf::st_combine(other_clines_sf[whether_cross, ])
                        ) |>
                            sf::st_collection_extract("POLYGON")
                    })
                    regions <- regions[-sub_region_ind, ]
                    regions <- rbind(do.call(rbind, subregions), regions)
                }
            }
            inds <- sf::st_intersects(regions, grids_pts_sf)
            if (any(sapply(inds, length) == 0L)) {
                ind_buffer <- which(sapply(inds, length) == 0L)
                regions_tmp <- regions
                regions_tmp[ind_buffer, ] <- sf::st_buffer(
                    regions_tmp[ind_buffer, ],
                    dist = `if`(spe@metadata$grid_info$grid_type == "hex",
                         diff(spe@metadata$grid_info$xlim)/spe@metadata$grid_info$xbins/2,
                         spe@metadata$grid_info$xstep/2
                    )
                )
                inds <- sf::st_intersects(regions_tmp, grids_pts_sf)
            }
            avglevel <- sapply(inds, function(ii) {
                mean(grids_pts_sf$density_coi_average[ii])
            })
            avglevel <- findInterval(avglevel, levs,
                rightmost.closed = FALSE
            )
            area_up <- regions[avglevel >= lev_code, ]
            area_down <- regions[avglevel < lev_code, ]
            sf::st_geometry(area_up) <- "area"
            sf::st_geometry(area_down) <- "area"
            area_up <- sf::st_sf(area_up)
            area_down <- sf::st_sf(area_down)
            cline_touches_bound <- TRUE
        } else {
            area <- sf::st_cast(line_piece_sf, "POLYGON")
            area <- sf::st_sf(area)
            inds <- sf::st_intersects(area, grids_pts_sf)
            if (any(sapply(inds, length) == 0L)) {
              ind_buffer <- which(sapply(inds, length) == 0L)
              area_tmp <- area
              area_tmp[ind_buffer, ] <- sf::st_buffer(
                area_tmp[ind_buffer, ],
                dist = `if`(spe@metadata$grid_info$grid_type == "hex",
                            diff(spe@metadata$grid_info$xlim)/spe@metadata$grid_info$xbins/2,
                            spe@metadata$grid_info$xstep/2
                )
              )
              inds <- sf::st_intersects(area_tmp, grids_pts_sf)
            }
            avglevel <- mean(grids_pts_sf$density_coi_average[unlist(inds)])
            avglevel <- findInterval(avglevel, levs,
                rightmost.closed = FALSE
            )
            if (avglevel >= lev_code) {
                area_up <- area
                area_down <- NULL
                bbox_parabound <- NULL
            } else {
                area_up <- NULL
                area_down <- area
                bbox_parabound <- NULL
            }
            cline_touches_bound <- FALSE
        }

        if (!is.null(area_up)) {
            area_up <- area_up[!is.na(sf::st_dimension(area_up)), ]
            if (nrow(area_up) == 0L) area_up <- NULL
        }
        if (!is.null(area_down)) {
            area_down <- area_down[!is.na(sf::st_dimension(area_down)), ]
            if (nrow(area_down) == 0L) area_down <- NULL
        }

        return(list(
            area_up = area_up,
            area_down = area_down,
            cline_touches_bound = cline_touches_bound,
            bbox_parabound = bbox_parabound
        ))
    })

    areas_up <- do.call(rbind, lapply(clines_lev_sf, "[[", "area_up"))
    areas_down <- do.call(rbind, lapply(clines_lev_sf, "[[", "area_down"))
    cline_touches_bound <- unlist(lapply(
        clines_lev_sf, "[[",
        "cline_touches_bound"
    ))
    bbox_parabound <- do.call(rbind, lapply(
        clines_lev_sf, "[[",
        "bbox_parabound"
    ))

    if (!is.null(areas_down)) {
        if (!is.null(areas_up)){
            areas_up_union <- sf::st_union(sf::st_make_valid(areas_up))
            out <- sf::st_covered_by(areas_down, areas_up_union, sparse = FALSE)
        } else {
            out <- sf::st_covered_by(areas_down, sparse = FALSE)
        }
        areas_down_out <- areas_down[c(out), ]
        if (nrow(areas_down_out) > 0L) {
            # flatten out overlaps
            downHasOverlap <- sf::st_intersection(areas_down_out)
            areas_down_out <- sf::st_sf(sf::st_geometry(downHasOverlap))
            # remove MULTILINESTRING
            areas_down_out <- areas_down_out[
                sf::st_geometry_type(areas_down_out) %in% c(
                    "POLYGON",
                    "MULTIPOLYGON"
                ),
            ]
            # check if downs are really down
            areas_down_out_code <- sapply(
                seq_len(nrow(areas_down_out)),
                function(xx) {
                    xx <- areas_down_out[xx, ]
                    inds <- sf::st_intersects(xx, grids_pts_sf)
                    avglevel <- sapply(inds, function(ii) {
                        mean(grids_pts_sf$density_coi_average[ii])
                    })
                    avglevel <- findInterval(avglevel, levs,
                        rightmost.closed = FALSE
                    )
                    return(avglevel)
                }
            )
            areas_down_out <- areas_down_out[areas_down_out_code < lev_code, ]
            areas_down_out <- sf::st_combine(areas_down_out)
            if (!is.null(areas_up)){
                areas <- sf::st_difference(areas_up_union, sf::st_make_valid(areas_down_out))
                # check if there is any missed area
                missed_up <- !sf::st_intersects(areas_up, areas, sparse = FALSE)
                if (any(missed_up)) {
                  areas <- sf::st_union(sf::st_sf(areas), areas_up[missed_up, ])
                }
            } else {
                areas <- areas_down_out
            }
        } else {
            areas <- sf::st_union(areas_up)
        }
    } else {
        areas <- sf::st_union(areas_up)
    }

    # if there are clines cross parallel boundaries of the canvas
    if (!is.null(bbox_parabound)) {
        # get regions outside the bbox(es)
        bbox_parabound <- sf::st_union(bbox_parabound)
        stripes <- sf::st_difference(canvas_sf, bbox_parabound)
        if (nrow(stripes) > 0L) {
            stripes <- sf::st_cast(stripes, to = "POLYGON")
            # for each polygon, remove the existing up areas, and see if the
            # rest of the region still has up regions
            stripes_up <- lapply(seq_len(nrow(stripes)), function(ss) {
                this_stripe <- stripes[ss, ]
                this_stripe_minus_up <- sf::st_difference(this_stripe, areas)
                this_stripe_minus_up <- sf::st_union(this_stripe_minus_up)
                this_stripe_minus_up <- sf::st_cast(this_stripe_minus_up,
                    to = "POLYGON"
                )
                this_stripe_minus_up <- sf::st_sf(this_stripe_minus_up)
                # if there are any other isolines crossing
                all_clines_sf_collapsed <- do.call(rbind, lapply(
                    all_clines_sf,
                    sf::st_sf
                ))
                whether_cross <- c(sf::st_crosses(all_clines_sf_collapsed,
                    sf::st_union(this_stripe_minus_up),
                    sparse = FALSE
                ))
                if (any(whether_cross)) {
                    sub_region_ind <- sf::st_intersects(this_stripe_minus_up,
                        all_clines_sf_collapsed[whether_cross, ],
                        sparse = FALSE
                    )
                    sub_region_ind <- which(rowSums(sub_region_ind) > 0L)
                    subregions <- lapply(sub_region_ind, function(subr) {
                        lwgeom::st_split(
                            this_stripe_minus_up[sub_region_ind, ],
                            sf::st_combine(
                                all_clines_sf_collapsed[whether_cross, ]
                            )
                        ) |>
                            sf::st_collection_extract("POLYGON")
                    })
                    this_stripe_minus_up <-
                        this_stripe_minus_up[-sub_region_ind, ]
                    this_stripe_minus_up <- rbind(
                        do.call(rbind, subregions),
                        this_stripe_minus_up
                    )
                }
                # check if any ups
                this_stripe_minus_up_code <- sapply(
                    seq_len(nrow(this_stripe_minus_up)),
                    function(xx) {
                        xx <- this_stripe_minus_up[xx, ]
                        inds <- sf::st_intersects(xx, grids_pts_sf)
                        avglevel <- sapply(inds, function(ii) {
                            mean(grids_pts_sf$density_coi_average[ii])
                        })
                        avglevel <- findInterval(avglevel, levs,
                            rightmost.closed = FALSE
                        )
                        return(avglevel)
                    }
                )
                this_stripe_still_up <- this_stripe_minus_up[
                    this_stripe_minus_up_code >= lev_code,
                ]
                return(this_stripe_still_up)
            })
            any_still_up <- sapply(stripes_up, nrow)
            #any_still_up <- sapply(stripes_up, function(ii) {
            #    is_empty <- sapply(1:nrow(ii), function(rr) {
            #        sf::st_is_empty(ii[rr, ]) + 0L
            #        })
            #    nrow(ii) - sum(is_empty)
            #    })
            if (any(any_still_up > 0L)) {
                stripes_up <- do.call(rbind, stripes_up)
                stripes_up <- sf::st_difference(
                    stripes_up,
                    sf::st_union(areas_down)
                )
            } else {
                stripes_up <- NULL
            }
        } else {
            stripes_up <- NULL
        }

        if (!is.null(stripes_up)) {
            areas <- sf::st_union(areas, stripes_up)
        }
    }

    if (any(cline_touches_bound)) {
        # check if there are any other up regions
        canvas_minus_areas <- sf::st_difference(
            canvas_sf,
            sf::st_union(sf::st_make_valid(areas))
        )
        if (!is.null(areas_down)) {
            canvas_minus_areas <- sf::st_difference(
                canvas_minus_areas,
                sf::st_union(sf::st_make_valid(areas_down))
            )
        }
        if (nrow(canvas_minus_areas) > 0L) {
            # if there are any other isolines crossing
            all_clines_sf_collapsed <- do.call(rbind, lapply(
                all_clines_sf,
                sf::st_sf
            ))
            whether_cross <- c(sf::st_crosses(all_clines_sf_collapsed,
                sf::st_buffer(sf::st_union(canvas_minus_areas),
                    dist = 0
                ),
                sparse = FALSE
            ))
            if (any(whether_cross)) {
                sub_region_ind <- sf::st_intersects(canvas_minus_areas,
                    all_clines_sf_collapsed[whether_cross, ],
                    sparse = FALSE
                )
                sub_region_ind <- which(rowSums(sub_region_ind) > 0L)
                subregions <- lapply(sub_region_ind, function(subr) {
                    lwgeom::st_split(
                        canvas_minus_areas[sub_region_ind, ],
                        sf::st_combine(
                            all_clines_sf_collapsed[whether_cross, ]
                        )
                    ) |>
                        sf::st_collection_extract("POLYGON")
                })
                canvas_minus_areas <- canvas_minus_areas[-sub_region_ind, ]
                canvas_minus_areas <- rbind(
                    do.call(rbind, subregions),
                    canvas_minus_areas
                )
            }
            # check if any ups
            canvas_minus_areas_code <- sapply(
                seq_len(nrow(canvas_minus_areas)),
                function(xx) {
                    xx <- canvas_minus_areas[xx, ]
                    inds <- sf::st_intersects(xx, grids_pts_sf)
                    if (length(unlist(inds)) == 0L) {
                        inds <- sf::st_intersects(
                            sf::st_buffer(xx,
                                dist = `if`(spe@metadata$grid_info$grid_type == "hex",
                                            diff(spe@metadata$grid_info$xlim)/spe@metadata$grid_info$xbins/2,
                                            spe@metadata$grid_info$xstep/2
                                )
                            ),
                            grids_pts_sf
                        )
                    }
                    avglevel <- sapply(inds, function(ii) {
                        mean(grids_pts_sf$density_coi_average[ii])
                    })
                    avglevel <- findInterval(avglevel, levs,
                        rightmost.closed = FALSE
                    )
                    return(avglevel)
                }
            )
            if (any(canvas_minus_areas_code >= lev_code)) {
                canvas_minus_areas_still_up <- canvas_minus_areas[
                    canvas_minus_areas_code >= lev_code,
                ]
                areas <- sf::st_union(areas, canvas_minus_areas_still_up)
            }
        }
        
    }

    areas <- sf::st_as_sf(sf::st_union(areas))
}

#' Plot grid from metadata. 
#'
#' @param spe A SpatialExperiment object.
#' @param group.by values to group polygons by. Must be in 
#' spe@metadata$grid_density, or colData(spe) if gridLevelAnalysis is TRUE. 
#' If NULL, will try with cols if available.
#' @param feature Feature to group polygons by. Must be in rownames(spe).
#' @param assay Name of assay to use for plotting feature.
#' @param type Transformation to apply for the group/feature. Options are "raw"
#' , "log", "cpm", "logcpm", or a function that accepts and returns a vector of 
#' the same length.
#' @param cols Colour palette. Can be a vector of colours or a function 
#' that accepts an integer n and return n colours.
#' @param pol.alpha alpha of points between 0 and 1.
#' @param pol.border Boolean. Whether to draw border for each polygon.
#' @param probs Numeric value between 0 and 1, used for filtering
#' uninformative grid. Only applicable for continuous values.
#' @param cutoff Numeric. Either a vector of length 2 for the lower & upper 
#' bounds of data to be included, or length 1 for the lower bound. Override 
#' probs if specified. Only applicable for continuous values.
#' @param label label for the legend
#' @param cols.scale vector of position for color if colors should not be 
#' evenly positioned. See \link[ggplot2]{scale_fill_gradientn}. Only applicable for continuous values.
#' @param reverseY Logical. Whether to reverse Y coordinates. Default is TRUE 
#' if the spe contains an image (even if not plotted) and FALSE if otherwise.
#' @param ... Parameters pass to \link[scider]{plotImage}
#' @return A ggplot object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' plotGrid(spe, group.by = "density_overall")
#'
plotGrid <- function(spe,
                     group.by = NULL,
                     feature = NULL,
                     assay = "counts",
                     type = c("raw","log","cpm","logcpm"),
                     cols = NULL,
                     pol.border = FALSE,
                     pol.alpha = 1,
                     probs = 0,
                     cutoff = NULL,
                     label = NULL,
                     cols.scale = NULL,
                     reverseY = NULL,
                     ...) {
  grid_data <- spe@metadata$grid_density
  if(!is.null(spe@metadata$grid_info$gridLevelAnalysis)) {
    grid_data <- c(grid_data,colData(spe))
  }
  
  
  group <- col.p <- NULL
  # Groups. Order is: grid_density -> colData -> assays -> cols
  if (!is.null(group.by) && group.by %in% colnames(grid_data)) {
    group <- grid_data[[group.by]]
    if (is.null(label)) label <- group.by
  } else if (!is.null(feature) && feature %in% rownames(spe)) {
    group <- SummarizedExperiment::assay(spe,assay)[feature,]
    if (is.null(label)) label <- feature
  } else if (!is.null(cols) && !is.function(cols)) {
    group <- factor(rep_len(cols,nrow(grid_data)),levels=unique(cols))
    col.p <- rep_len(unique(cols), length(unique(cols)))
  }
  
  # Type
  if (is.character(type)) {
    type <- switch(match.arg(type),
                   raw = NULL,
                   log = function(x) {log2(x+1)},
                   cpm = function(x) {
                     (x+0.5)/colSums(as.matrix(spe@assays@data[[assay]]))*1e6
                   },
                   logcpm = function(x) {
                     log2((x+0.5)/colSums(as.matrix(spe@assays@data[[assay]]))*1e6)
                   })
  }
  if(is.function(type)) {
    tryCatch({group <- type(group)},
             error = function(e){
               message("Error when applying 'type'. Skipping 'type'.")
             })
  }
  isContinuous <- is.numeric(group)
  
  # Filter
  if (isContinuous) {
    if (!is.null(cutoff)) {
      if (length(cutoff)==1) cutoff <- c(cutoff,max(group))
      kp <- group >= cutoff[1] & group <= cutoff[2]
    } else {
      kp <- group >= quantile(group, probs = probs)
    }
    group <- group[kp]
    grid_data <- grid_data[kp,]
  }
  
  # Colours
  if (!is.null(group) && is.null(col.p)) {
    n_colour <- length(unique(group))
    if (is.null(cols)) { # Default palette
      col.p <- `if`(isContinuous, col.spec, selectColor(n_colour))
    } else if (is.function(cols)) { # cols is function
      col.p <- cols(n_colour)
    } else { # cols is vector
      col.p <- `if`(isContinuous, cols, rep_len(cols,n_colour))
    }
  }

  # Plotting
  poly <- grid2df(spe, grid_data$node_x, grid_data$node_y,group = group)
  p <- plotImage(spe, reverseY=reverseY,...) + 
    geom_polygon(
      data = poly,
      aes(
        x=X,
        y=Y,
        group = L2,
        fill = group
      ),alpha=pol.alpha,
      color = if (pol.border) "black" else NA
    ) +
    theme_classic() +
    labs(x = "x", y = "y", fill = label)
  p <- update_bound(p,
                    x = spe@metadata$grid_info$xlim + c(-1,1)*spe@metadata$grid_info$xstep/2,
                    y = spe@metadata$grid_info$ylim + c(-1,1)*spe@metadata$grid_info$ystep/2)
  
  if (isContinuous) {
    p <- p + scale_fill_gradientn(colours = rev(col.p), limits=cutoff, values = cols.scale)
  } else {
    p <- p + scale_fill_manual(values = col.p)
  }
  return(p)
}

utils::globalVariables(c("X", "Y", "L1", "L2"))

#' Summarize a SpatialExperiment object at grid-level
#'
#' @param spe A SpatialExperiment object.
#' @param cell.count Logical. Whether to obtain the number of cells within 
#' each group identified by the 'id' column in colData(spe). Default to FALSE.
#' @param id A character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to 'cell_type' by default.
#' @param split.count.by A character. The name of the column of colData(spe). 
#' When it is not NULL, a grid-level count matrix is calculated for each member 
#' specified in that column of colData(spe) and stored in the assays(spe).
#' Set to 'cell_type' by default. 
#' 
#' @return A SpatialExperiment object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' spe_grid <- gridSPE(spe)
#'
gridSPE <- function(spe, cell.count = FALSE, id = 'cell_type', split.count.by = id) {
  if (!("grid_density" %in% names(spe@metadata))) {
    stop("Please run gridDensity before using this function.")
  }
  
  grid_data <- spe@metadata$grid_density[,(1:5)]
  rownames(grid_data) <- grid_data$node
  grid_info <- spe@metadata$grid_info
  assay_matrix <- as.matrix(spe@assays@data[["counts"]])

  #Get vector of which polygon each cell belong to
  xy_allcells <- SpatialExperiment::spatialCoords(spe)
  if(grid_info$grid_type=="hex") {
    poly_index <- hexDensity::xy2hcell(x=xy_allcells[,1],y=xy_allcells[,2],
                                       xbins=grid_info$xbins,
                                       xbnds=grid_info$xlim,
                                       ybnds=grid_info$ylim,
                                       shape=grid_info$shape)
  } else {
    rr <- (xy_allcells[,1]-grid_info$xlim[1])%/%grid_info$xstep
    rr <- pmin.int(rr,grid_info$dim[1]-1)
    cc <- (xy_allcells[,2]-grid_info$ylim[1])%/%grid_info$ystep
    cc <- pmin.int(cc,grid_info$dim[2]-1)
    poly_index <- (rr*grid_info$dims[2]+cc+1)
  }
  
  # Obtain gene counts at the grid level
  assays <- list()
  if(is.null(split.count.by)){
    assays$counts <- matrix(data=0,
                            nrow=nrow(spe),ncol=nrow(spe@metadata$grid_density),
                            dimnames = list(rownames(spe)))
    
    aggCounts <- colsum(assay_matrix, poly_index, reorder = FALSE)
    assays$counts[,unique(poly_index)] <- aggCounts
  } else {
    split_names <- names(table(spe@colData[[split.count.by]]))
    split_names_clean <- janitor::make_clean_names(split_names)
    for(i in seq_along(split_names)){
      sub <- spe@colData[[split.count.by]] == split_names[i]
      assays[[i+1]] <- matrix(data=0,
                              nrow=nrow(spe),ncol=nrow(spe@metadata$grid_density),
                              dimnames = list(rownames(spe)))
      aggCounts <- colsum(assay_matrix[,sub], poly_index[sub], reorder = FALSE)
      assays[[i+1]][,unique(poly_index[sub])] <- aggCounts
    }
    assays[[1]] <- Reduce(`+`, assays[-1])
    names(assays) <- c("counts", paste0("counts_", split_names_clean))
  }
  
  # Obtain cell type counts at the grid level
  if(cell.count){
    # Sorting is just for backward consistency
    cell_type_names <- janitor::make_clean_names(sort(unique(spe@colData[[id]])))

    poly_counts <- matrix(0,nrow(spe@metadata$grid_density),length(cell_type_names),
                          dimnames=list(NULL,cell_type_names))
    cell_types <- as.numeric(factor(spe@colData[[id]]))

    for (i in 1:ncol(spe)) {
      poly_counts[poly_index[i],cell_types[i]] <- poly_counts[poly_index[i],cell_types[i]] + 1
    }
    poly_counts <- cbind(poly_counts, overall=rowSums(poly_counts))
    grid_data$cell_count <- S4Vectors::DataFrame(poly_counts)
  }
  grid_data$LibSize <- colSums(assays[[1]])
  grid_data$nGenes <- colSums(assays[[1]]!=0)
  
  spe_out <- SpatialExperiment::SpatialExperiment(assays = assays,
                                                  colData = grid_data,
                                                  rowData = SummarizedExperiment::rowData(spe),
                                                  spatialCoordsNames = c("x_grid", "y_grid"))
  
  spe_out@metadata <- spe@metadata
  spe_out@metadata$grid_info$gridLevelAnalysis <- TRUE
  
  return(spe_out)
}

#' @useDynLib scider, .registration=TRUE
#' @import ggplot2
#' @importFrom methods is
#' @import shiny
#' @import utils
#' @importFrom plotly plot_ly
#' @importFrom plotly renderPlotly
#' @importFrom plotly add_markers
#' @importFrom plotly layout
#' @importFrom plotly event_data
#' @importFrom SummarizedExperiment colData
#' @import SpatialExperiment
#' @import knitr
#' @importFrom spatstat.geom ppp
#' @importFrom spatstat.explore density.ppp
#' @importFrom spatstat.explore bw.diggle
#' @importFrom grDevices colorRampPalette
#' @importFrom stats cor.test
#' @importFrom stats pchisq
#' @importFrom stats quantile
#' @importFrom stats reshape

NULL

#' @keywords internal 
"_PACKAGE"

#' Spatial cell-type inter-correlation by density in R.
#'
#' `scider` implements functions to analyse spatial transcriptomics data with
#' cell type annotations by performing cell type correlation via density
#' estimation and cell type co-localization via real number distance.
#' Functions include density estimation, statistical modelling and
#' visualizations.
#'
#' `scider` uses SpatialExperiment objects as the main infrastructure,
#' which can easily be integrated with a wide variety
#' of Bioconductor packages.
#'
#'
#' @author Ning Liu \email{liu.n@@wehi.edu.au},
#' Mengbo Li \email{li.me@@wehi.edu.au},
#' Yunshun Chen \email{yuchen@@wehi.edu.au},
#' Quoc Hoang Nguyen \email{nguyen.q@@wehi.edu.au}
#' @name scider-package
#' @aliases scider scider-package
#' @keywords internal
#'
NULL


#' Description of the scider example datasets
#'
#' scider-package has 1 datasets: \itemize{
#'   \item xenium_bc_spe Example test spatial transcriptomics data
#'   in SpatialExperiment format. This test data is randomly subsetting
#'   from a publicly available 10X Xenium breast cancer data.
#'   Source data: https://www.10xgenomics.com/resources/datasets/xenium-ffpe-human-breast-with-custom-add-on-panel-1-standard
#'  }
#'
#' @docType data
#' @name xenium_bc_spe
#' @usage data("xenium_bc_spe")
#' @return A SpatialExperiment object
#' @keywords internal
#' @format A SpatialExperiment object
#' @examples
#' data(xenium_bc_spe)
"spe"

#' Subset for grid level analysis
#'
#' Overwrite the default SpatialExperiment subsetting method to ensure 
#' 'grid_density' is also subsetted if 'gridLevelAnalysis' is TRUE (1 polygon 1 spot)
#' @param x A SpatialExperiment object.
#' @param i row indices for subsetting.
#' @param j col indices for subsetting.
#' @param ... further arguments to be passed to or from other methods.
#' @param drop passed on to [ indexing operator.
#' 
#' @return A SpatialExperiment object.
#'
#' @export
setMethod("[",
          c("SpatialExperiment", "ANY", "ANY"),
          function(x, i, j, ..., drop=FALSE) {
            if (missing(i)) i <- TRUE
            if (missing(j)) j <- TRUE
            x <- methods::callNextMethod()
            if ( !S4Vectors::isEmpty(SpatialExperiment::imgData(x)) ) {
              keep <- SpatialExperiment::imgData(x)$sample_id %in% unique(x$sample_id)
              SpatialExperiment::imgData(x) <- SpatialExperiment::imgData(x)[keep, ]
            }
            
            if (!is.null(x@metadata$grid_info$gridLevelAnalysis)) {
              x@metadata$grid_density <- x@metadata$grid_density[j,]
            }
            return(x)
          }
)

#' Get contour from density
#'
#' @param spe A SpatialExperiment object.
#' @param coi A character vector of cell types of interest (COIs).
#' All cell types are chosen if NULL or `overall`.
#' @param equal.cell Logical. Whether to use produce contour levels so that
#' there are roughly the same number of cells of the COI at each level. 
#' Default to TRUE.
#' @param bins An integer. Number of contour levels.
#' @param binwidth A numeric scale of the smoothing bandwidth.
#' @param breaks A numeric scale referring to the breaks in
#' `ggplot2:::contour_breaks`.
#' @param id A character. The name of the column of colData(spe) containing
#' the cell type identifiers. Set to cell_type by default or in_tissue if spe 
#' is Visium. Only needed when \code{equal.cell = TRUE}. 
#'
#' @return A SpatialExperiment object. An sf object of the contour region of
#' the specified level is stored in the metadata of the
#' SpatialExperiment object.
#' @export
#'
#' @examples
#'
#' data("xenium_bc_spe")
#'
#' spe <- gridDensity(spe)
#'
#' coi <- "Breast cancer"
#'
#' spe <- getContour(spe, coi = coi)
#'
getContour <- function(spe, coi = NULL, equal.cell = TRUE, bins = NULL,
                       binwidth = NULL, breaks = NULL, 
                       id = NULL) {
    if (is.null(spe@metadata$grid_density)) {
        stop("Have to calculate grid density, run gridDensity() first!")
    }
    grid_info <- spe@metadata$grid_info
    

    coi_clean <- `if`(is.null(coi),"overall",cleanName(coi))
    dens_cols <- paste("density", coi_clean, sep = "_")
    if (!all(dens_cols %in% colnames(spe@metadata$grid_density))) {
      stop("Density of COI not computed yet.")
    }
    
    # grid level density data
    dens <- spe@metadata$grid_density
    dups <- duplicated(dens[, c("y_grid", "x_grid"), drop = FALSE],
        fromLast = TRUE
    )
    dens <- dens[!dups, , drop = FALSE]
    dens <- as.data.frame(dens)

    if (!all(dens_cols %in% colnames(dens))) {
        stop("Density of COI is not yet computed.")
    }

    if (length(dens_cols) > 1L) {
        message("Finding contour using total density of input COIs. ")
        dens$density_coi <- rowSums(dens[, which(colnames(dens) %in%
            dens_cols),
        drop = FALSE
        ])
    } else {
        dens$density_coi <- dens[, dens_cols]
    }
    
    dens <- dens[, c(seq_len(5), which(colnames(dens) ==
        "density_coi"))]

    # filter out negative densities when calculating contours
    dens <- dens[dens$density_coi > 0L, ]

    # levels for contour
    if (!equal.cell) {
        if (is.null(bins) && is.null(binwidth) && is.null(breaks)) {
        message("Using bins = 10 to draw contours.")
        bins <- 10L
        }
        if (!is.null(bins)) binwidth <- breaks <- NULL
        if (is.null(bins) && !is.null(binwidth)) breaks <- NULL
    } else {
        # calculate density level breaks to get roughly the same number of cells at each level
        if (is.null(bins)) {
            message("Using bins = 10 to draw contours with equal cell numbers.")
            bins <- 10L
            binwidth <- breaks <- NULL
        } else {
            message(paste("Using bins =", bins, "to draw contours with equal cell numbers.", sep = " "))
        }
        ## count no of cells of coi in each grid
        ## note this no can be very different from the expected no
        coi_coords <- as.data.frame(spatialCoords(spe))
        
        # Filter for relevant cells belonging to id if coi is a factor of id.
        if (!is.null(coi)) {
          if (!is.null(id) && !(id %in% colnames(colData(spe)))) {
            stop(paste(id,"is not a column of colData(spe)."))
          }
          id_missing <- is.null(id)
          id <- id %||% "cell_type"
          if (all(coi %in% colData(spe)[[id]])) {
            coi_coords <- coi_coords[colData(spe)[[id]] %in% coi, ]
          } else if (!id_missing) {
            stop(paste0(coi," not found in colData(spe)$",id))
          }
        }

        if (spe@metadata$grid_info$grid_type == "hex") {
          hcellsID <- hexDensity::xy2hcell(x=coi_coords$x_centroid,y=coi_coords$y_centroid,
                                           xbins=grid_info$xbins,
                                           xbnds=grid_info$xlim,
                                           ybnds=grid_info$ylim,
                                           shape=grid_info$shape)
          coi_coords$hcellsID <- hcellsID
          coi_coords$x_node <- (hcellsID-1)%%grid_info$dims[1]+1
          coi_coords$y_node <- (hcellsID-1)%/%grid_info$dims[1]+1
        } else {
          coi_coords$x_node <- vapply(coi_coords$x_centroid, function(xx) {
              which.min(abs(grid_info$xcol - xx))
          }, numeric(1))
          coi_coords$y_node <- vapply(coi_coords$y_centroid, function(yy) {
              which.min(abs(grid_info$yrow - yy))
          }, numeric(1))
        }
        coi_coords$node <- paste(coi_coords$x_node, coi_coords$y_node, sep = "-")
        freq <- c(table(coi_coords$node))
        dens$n <- freq[dens$node]
        dens$n <- ifelse(is.na(dens$n), 0L, dens$n)
        dens_expanded <- rep(dens$density_coi, times = dens$n)
        dens_expanded <- dens_expanded[dens_expanded > 0L]
        qq <- seq(0, 1, length.out = bins + 1)[-1]
        if (qq[length(qq)] == 1L) qq <- qq[-length(qq)]
        breaks <- as.vector(quantile(dens_expanded, probs = qq))
        binwidth <- bins <- NULL
    }
    

    # note that when calculating contours, density is not filtered at any
    # quantile cutoff!

    contour <- compute_group0(dens,
        z.range = range(dens$density_coi, na.rm = TRUE, finite = TRUE),
        bins = bins,
        binwidth = binwidth,
        breaks = breaks,
        na.rm = FALSE,
        grid_type = grid_info$grid_type
    )

    contour$level <- as.factor(as.numeric(as.factor(contour$cutoff)))
    
    coi_clean <- paste(c(coi_clean,"contour"), collapse="_")
    contour <- S4Vectors::DataFrame(contour)
    S4Vectors::metadata(contour) <- list(densities = dens_cols)
    spe@metadata[[coi_clean]] <- contour

    return(spe)
}



#### lower level functions for computing the contours.
# compute contour groups (grabbed from ggplot2)
xyz_to_isolines_square <- function(data, breaks) {
  # Convert vector of data to raster z
  x_pos <- as.integer(factor(data$x_grid,
                             levels =
                               sort(unique00(data$x_grid))
  ))
  y_pos <- as.integer(factor(data$y_grid,
                             levels =
                               sort(unique00(data$y_grid))
  ))
  nrow <- max(y_pos)
  ncol <- max(x_pos)
  z <- matrix(NA_real_, nrow = nrow, ncol = ncol)
  z[cbind(y_pos, x_pos)] <- data$density_coi
  
    isoband::isolines(
        x = sort(unique00(data$x_grid)),
        y = sort(unique00(data$y_grid)),
        z = z,
        levels = breaks
    )
}
xyz_to_isolines_hex <- function(data, breaks) {
  x.coords <- sort(unique00(data$x_grid))
  x.coords.left <- x.coords[seq.int(1,length(x.coords),2)]
  x.coords.right <- x.coords[seq.int(2,length(x.coords),2)]
  y.coords <- sort(unique00(data$y_grid))
  # Convert vector of data to raster
  ncol <- diff(range(data$node_x))+1
  nrow <- diff(range(data$node_y))+1
  z <- matrix(NA_real_, nrow = nrow, ncol = ncol)
  z[cbind(data$node_y, data$node_x)] <- data$density_coi
  isolines <- hexDensity::meanderingTriangles(x.coords.left,x.coords.right,
                                              y.coords,z,breaks)

  return(isolines)
}

iso_to_path <- function(iso, group = 1) {
    lengths <- vapply(iso, function(x) length(x$x), integer(1))

    if (all(lengths == 0)) {
        message("Zero contours were generated.")
        return(data_frame00())
    }

    levels <- names(iso)
    xs <- unlist(lapply(iso, "[[", "x"), use.names = FALSE)
    ys <- unlist(lapply(iso, "[[", "y"), use.names = FALSE)
    ids <- unlist(lapply(iso, "[[", "id"), use.names = FALSE)
    item_id <- rep(seq_along(iso), lengths)

    # Add leading zeros so that groups can be properly sorted
    groups <- paste(group, sprintf("%03d", item_id), sprintf("%03d", ids),
        sep = "-"
    )
    groups <- factor(groups)

    data_frame00(
        level = rep(levels, lengths),
        x = xs,
        y = ys,
        piece = as.integer(groups),
        group = groups,
        .size = length(xs)
    )
}

compute_group0 <- function(data, z.range, bins = NULL,
                          binwidth = NULL, breaks = NULL, na.rm = FALSE,
                          grid_type) {
    breaks <- contour_brks(z.range, bins, binwidth, breaks)
    isolines <- `if` (grid_type=="hex",
                      xyz_to_isolines_hex(data, breaks),
                      xyz_to_isolines_square(data, breaks))
    path_df <- iso_to_path(isolines, data$group[1])
    path_df$cutoff <- as.numeric(path_df$level)
    # path_df$level <- as.numeric(path_df$level)
    # path_df$nlevel <- scales::rescale_max(path_df$level)
    path_df
}

---
title: "A quick start guide to the scider package"
author: "Mengbo Li, Ning Liu, Quoc Hoang Nguyen and Yunshun Chen"
date: "`r Sys.Date()`"
output: 
  html_document:
    toc: true
    number_sections: true
    theme: cosmo
    highlight: tango
    code_folding: show
vignette: >
  %\VignetteIndexEntry{scider_introduction}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<style type="text/css">
  body{
  font-size: 12pt;
}
</style>

```{r message=FALSE, warning=FALSE, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, message = FALSE, warning = FALSE, dpi = 72)
suppressWarnings(library(ggplot2))
suppressMessages(library(scider))
suppressMessages(library(SpatialExperiment))

setClassUnion("ExpData", c("matrix", "SummarizedExperiment"))
```

scider is an user-friendly R package providing functions to model 
the global density of cells in a slide of spatial transcriptomics 
data. All functions in the package are built based on the 
SpatialExperiment object, allowing integration into various 
spatial transcriptomics-related packages from Bioconductor. 
After modelling density, the package allows for serveral 
downstream analysis, including colocalization analysis, 
boundary detection analysis and differential density analysis.

# Installation

```{r eval=FALSE}
if (!require("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("scider")
```

The development version of `scider` can be installed from GitHub:

```{r eval=FALSE}
devtools::install_github("ChenLaboratory/scider")
```

# Quick start

```{r}
library(scider)
library(SpatialExperiment)
```


# Load data

In this vignette, we will use a subset of a Xenium Breast Cancer dataset.

```{r}
data("xenium_bc_spe")
```

In the data, we have quantification of 541 genes from 10000 cells.

```{r}
spe
```

We also have cell-type annotations of these cells, there are 4 cell types.

```{r}
table(colData(spe)$cell_type)
```

We can use the function `plotSpatial` to visualise the cell position and 
color the cells by cell types.

```{r, fig.width=5, fig.height=4}
plotSpatial(spe, group.by = "cell_type", pt.alpha = 0.8)
```


# Grid-based analysis

`scider` can conduct grid-based density analysis for spatial transcriptomics 
data.

## Density calculation

We can perform density calculation for each cell type using function `gridDensity`.
The calculated density and grid information are saved in the metadata of the 
SpatialExperimnet object.
```{r}
spe <- gridDensity(spe)
names(metadata(spe))
```
```{r}
metadata(spe)$grid_density
```

We can visualise the overall cell density of the whole tissue using function `plotDensity`.
```{r, fig.width=5, fig.height=4}
plotDensity(spe)
```

We can also visualise the density of individual cell type, e.g., fibroblast cells.
```{r, fig.width=5, fig.height=4}
plotDensity(spe, coi = "Fibroblasts")
```


## Find Regions-of-interest (ROIs)

After obtaining grid-based density for each COI, we can then detect 
regions-of-interest (ROIs) based on density or select by user.

### Detected by algorithm

To detect ROIs automatically, we can use the function `findROI`.

The detected ROIs are saved in the metadata of the SpatialExperiment object.

Here we identify ROIs based on the fibroblasts cell density.
```{r}
spe <- findROI(spe, coi = "Fibroblasts")
metadata(spe)$fibroblasts_roi
```

We can visualise the ROIs with function `plotROI`.
```{r, fig.width=5, fig.height=5}
plotROI(spe, roi = "Fibroblasts")
```

### Select ROI by user

Alternatively, users can select ROIs based on their own 
research interest (drawn by hand).
This can be done using function `selectRegion`.
This function will open an interactive window with an interactive plot for 
users to zoom-in/-out and select ROI using either a rectangular or lasso 
selection tool. Users can also press the `Export selected points` button to 
save the ROIs as object in the R environment.

```{r, eval=FALSE}
selectRegion(metadata(spe)$grid_density, x.col = "x_grid", y.col = "y_grid")
```

After closing the interactive window, the selected ROI has been saved as 
a data.frame object named `sel_region` in the R environment.

```{r, eval=FALSE}
sel_region
```

We can then use the `postSelRegion` to save the ROI in the metadata of 
the SpatialExperiment object.

```{r, eval=FALSE}
spe1 <- postSelRegion(spe, sel_region = sel_region)
metadata(spe1)$roi
```

Similarly, we can plot visualise the user-defined ROI with function `plotROI`.

```{r, eval=FALSE}
plotROI(spe1)
```

## Testing relationship between cell types

After defining ROIs, we can then test the relationship between any two 
cell types within each ROI or overall but account for ROI variation using 
a cubic spline or a linear fit. This can be done with function `corrDensity`.

```{r}
results <- corDensity(spe, roi = "Fibroblasts")
```

We can see the correlation between each pair of cell types in each fibroblasts ROI.

```{r}
results$ROI
```

Or the correlation between each pair of cell types across all fibroblasts ROI:

```{r}
results$overall
```


We can also visualise the fitting using function `plotDensCor`.

```{r, fig.width=8, fig.height=6}
plotDensCor(spe, celltype1 = "Breast cancer", celltype2 = "Fibroblasts")
```

Or, we can visualise the statistics between each pair of cell types using 
function `plotCorHeatmap` in the ROIs: 


```{r, fig.width=7, fig.height=4}
plotCorHeatmap(results$ROI)
```

Or the correlation between cell type pairs across the whole slide:

```{r, fig.width=7, fig.height=4}
plotCorHeatmap(results$overall)
```


# Cell-based analysis

Based on the grid density, we can ask many biological question about the data. 
For example, we would like to know if a certain cell type that are located in 
high density of fibroblast cells are different to the same cell type from 
a different level of fibroblast region.

## cell annotation based on grid density

To address this question, we first need to divide cells into different 
levels of grid density. This can be done using a contour identification 
strategy with function `getContour`.


```{r}
spe <- getContour(spe, coi = "Fibroblasts", equal.cell = TRUE)
```

Different level of contour can be visualised with cells using `plotContour`.

```{r, fig.width=5, fig.height=4}
plotContour(spe, coi = "Fibroblasts")
```


We can then annotate cells by their locations within each contour 
using function `allocateCells`.


```{r}
spe <- allocateCells(spe)
```


```{r, fig.width=6, fig.height=4}
plotSpatial(spe, group.by = "fibroblasts_contour", pt.alpha = 0.5)
```

We can visualise cell type composition per level.

```{r, fig.width=6, fig.height=4}
plotCellCompo(spe, contour = "Fibroblasts")
```


```{r, fig.width=7, fig.height=5}
plotCellCompo(spe, contour = "Fibroblasts", roi = "Fibroblasts")
```


```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findNbrsSNN.R
\name{findNbrsSNN}
\alias{findNbrsSNN}
\title{Construct a SNN neighbour list from assay.}
\usage{
findNbrsSNN(
  spe,
  assay = NULL,
  dimred = "PCA",
  n_dimred = 10,
  k = 20,
  BNPARAM = BiocNeighbors::AnnoyParam(),
  type = c("rank", "number", "jaccard"),
  nbrs_name = NULL,
  cpu_threads = 6
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{assay}{Name of assay for clustering. Incompatible with dimred.}

\item{dimred}{Name of the dimensionality reduction (e.g. PCA) for clustering.
Incompatible with assay}

\item{n_dimred}{Integer scalar or vector specifying the dimensions to use if dimred is specified.}

\item{k}{Integer scalar for number of nearest neighbors to find.}

\item{BNPARAM}{\link[BiocNeighbors]{BiocNeighborParam} object specifying the nearest neighbor algorithm. Default is Annoy.}

\item{type}{Type of weighting scheme for shared neighbors. Options are rank, number, and jaccard.
type="rank" is defined in Xu and Su (2015).}

\item{nbrs_name}{Name of the neighbour list to be stored in spe. Default to be
assay/dimred + "_snn".}

\item{cpu_threads}{Number of cpu threads for parallel computation.}
}
\value{
A spe with the clusters stored in \link[SingleCellExperiment]{reducedDims}.

A SpatialExperiment object
}
\description{
Construct a SNN neighbour list from assay.
}
\details{
Construct a SNN neighbour list using either the spe's assay or reduced
dimension and store it in spe@metadata$nbrs$cell

neighbour list contain
}
\examples{

data("xenium_bc_spe")
spe <- runPCA(spe)
spe <- findNbrsSNN(spe,dimred="PCA")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridSPE.R
\name{gridSPE}
\alias{gridSPE}
\title{Summarize a SpatialExperiment object at grid-level}
\usage{
gridSPE(spe, cell.count = FALSE, id = "cell_type", split.count.by = id)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{cell.count}{Logical. Whether to obtain the number of cells within
each group identified by the 'id' column in colData(spe). Default to FALSE.}

\item{id}{A character. The name of the column of colData(spe) containing
the cell type identifiers. Set to 'cell_type' by default.}

\item{split.count.by}{A character. The name of the column of colData(spe).
When it is not NULL, a grid-level count matrix is calculated for each member
specified in that column of colData(spe) and stored in the assays(spe).
Set to 'cell_type' by default.}
}
\value{
A SpatialExperiment object.
}
\description{
Summarize a SpatialExperiment object at grid-level
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

spe_grid <- gridSPE(spe)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/realignVisium.R
\name{realignVisiumHD}
\alias{realignVisiumHD}
\title{Scale and straighten out VisiumHD coordinates}
\usage{
realignVisiumHD(spe, distPoint = NULL)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{distPoint}{Numeric. Desired point to point distance. If NULL, will try
to determine the bin level of spe and use that.}
}
\description{
Scale and straighten out VisiumHD coordinates
}
\details{
This function rescale the distance between points to 8um (or other
value) to matchthe real distance. In addition, Visium spots have a slight
tilt to them which this function will also fix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moran.R
\name{localMoran}
\alias{localMoran}
\title{Calculate local Moran for 1 to 2 variables.}
\usage{
localMoran(
  spe,
  data1,
  data2 = data1[],
  at = c("grid", "cell"),
  nbrs_name = NULL,
  hhonly = FALSE,
  significance_cutoff = 0.05,
  permutations = 999,
  seed = 123456789,
  cpu_threads = 6
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{data1}{Numeric vector 1. Must be same length as number of grid points
or cells, depending on 'at'.}

\item{data2}{Numeric vector 2 for bivariate local Moran. Must be same length as data1.}

\item{at}{Option of grid or cell for where to look for neighbour list}

\item{nbrs_name}{Name of the neighbour list in \code{spe@metadata$grid[[at]]}
for Moran's I. If NULL, will use the newest neighbour list.}

\item{hhonly}{Only high-high clusters, which is more interpretable. Other
clusters (e.g. "Low-Low","High-Low",...) will be assigned as undefined.}

\item{significance_cutoff}{Cutoff for p-value to filter non-significant clusters}

\item{permutations}{Number of permutations for p-value.}

\item{seed}{Integer. For random permutations.}

\item{cpu_threads}{The number of cpu threads used for parallel computation.}
}
\value{
List of lisa_value, clusters, and pseudo p-value.
}
\description{
Calculate local Moran for 1 to 2 variables.
}
\examples{
data("xenium_bc_spe")

## At grid.
spe <- gridDensity(spe, coi = "Breast cancer")
dat <- spe@metadata$grid_density$density_breast_cancer
spe <- findNbrsGrid(spe)
res <- localMoran(spe,data1=dat, at = "grid")

## At cell.
dat <- as.numeric(spe$cell_type=="Breast cancer")
spe <- findNbrsSpatial(spe,k=20)
res <- localMoran(spe,data1=dat,at="cell")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subset.R
\name{[,SpatialExperiment,ANY,ANY,ANY-method}
\alias{[,SpatialExperiment,ANY,ANY,ANY-method}
\title{Subset for grid level analysis}
\usage{
\S4method{[}{SpatialExperiment,ANY,ANY,ANY}(x, i, j, ..., drop = FALSE)
}
\arguments{
\item{x}{A SpatialExperiment object.}

\item{i}{row indices for subsetting.}

\item{j}{col indices for subsetting.}

\item{...}{further arguments to be passed to or from other methods.}

\item{drop}{passed on to [ indexing operator.}
}
\value{
A SpatialExperiment object.
}
\description{
Overwrite the default SpatialExperiment subsetting method to ensure
'grid_density' is also subsetted if 'gridLevelAnalysis' is TRUE (1 polygon 1 spot)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCellCompo.R
\name{plotCellCompo}
\alias{plotCellCompo}
\title{Plot cell type composition in each density level of cell of interest.}
\usage{
plotCellCompo(
  spe,
  contour = NULL,
  id = "cell_type",
  roi = NULL,
  self.included = TRUE
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{contour}{A character vector of cell type(s) on which the
contour density level is calculated. If NULL, it looks for
'overall_contour' in colData(spe). Default to NULL.}

\item{id}{A character. The name of the column of colData(spe)
containing the cell type identifiers. Set to 'cell_type' by default.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. Default is NULL for no plotting by ROI}

\item{self.included}{Logical. Whether to include all the cell types in the plot.
Default to TRUE. If FALSE, the cell types specified in 'contour' will not
be included in the plot.}
}
\value{
A ggplot object.
}
\description{
Plot cell type composition in each density level of cell of interest.
}
\examples{

data("xenium_bc_spe")
coi <- "Breast cancer"
spe <- gridDensity(spe, coi = coi)
spe <- findROI(spe, coi = coi)
spe <- getContour(spe, coi = coi)
spe <- allocateCells(spe, contour = coi)
plotCellCompo(spe, contour = "Breast cancer")
plotCellCompo(spe, contour = "Breast cancer", roi = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeROI.R
\name{mergeROI}
\alias{mergeROI}
\title{Manually merge ROIs}
\usage{
mergeROI(
  spe,
  roi = NULL,
  merge.list = NULL,
  remove.ids = NULL,
  id = "component",
  rename = FALSE
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. All cell types are chosen if NULL or 'overall'.}

\item{merge.list}{A (named) list of vectors of ROI ids to be merged.
Each vector in the list should be of length greater than or
equal to 2. If no name is specified, the merged ROI will be
named by concatenating ROIs being merged.}

\item{remove.ids}{Optional. A vector of ROI ids to be removed.}

\item{id}{Character. The name of the column in \code{spe@metadata$roi}
that stores the ROIs to be merged. Default is "component".}

\item{rename}{Logical. If TRUE, names of merge.list are ignored.
ROIs will be given a new name. For the unmerged ROIs, their new
names are not necessarily the same as those before merging.}
}
\value{
A SpatialExperiment object.
}
\description{
Manually merge ROIs
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi, method = "walktrap")

spe <- mergeROI(spe, roi = coi, list("1-2" = 1:2))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scider-package.R
\docType{package}
\name{scider-package}
\alias{scider-package}
\alias{scider}
\title{scider: Spatial cell-type inter-correlation by density in R}
\description{
scider is an user-friendly R package providing functions to model the global density of cells in a slide of spatial transcriptomics data. All functions in the package are built based on the SpatialExperiment object, allowing integration into various spatial transcriptomics-related packages from Bioconductor. After modelling density, the package allows for serveral downstream analysis, including colocalization analysis, boundary detection analysis and differential density analysis.

\code{scider} implements functions to analyse spatial transcriptomics data with
cell type annotations by performing cell type correlation via density
estimation and cell type co-localization via real number distance.
Functions include density estimation, statistical modelling and
visualizations.
}
\details{
\code{scider} uses SpatialExperiment objects as the main infrastructure,
which can easily be integrated with a wide variety
of Bioconductor packages.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/ChenLaboratory/scider}
  \item \url{https://chenlaboratory.github.io/scider/}
  \item Report bugs at \url{https://github.com/ChenLaboratory/scider/issues}
}

}
\author{
\strong{Maintainer}: Yunshun Chen \email{yuchen@wehi.edu.au} (\href{https://orcid.org/0000-0003-4911-5653}{ORCID})

Authors:
\itemize{
  \item Mengbo Li \email{li.me@wehi.edu.au} (\href{https://orcid.org/0000-0002-9666-5810}{ORCID})
  \item Ning Liu \email{liu.n@wehi.edu.au} (\href{https://orcid.org/0000-0002-9487-9305}{ORCID})
  \item Quoc Hoang Nguyen \email{nguyen.q@wehi.edu.au} (\href{https://orcid.org/0009-0007-2828-7567}{ORCID})
}


Ning Liu \email{liu.n@wehi.edu.au},
Mengbo Li \email{li.me@wehi.edu.au},
Yunshun Chen \email{yuchen@wehi.edu.au},
Quoc Hoang Nguyen \email{nguyen.q@wehi.edu.au}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/postSelRegion.R
\name{postSelRegion}
\alias{postSelRegion}
\title{Merge sel_region from the selectRegion function to SpatialExperiment.}
\usage{
postSelRegion(spe, sel_region)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{sel_region}{A dataframe object. Can be generated from
function selectRegion.}
}
\value{
A SpatialExperiment object.
}
\description{
Merge sel_region from the selectRegion function to SpatialExperiment.
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")

spe <- gridDensity(spe, coi = coi)

sel_region <- data.frame(
    "node" = seq(10),
    "node_x" = seq(10),
    "node_y" = seq(10)
)

spe1 <- postSelRegion(spe, sel_region)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runPCA.R
\name{runPCA}
\alias{runPCA}
\title{Fast PCA using irlba.}
\usage{
runPCA(
  spe,
  n_pcs = 50,
  assay = "logcounts",
  centre = TRUE,
  scale = TRUE,
  name = "PCA",
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{n_pcs}{Number of principal components to calculate}

\item{assay}{Name of assay used for PCA. See details for defaults.}

\item{centre}{Logical. Whether to centre the assay before PCA.}

\item{scale}{Logical. Whether to scale the variance to 1 before PCA.}

\item{name}{Name to store the PCA in the spe's \link[SingleCellExperiment]{reducedDims}}

\item{...}{Other parameters to be passed to \link[irlba]{irlba}.}
}
\value{
A SpatialExperiment with the PCA stored in \link[SingleCellExperiment]{reducedDims}.
}
\description{
Fast PCA using irlba.
}
\details{
By default, runPCA uses logcounts assay (from \link[scider]{normalizeAssay}).
If that's unavailable, it falls back to counts assay
}
\examples{

data("xenium_bc_spe")

spe <- runPCA(spe)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grid2sf.R
\name{grid2sf}
\alias{grid2sf}
\title{Convert x,y nodes to sf polygons}
\usage{
grid2sf(
  spe,
  x = spe@metadata$grid_density$node_x,
  y = spe@metadata$grid_density$node_y,
  reverseY = FALSE
)
}
\arguments{
\item{spe}{A SpatialExperiment object with grid density calculated}

\item{x}{vector of x nodes of the polygons}

\item{y}{vector of y nodes of the polygons}

\item{reverseY}{Reverse y coordinates. Can be numeric to specify the value to
subtract y coordinates from (reverseY - y coords).}
}
\value{
List of sf polygons
}
\description{
Convert x,y nodes to sf polygons
}
\details{
Default is to generate sf polygons for all grid.
For plotting with geom_sf, use sf::st_as_sfc(grid2sf2(spe)) to convert list
into Geometry Set.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runUMAP.R
\name{runUMAP}
\alias{runUMAP}
\title{UMAP using uwot. Parameters are set to be similar to Seurat's}
\usage{
runUMAP(
  spe,
  n_neighbors = 30,
  n_components = 2,
  metric = "cosine",
  min_dist = 0.3,
  assay = NULL,
  dimred = "PCA",
  n_dimred = NULL,
  name = "UMAP",
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{n_neighbors, n_components, metric, min_dist}{See \link[uwot]{umap}}

\item{assay}{Name of assay for UMAP. Incompatible with dimred.}

\item{dimred}{Name of the dimensionality reduction (e.g. PCA) for UMAP. Incompatible with assay}

\item{n_dimred}{Integer scalar or vector specifying the dimensions to use if dimred is specified.}

\item{name}{Name to store the UMAP in the spe's \link[SingleCellExperiment]{reducedDims}.}

\item{...}{Other parameters to be passed to \link[uwot]{umap}.}
}
\value{
A SpatialExperiment with the UMAP stored in \link[SingleCellExperiment]{reducedDims}.
}
\description{
UMAP using uwot. Parameters are set to be similar to Seurat's
}
\details{
By default, runUMAP uses PCA (from \link[scider]{runPCA}). If that's
unavailable, it falls back to logcounts, then counts assay.
}
\examples{

data("xenium_bc_spe")
spe <- runPCA(spe)
spe <- runUMAP(spe,dimred="PCA",n_dimred=10)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDensCor.R
\name{plotDensCor}
\alias{plotDensCor}
\title{Plot density correlation between two cell types}
\usage{
plotDensCor(
  spe,
  celltype1 = NULL,
  celltype2 = NULL,
  roi = NULL,
  probs = 0.85,
  fit = c("spline", "linear"),
  df = 3,
  pt.shape = 21,
  pt.size = 1.5,
  pt.alpha = 1,
  line.type = 1,
  line.width = 1,
  line.alpha = 1
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{celltype1}{Cell type 1 to compare.}

\item{celltype2}{Cell type 2 to compare.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. Default is NULL for no facetting by ROI}

\item{probs}{A numeric scalar. The threshold of proportion that used to
filter grids by density when ROIs have not been identified previously.
Ignored if 'roi' is present in the 'metadata' component of spe. Default to 0.85.}

\item{fit}{Character. Options are "spline" and "linear".}

\item{df}{Integer. Degrees of freedom of the spline fit.
Default to 3 (i.e., a cubic spline fit).}

\item{pt.shape}{shape of points.}

\item{pt.size}{size of points.}

\item{pt.alpha}{alpha of points between 0 and 1.}

\item{line.type}{shape of line.}

\item{line.width}{size of line.}

\item{line.alpha}{alpha of line between 0 and 1.}
}
\value{
A ggplot object.
}
\description{
Plot density correlation between two cell types
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi, method = "walktrap")

plotDensCor(spe, celltype1 = "Breast cancer", celltype2 = "Fibroblasts", roi = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSpatial.R
\name{plotSpatial}
\alias{plotSpatial}
\title{Plot cells based on spatial coordinates.}
\usage{
plotSpatial(
  spe,
  group.by = NULL,
  feature = NULL,
  assay = "counts",
  type = c("raw", "log", "cpm", "logcpm"),
  cols = NULL,
  pt.shape = 16,
  pt.size = 0.3,
  pt.alpha = 0.5,
  label = NULL,
  cols.scale = NULL,
  reverseY = NULL,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{group.by}{values to group points by. Must be in colData of spe.
If NULL, will try with 'cols' if available.}

\item{feature}{Feature to group polygons by. Must be in rownames(spe).}

\item{assay}{Name of assay to use for plotting feature.}

\item{type}{Transformation to apply for the group/feature. Options are "raw"
, "log", "cpm", "logcpm", or a function that accepts and returns a vector of
the same length.}

\item{cols}{Colour palette. Can be a vector of colours or a function
that accepts an integer n and return n colours.}

\item{pt.shape}{shape of points.}

\item{pt.size}{size of points.}

\item{pt.alpha}{alpha of points between 0 and 1.}

\item{label}{label for the legend}

\item{cols.scale}{vector of position for color if colors should not be
evenly positioned. See \link[ggplot2]{scale_color_gradientn}. Only applicable for continuous values.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Parameters pass to plotImage}
}
\value{
A ggplot object.
}
\description{
Plot cells based on spatial coordinates.
}
\examples{

data("xenium_bc_spe")

plotSpatial(spe, group.by = "cell_type", pt.size = 0.5, pt.alpha = 0.6)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCorHeatmap.R
\name{plotCorHeatmap}
\alias{plotCorHeatmap}
\title{Plot model statistics using heatmap.}
\usage{
plotCorHeatmap(
  model.result,
  stats = c("cor.coef", "t", "p.Pos", "p.Neg"),
  roi = "all",
  cell.type = "all",
  silent = FALSE
)
}
\arguments{
\item{model.result}{A dataFrame object.}

\item{stats}{Character value. Choose either coefficient or t.
Coefficient by default.}

\item{roi}{Character value. By default is all. The specific
ROIs to be plotted.}

\item{cell.type}{Character value. By default is all. The cell types
to be plotted.}

\item{silent}{Do not draw the plot
(useful when using the gtable output).}
}
\value{
A pheatmap object.
}
\description{
Plot model statistics using heatmap.
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi)

model_result <- corDensity(spe, roi = coi)

plotCorHeatmap(model_result$ROI)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotContour.R
\name{plotContour}
\alias{plotContour}
\title{Plot contour lines.}
\usage{
plotContour(
  spe,
  coi = NULL,
  overlay = c("cell", "density", "none"),
  id = "cell_type",
  sub.level = NULL,
  line.type = 1,
  line.width = 0.5,
  line.alpha = 1,
  reverseY = NULL,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{A character vector of cell types of interest (COIs).
All cell types are chosen if NULL or 'overall'.}

\item{overlay}{Character vector. Options are 'cell' (plot overlay on cells),
'density' (overlay on density), or 'none'. Default to 'cell'.}

\item{id}{A character. The name of the column of colData(spe) containing
the cell type identifiers. Set to 'cell_type' by default.}

\item{sub.level}{Character vector. Subset on specific level.}

\item{line.type}{shape of contour. See 'ggplot2::geom_path()'.}

\item{line.width}{size of contour.}

\item{line.alpha}{alpha of contour between 0 and 1.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Aesthetic mappings to pass to \link[scider]{plotSpatial},
\link[scider]{plotDensity}, or \link[scider]{plotImage}, depending on
the overlay.}
}
\value{
A ggplot object.
}
\description{
Plot contour lines.
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

coi <- "Breast cancer"

spe <- getContour(spe, coi = coi)

plotContour(spe, coi = coi, line.width = 0.3, pt.alpha = 0.2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getContour.R
\name{getContour}
\alias{getContour}
\title{Get contour from density}
\usage{
getContour(
  spe,
  coi = NULL,
  equal.cell = TRUE,
  bins = NULL,
  binwidth = NULL,
  breaks = NULL,
  id = NULL
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{A character vector of cell types of interest (COIs).
All cell types are chosen if NULL or \code{overall}.}

\item{equal.cell}{Logical. Whether to use produce contour levels so that
there are roughly the same number of cells of the COI at each level.
Default to TRUE.}

\item{bins}{An integer. Number of contour levels.}

\item{binwidth}{A numeric scale of the smoothing bandwidth.}

\item{breaks}{A numeric scale referring to the breaks in
\code{ggplot2:::contour_breaks}.}

\item{id}{A character. The name of the column of colData(spe) containing
the cell type identifiers. Set to cell_type by default or in_tissue if spe
is Visium. Only needed when \code{equal.cell = TRUE}.}
}
\value{
A SpatialExperiment object. An sf object of the contour region of
the specified level is stored in the metadata of the
SpatialExperiment object.
}
\description{
Get contour from density
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

coi <- "Breast cancer"

spe <- getContour(spe, coi = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moran.R
\name{globalMoran}
\alias{globalMoran}
\title{Calculate global Moran for 1 to 2 variables.}
\usage{
globalMoran(
  spe,
  data1,
  data2 = data1[],
  at = c("grid", "cell"),
  nbrs_name = NULL,
  permutations = 999,
  seed = 123456789,
  cpu_threads = 6
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{data1}{Numeric vector 1. Must be same length as
nrow(spe@metadata$grid_density) or spatialCoords(spe), depending on 'at'.}

\item{data2}{Numeric vector 2 for bivariate local Moran. Must be same length as data1.}

\item{at}{Option of grid or cell for where to look for neighbour list}

\item{nbrs_name}{Name of the neighbour list in \code{spe@metadata$grid[[at]]}
for Moran's I}

\item{permutations}{Number of permutations for p-value.}

\item{seed}{Integer. For random permutations.}

\item{cpu_threads}{(optional) The number of cpu threads used for parallel
LISA computation}
}
\value{
List with global lisa, p.value, and vector of permuted lisa.
}
\description{
Calculate global Moran for 1 to 2 variables.
}
\examples{
data("xenium_bc_spe")

## At grid.
spe <- gridDensity(spe, coi = "Breast cancer")
dat <- spe@metadata$grid_density$density_breast_cancer
spe <- findNbrsGrid(spe)
res <- globalMoran(spe,data1 = dat,at="grid")
res$lisa
## At cell.
dat <- as.numeric(spe$cell_type=="Breast cancer")
spe <- findNbrsSpatial(spe,k=10)
res <- globalMoran(spe,data1 = dat,at="cell")
res$lisa
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/corDensity.R
\name{corDensity}
\alias{corDensity}
\title{Test for density correlation between two cell types.}
\usage{
corDensity(spe, coi = NULL, roi = NULL, probs = 0.85, trace = FALSE)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{Character vector for cell types of interest for density
correlation analysis. Default is NULL, which is to consider all cell types
previously calculated in the gridDensity() step.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. Default is NULL for no subsetting cell types by ROI}

\item{probs}{A numeric scalar. The threshold of proportion that used to
filter grids by density when ROIs have not been identified previously.
Ignored if 'roi' is present in the 'metadata' component of spe. Default to 0.85.}

\item{trace}{Logical. If TRUE, print the process of testing. Default to FALSE.}
}
\value{
A DataFrame containing the testing results.
}
\description{
Test for density correlation between two cell types.
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts", "B cells", "T cells")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi, method = "walktrap")

result <- corDensity(spe, roi = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getClusters.R
\name{getClusters}
\alias{getClusters}
\title{Cluster cells in spe using graph methods.}
\usage{
getClusters(
  spe,
  nbrs_name = NULL,
  method = c("leiden", "louvain"),
  resolution = 1,
  cluster_name = "cluster",
  seed = 1,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{nbrs_name}{Name of neighbour list for clustering. If NULL, will use
the newest one in spe@metadata$nbrs$cell or create one if none are available.}

\item{method}{Clustering methods. Options are leiden and louvain.}

\item{resolution}{Higher resolution for more clusters and lower for fewer
clusters. See \link[igraph]{cluster_leiden} and \link[igraph]{cluster_louvain}}

\item{cluster_name}{Name to store the clusters in spe's
\link[SummarizedExperiment]{colData}}

\item{seed}{seed for clustering}

\item{...}{Other clustering arguments for \link[igraph]{cluster_leiden} or
\link[igraph]{cluster_louvain}}
}
\value{
A spe with the clusters stored in \link[SingleCellExperiment]{reducedDims}.

A SpatialExperiment object
}
\description{
Cluster cells in spe using graph methods.
}
\details{
Cluster cells with igraph using SNN calculated by \link[scider]{findNbrsSNN}.
Any neighbour list in spe@metadata$nbrs$cell can also be used
}
\examples{

data("xenium_bc_spe")
spe <- normalizeAssay(spe)
spe <- runPCA(spe)
spe <- findNbrsSNN(spe,dimred="PCA")
spe <- getClusters(spe, resolution=0.5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findNbrsSpatial.R
\name{findNbrsSpatial}
\alias{findNbrsSpatial}
\title{Construct a distance-based neighbour list from cell coordinates.}
\usage{
findNbrsSpatial(
  spe,
  k = NULL,
  radius = NULL,
  dist_func = c("idw", "exp", "binary", "none"),
  standardisation = c("none", "row"),
  scale = 1,
  nbrs_name = NULL,
  cpu_threads = 6
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{k}{Integer scalar for number of nearest neighbours to find. Can be used
with radius. See details.}

\item{radius}{Numeric for maximum distance to search for neighbours. Can be
with k. See details}

\item{dist_func}{Options for distance-based weight. "idw" for inverse
distance, "exp" for exponential decay, "binary" for constant weight, and
"none" for raw euclidean distance.}

\item{standardisation}{Options for weight standardisation. "none" for
nothing, and "row" for dividing weights by number of neighbours.}

\item{scale}{Numeric scaler for weight scaling.}

\item{nbrs_name}{Name of the neighbour list to be stored. Default to be "spatial".}

\item{cpu_threads}{Number of cpu threads for parallel computation.}
}
\value{
A SpatialExperiment object with neighbour list stored in
\code{spe@metadata$nbrs$cell[[nbrs_name]]}
}
\description{
Construct a distance-based neighbour list from cell coordinates.
}
\details{
if only \code{k} is provided, neighbours are found using
\link[BiocNeighbors]{findKNN}. If only \code{radius} is provided, neighbours are
found using \link[BiocNeighbors]{findNeighbors}. If both are provided, then
knn is done first then neighbours are filtered to only those within radius.
}
\examples{

data("xenium_bc_spe")
spe <- findNbrsSpatial(spe,k=20,radius=100)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotGrid.R
\name{plotGrid}
\alias{plotGrid}
\title{Plot grid from metadata.}
\usage{
plotGrid(
  spe,
  group.by = NULL,
  feature = NULL,
  assay = "counts",
  type = c("raw", "log", "cpm", "logcpm"),
  cols = NULL,
  pol.border = FALSE,
  pol.alpha = 1,
  probs = 0,
  cutoff = NULL,
  label = NULL,
  cols.scale = NULL,
  reverseY = NULL,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{group.by}{values to group polygons by. Must be in
spe@metadata$grid_density, or colData(spe) if gridLevelAnalysis is TRUE.
If NULL, will try with cols if available.}

\item{feature}{Feature to group polygons by. Must be in rownames(spe).}

\item{assay}{Name of assay to use for plotting feature.}

\item{type}{Transformation to apply for the group/feature. Options are "raw"
, "log", "cpm", "logcpm", or a function that accepts and returns a vector of
the same length.}

\item{cols}{Colour palette. Can be a vector of colours or a function
that accepts an integer n and return n colours.}

\item{pol.border}{Boolean. Whether to draw border for each polygon.}

\item{pol.alpha}{alpha of points between 0 and 1.}

\item{probs}{Numeric value between 0 and 1, used for filtering
uninformative grid. Only applicable for continuous values.}

\item{cutoff}{Numeric. Either a vector of length 2 for the lower & upper
bounds of data to be included, or length 1 for the lower bound. Override
probs if specified. Only applicable for continuous values.}

\item{label}{label for the legend}

\item{cols.scale}{vector of position for color if colors should not be
evenly positioned. See \link[ggplot2]{scale_fill_gradientn}. Only applicable for continuous values.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Parameters pass to \link[scider]{plotImage}}
}
\value{
A ggplot object.
}
\description{
Plot grid from metadata.
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

plotGrid(spe, group.by = "density_overall")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotImage.R
\name{plotImage}
\alias{plotImage}
\title{Plot background image of spe}
\usage{
plotImage(
  spe,
  image = TRUE,
  image_id = NULL,
  sample_id = NULL,
  reverseY = NULL,
  crop = TRUE,
  image.alpha = 1
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{image}{Logical. Whether to plot image (if present).}

\item{image_id, sample_id}{sample and image identifiers for scaling factor.
See \link[SpatialExperiment]{scaleFactors} for default behavior.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{crop}{Whether to crop the plot to the spots.}

\item{image.alpha}{alpha of points between 0 and 1.}
}
\value{
a ggplot object if there is a valid image, else NULL.
}
\description{
Plot background image of spe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allocateCells.R
\name{allocateCells}
\alias{allocateCells}
\title{Annotate all cells with contour level of cell type-specific density.}
\usage{
allocateCells(
  spe,
  to.roi = TRUE,
  roi = NULL,
  to.contour = TRUE,
  contour = NULL
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{to.roi}{Logical. Whether to allocate cells to ROIs.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. If NULL, then the cell allocation will
be performed for all detected roi Default to NULL.}

\item{to.contour}{Logical. Whether to allocate cells to contour levels.}

\item{contour}{Character. The name of the group or cell type on which
the contour level is computed. If NULL, then the cell allocation will
be performed for all detected contours. Default to NULL.}
}
\value{
A SpatialExperiment object. An extra column is added to the colData.
}
\description{
Annotate all cells with contour level of cell type-specific density.
}
\examples{

data("xenium_bc_spe")
spe <- gridDensity(spe)
coi <- "Breast cancer"
spe <- findROI(spe, coi = coi)
spe <- getContour(spe, coi = coi)
spe <- allocateCells(spe, contour = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getNiche.R
\name{getNiche}
\alias{getNiche}
\title{Build a niche assay based on the profile of neighbouring cells}
\usage{
getNiche(
  spe,
  at = c("cell", "grid"),
  nbrs_name = NULL,
  group.by,
  use_weight = FALSE
)
}
\arguments{
\item{spe}{A SpatialExperiment object}

\item{at}{Option of cell or grid neighbourhood}

\item{nbrs_name}{Name of the neighbour list in \code{spe@metadata$grid[[at]]}}

\item{group.by}{Character vector to group neighbours cell by. Should be in
either colData(spe) or spe@metadata$grid_density, depending
on "at". Multiple groups can be used. See details}

\item{use_weight}{Whether to scale each nbr based on its weight}
}
\value{
A matrix where rows are cells/grid points and cols are groups based
on group.by
}
\description{
Build a niche assay based on the profile of neighbouring cells
}
\details{
For numerical group, result will be sum of nbrs for each cell. For
categorical group (factor/string), result will be counts of nbrs belonging in
category
}
\examples{

data("xenium_bc_spe")

spe <- findNbrsSpatial(spe,k=30)
niche = getNiche(spe,at="cell",group.by="cell_type")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grid2sf.R
\name{grid2df}
\alias{grid2df}
\title{Convert x,y nodes to data.frame of polygons}
\usage{
grid2df(
  spe,
  x = spe@metadata$grid_density$node_x,
  y = spe@metadata$grid_density$node_y,
  reverseY = FALSE,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object with grid density calculated}

\item{x}{vector of x nodes of the polygons}

\item{y}{vector of y nodes of the polygons}

\item{reverseY}{Reverse y coordinates. Can be numeric to specify the value to
subtract y coordinates from (reverseY - y coords).}

\item{...}{other elements to be stored as columns of the data.frame. Each one
must be a vector same length as x.}
}
\value{
data.frame with X, Y, and L2. Points with the same L2 belong to the
same polygons
}
\description{
Convert x,y nodes to data.frame of polygons
}
\details{
Basically grid2sf() but returns a data.frame for plotting with geom_polygon(),
which allows for scale_*_transform(), unlike geom_sf().

Column names are kept similar to sf::st_coordinates
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/normalizeAssay.R
\name{normalizeAssay}
\alias{normalizeAssay}
\title{Perform log normalization for counts}
\usage{
normalizeAssay(
  spe,
  transformation = c("log"),
  scale.factor = 1e+06,
  assay = "counts",
  name = "logcounts"
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{transformation}{Choice of transformation. "Log" for log1p}

\item{scale.factor}{Factor to multiply the count of each cell by. A single
value or a numeric vector equal to number of cells}

\item{assay}{Name of assay in spe to perform the transformation on}

\item{name}{Name of the transformed assay}
}
\value{
A SpatialExperiment object
}
\description{
Perform log normalization for counts
}
\examples{
data("xenium_bc_spe")
spe <- normalizeAssay(spe)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spe2PB.R
\name{spe2PB}
\alias{spe2PB}
\title{Given a 'SpatialExperiment' data object, create pseudo-bulk
samples using the colData information and return a DGEList object}
\usage{
spe2PB(
  spe,
  by.group = TRUE,
  group.id = "cell_type",
  keep.groups = NULL,
  roi = NULL,
  roi.only = TRUE,
  contour = NULL
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{by.group}{Logical. Whether to perform pseudo-bulking by group.
TRUE by default.}

\item{group.id}{Character. The column name of the colData(spe) that
contains the group information. Default to 'cell_type'.}

\item{keep.groups}{Vector. Values from group.id to include in pseudo-
bulking. Default is NULL, where all cells are included in pseudo-bulking.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed.
If NULL, then no pseudo-bulking will be performed based on roi.
Default to NULL.}

\item{roi.only}{Logical. Whether to filter out pseudo-bulk samples formed
by cells not in any ROIs. TRUE by default.}

\item{contour}{Character. The name of the group or cell type on which
the contour level is computed.
If NULL, then no pseudo-bulking will be performed based on contour level.
Default to NULL.}
}
\value{
An edgeR::DGEList object where each library (column) is a
pseudo-bulk sample.
}
\description{
Given a 'SpatialExperiment' data object, create pseudo-bulk
samples using the colData information and return a DGEList object
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

coi <- "Breast cancer"

spe <- findROI(spe, coi = coi)

spe <- allocateCells(spe, to.contour=FALSE)

y <- spe2PB(spe, roi = coi)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/computeDensityHex.R
\name{computeDensityHex}
\alias{computeDensityHex}
\title{Perform kernel density estimation on SpatialExperiment}
\usage{
computeDensityHex(
  xy,
  kernel = c("gaussian"),
  bandwidth = NULL,
  weights = NULL,
  ngrid.x = NULL,
  xlim = NULL,
  ylim = NULL,
  diggle = FALSE,
  gridInfo = FALSE
)
}
\arguments{
\item{xy}{A numeric matrix of spatial coordinates.}

\item{kernel}{The smoothing kernel. Options are gaussian, epanechnikov,
quartic or disc. ONLY GAUSSIAN IS IMPLEMENTED}

\item{bandwidth}{The smoothing bandwidth. By default performing automatic
bandwidth selection using cross-validation using function
spatstat.explore::bw.diggle.}

\item{weights}{Optional weights to be attached to the points.}

\item{ngrid.x}{Number of grids in the x-direction.}

\item{xlim}{The range of the x-coordinates of the image.}

\item{ylim}{The range of the y-coordinates of the image.}

\item{diggle}{Logical. If TRUE, use the Jones-Diggle improved edge
correction. See spatstat.explore::density.ppp() for details.}

\item{gridInfo}{Logical. If TRUE, then the grid information is also returned.}
}
\value{
Output from spatstat.explore::density.ppp.
}
\description{
Perform kernel density estimation on SpatialExperiment
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findNbrsGrid.R
\name{coord_hash}
\alias{coord_hash}
\title{Hash two 15-bytes signed integers into one 32-bytes integer.}
\usage{
coord_hash(a, b)
}
\arguments{
\item{a, b}{Integer vectors of same lengths. Can be negative.}
}
\description{
Hash two 15-bytes signed integers into one 32-bytes integer.
}
\details{
Should work for a,b in range (-2^14, 2^14-1) which is good enough for our
purpose.

Integer in R is 32-bytes but reserve 1 byte for NA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/contour2sf.R
\name{contour2sf}
\alias{contour2sf}
\title{Draw a contour region on some density level}
\usage{
contour2sf(spe, contour, cutoff)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{contour}{Name in metadata.}

\item{cutoff}{A numeric scalar specifying the density cutoff.}
}
\value{
An sf object of the contour region of the specified level.
}
\description{
Draw a contour region on some density level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scider-package.R
\docType{data}
\name{xenium_bc_spe}
\alias{xenium_bc_spe}
\alias{spe}
\title{Description of the scider example datasets}
\format{
A SpatialExperiment object
}
\usage{
data("xenium_bc_spe")
}
\value{
A SpatialExperiment object
}
\description{
scider-package has 1 datasets: \itemize{
\item xenium_bc_spe Example test spatial transcriptomics data
in SpatialExperiment format. This test data is randomly subsetting
from a publicly available 10X Xenium breast cancer data.
Source data: https://www.10xgenomics.com/resources/datasets/xenium-ffpe-human-breast-with-custom-add-on-panel-1-standard
}
}
\examples{
data(xenium_bc_spe)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotContourRegion.R
\name{plotContourRegion}
\alias{plotContourRegion}
\title{Visualising an sf object (for internal use only at the moment)}
\usage{
plotContourRegion(
  spe,
  coi,
  id = "cell_type",
  overlay = c("density", "cell"),
  sub.level
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{A character vector of length 1 of the cell type of interest.}

\item{id}{A character. The name of the column of colData(spe) containing
the cell type identifiers. Set to cell_type by default.}

\item{overlay}{Character vector. Either plot overlay on density or cells.}

\item{sub.level}{Numeric vector of length 1 or 2, identifies which
density level to plot. When length is 1, plot the density region above
this level. When length is 2, plot the density region
between the two levels.}
}
\value{
A ggplot object.
}
\description{
Visualising an sf object (for internal use only at the moment)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findROI.R
\name{findROI}
\alias{findROI}
\title{Find ROIs based on cell type-specific densities via graph-based method.}
\usage{
findROI(
  spe,
  coi = NULL,
  probs = 0.85,
  min.density = NULL,
  ngrid.min = 20,
  method = c("greedy", "walktrap", "connected", "hdbscan", "eigen", "dbscan"),
  diag.nodes = FALSE,
  sequential.roi.name = TRUE,
  zoom.in = FALSE,
  zoom.in.size = 500L,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{A character vector of cell types of interest (COIs).
Default to all cell types.}

\item{probs}{A numeric scalar. The threshold of proportion that used to
filter grids by density. Default to 0.85.}

\item{min.density}{A numeric value. The cut-off value used to filter grids
by density. Default is NULL and overwrites probs.}

\item{ngrid.min}{An integer. The minimum number of grids required for
defining a ROI. Default to 20.}

\item{method}{The community dectection method to be used, possible options
are greedy, walktrap, connected, hdbscan, eigen or dbscan.
Default to greedy, can be abbreviated.}

\item{diag.nodes}{Logical. Set this to TRUE to allow diagonal grid points
to be adjacent nodes.}

\item{sequential.roi.name}{Logical. Set this to FALSE if you want the
original ROI name before
filtering are retained.}

\item{zoom.in}{Logical. For very large ROIs, whether to zoom in and try
to get more refined ROIs.}

\item{zoom.in.size}{A numeric scaler. Smallest size of an ROI to be able
to zoom in. Default is 500L.}

\item{...}{Other parameters that passed to walktrap.community when method =
"walktrap".}
}
\value{
A SpatialExperiment object.
}
\description{
Find ROIs based on cell type-specific densities via graph-based method.
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi, method = "walktrap")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findNbrsGrid.R
\name{findNbrsGrid}
\alias{findNbrsGrid}
\title{Construct a neighbour list from grid coordinates.}
\usage{
findNbrsGrid(
  spe,
  n = 1,
  radius = NULL,
  diagonal = FALSE,
  dist_func = c("idw", "exp", "binary", "none"),
  dist_type = c("euclidean", "manhattan"),
  standardisation = c("row", "none"),
  scale = 1,
  nbrs_name = NULL,
  cpu_threads = 6
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{n}{Integer. Search for neighbours within (...). Either the number of
neighbors or radius}

\item{radius}{Numeric. Search for neighbours within the radius.}

\item{diagonal}{Whether to consider diagonal connection if using square grid}

\item{dist_func}{Options for distance-based weight. "idw" for inverse
distance, "exp" for exponential decay, "binary" for constant weight, and
"raw" for raw distance.}

\item{dist_type}{Options of using euclidean or manhattan for distance calculation}

\item{standardisation}{Options for weight standardisation. "none" for
nothing, and "row" for dividing weights by number of neighbours.}

\item{scale}{Numeric scaler for weight scaling.}

\item{nbrs_name}{Name of the neighbour list to be stored. Default to be "grid".}

\item{cpu_threads}{Number of cpu threads for parallel computation.}
}
\value{
A SpatialExperiment object with neighbour list stored in
\code{spe@metadata$nbrs$grid[[nbrs_name]]}
}
\description{
Construct a neighbour list from grid coordinates.
}
\details{
If n is used, distance is scaled to unit distance
}
\examples{

data("xenium_bc_spe")
spe <- gridDensity(spe)
spe <- findNbrsGrid(spe,n=3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/selectRegion.R
\name{selectRegion}
\alias{selectRegion}
\title{Select region of interest from plot}
\usage{
selectRegion(data, x.col = "x", y.col = "y")
}
\arguments{
\item{data}{A data.frame object.}

\item{x.col}{Column name of the x coordinates.}

\item{y.col}{Column name of the y coordinates.}
}
\value{
A data.frame object in the global environment.
}
\description{
Select region of interest from plot
}
\examples{

data("xenium_bc_spe")

spe_b <- spe[, SummarizedExperiment::colData(spe)$cell_type == "B cells"]

dat <- as.data.frame(SpatialExperiment::spatialCoords(spe_b))

# selectRegion(dat, x.col = "x_centroid", y.col = "y_centroid")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cellsInRegion.R
\name{cellsInRegion}
\alias{cellsInRegion}
\title{Check which cells are in which regions}
\usage{
cellsInRegion(spe, region, name_to, NA_level = "0", levels = NULL)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{region}{List or an sf object that represents a region or an ROI.}

\item{name_to}{Colname in colData(spe) to store the annotation.}

\item{NA_level}{Label for cells not falling in any of the regions.
Default to 0.}

\item{levels}{Factor levels.}
}
\value{
A SpatialExperiment object. The region information of each cell is
stored in the colData.
}
\description{
Check which cells are in which regions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDR.R
\name{plotDR}
\alias{plotDR}
\alias{plotUMAP}
\alias{plotPCA}
\title{Plot reduced dimensions.}
\usage{
plotDR(
  spe,
  dimred = NULL,
  dims = c(1, 2),
  group.by = NULL,
  feature = NULL,
  assay = "counts",
  cols = NULL,
  pt.shape = 16,
  pt.size = 1,
  pt.alpha = 0.6,
  label = NULL,
  label.x = NULL,
  label.y = NULL,
  cols.scale = NULL
)

plotUMAP(spe, dimred = "UMAP", ...)

plotPCA(spe, dimred = "PCA", ...)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{dimred}{Name of the reduced dimension in \link[SingleCellExperiment]{reducedDims}}

\item{dims}{Numeric vector length 2 for the dimensions to be plotted. Default to first two dimensions}

\item{group.by}{values to group points by. Must be in colData of spe.
If NULL, will try with 'cols' if available.}

\item{feature}{Feature to group polygons by. Must be in rownames(spe).}

\item{assay}{Name of assay to use for plotting feature.}

\item{cols}{Colour palette. Can be a vector of colours or a function
that accepts an integer n and return n colours.}

\item{pt.shape}{shape of points.}

\item{pt.size}{size of points.}

\item{pt.alpha}{alpha of points between 0 and 1.}

\item{label}{label for the legend}

\item{label.x}{label for the x-axis}

\item{label.y}{label for the y-axis}

\item{cols.scale}{vector of position for color if colors should not be
evenly positioned. See \link[ggplot2]{scale_color_gradientn}. Only applicable for continuous values.}

\item{...}{Additional arguments pass to plotDR}
}
\value{
A ggplot object.
}
\description{
plotDR is the main function for plotting reduced dimension. Others are
wrapper functions for convenience.
}
\examples{

data("xenium_bc_spe")
spe = runUMAP(spe)
plotDR(spe, group.by = "cell_type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/realignVisium.R
\name{realignVisium}
\alias{realignVisium}
\title{Scale and straighten out Visium coordinates}
\usage{
realignVisium(spe, distPoint = 100)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{distPoint}{Numeric. Desired point to point distance.}
}
\description{
Scale and straighten out Visium coordinates
}
\details{
This function rescale the distance between points to 100um (or other
value) to matchthe real distance. In addition, Visium spots have a slight
tilt to them which this function will also fix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getContourRegions.R
\name{getContourRegions}
\alias{getContourRegions}
\title{Calculate areas between every two density levels}
\usage{
getContourRegions(spe, contour_name)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{contour_name}{Name of contour in spe@metadata}
}
\value{
A list of sf objects, each representing the region between
two contour density levels.
}
\description{
Calculate areas between every two density levels
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridDensity.R
\name{gridDensity}
\alias{gridDensity}
\title{Perform kernel density estimation on SpatialExperiment for
cell types of interest}
\usage{
gridDensity(
  spe,
  id = if (isVisium) NULL else "cell_type",
  coi = NULL,
  feature = NULL,
  assay = "counts",
  kernel = "gaussian",
  bandwidth = NULL,
  ngrid.x = NULL,
  grid.length.x = NULL,
  diggle = FALSE,
  grid.type = c("hex", "square"),
  isVisium = FALSE,
  filterToVisiumSpot = isVisium
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{id}{A character. The name of the column of colData(spe) containing
the cell type identifiers. Set to cell_type by default. Set to NULL for overall density.}

\item{coi}{A character vector of cell types of interest (COIs).
Default to all cell types.}

\item{feature}{Feature(s) to calculate density with. Must be in rownames(spe).}

\item{assay}{Name of assay to use for finding feature(s).}

\item{kernel}{The smoothing kernel. Options are "gaussian",
"epanechnikov", "quartic" or "disc". For hexagonal grid, only Gaussian is implemented}

\item{bandwidth}{The smoothing bandwidth. By default performing
automatic bandwidth selection using cross-validation using
function spatstat.explore::bw.diggle.}

\item{ngrid.x}{Number of grids in the x-direction. Ignored when
'grid.length.x' is specified. Default to NULL.}

\item{grid.length.x}{Grid length in the x-direction. If both
'ngrid.x' and 'grid.length.x' are NULL, then 'grid.length.x'
is set to 100 (micron) by default.}

\item{diggle}{Logical. If TRUE, use the Jones-Diggle improved edge
correction. See spatstat.explore::density.ppp() for details.}

\item{grid.type}{Type of grid can be either hexagon or square.}

\item{isVisium}{Logical. If TRUE, fit hexagonal grids to Visium spots by
replacing spatial coords with array rows & array cols.}

\item{filterToVisiumSpot}{Logical. If TRUE, filter grid polygons to only
those with a Visium spot underneath.}
}
\value{
A SpatialExperiment object. Grid density estimates for
all cell type of interest are stored in spe@metadata$grid_density.
Grid information is stored in spe@metadata$grid_info
}
\description{
Perform kernel density estimation on SpatialExperiment for
cell types of interest
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDensity.R
\name{plotDensity}
\alias{plotDensity}
\title{Plot grid-based density.}
\usage{
plotDensity(spe, coi = NULL, probs = 0.5, reverseY = NULL, ...)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{coi}{A character vector of cell types of interest (COIs) to be plotted.
Default to all cell types.}

\item{probs}{Numeric value between 0 and 1, used for filtering
uninformative grid, default is 0.5.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Parameters pass to \link[scider]{plotGrid}}
}
\value{
A ggplot object.
}
\description{
Plot grid-based density.
}
\examples{

data("xenium_bc_spe")

spe <- gridDensity(spe)

plotDensity(spe, coi = "Breast cancer")

plotDensity(spe, coi = "Fibroblasts")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotROI.R
\name{plotROI}
\alias{plotROI}
\title{Plot ROIs on spatial.}
\usage{
plotROI(
  spe,
  roi = NULL,
  id = "cell_type",
  label = TRUE,
  show.legend = FALSE,
  reverseY = NULL,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{roi}{Character. The name of the group or cell type on which
the roi is computed. All cell types are chosen if NULL or 'overall'.}

\item{id}{Character. The name of the column of colData(spe) containing
the cell type identifiers. Set to cell_type by default.}

\item{label}{Logical. Show ROI label or not.}

\item{show.legend}{Logical. Show legend or not.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Parameters pass to \link[scider]{plotSpatial}}
}
\value{
A ggplot object.
}
\description{
Plot ROIs on spatial.
}
\examples{

data("xenium_bc_spe")

coi <- c("Breast cancer", "Fibroblasts")

spe <- gridDensity(spe, coi = coi)

spe <- findROI(spe, coi = coi, method = "walktrap", steps = 5)

plotROI(spe, roi = coi, pt.size = 0.3, pt.alpha = 0.2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLISA.R
\name{plotLISA}
\alias{plotLISA}
\title{Plotting LISA (e.g. moran)}
\usage{
plotLISA(
  spe,
  lisa,
  overlay = c("grid", "point"),
  type = c("cluster", "logpvalue"),
  reverseY = NULL,
  ...
)
}
\arguments{
\item{spe}{A SpatialExperiment object.}

\item{lisa}{Output from localMoran}

\item{overlay}{Option of grid or point. Depend on whether
\link[scider]{localMoran} is calculated at grid or point.}

\item{type}{Option of cluster or logpvalue for plotting lisa's cluster or
p-value, respectively.}

\item{reverseY}{Logical. Whether to reverse Y coordinates. Default is TRUE
if the spe contains an image (even if not plotted) and FALSE if otherwise.}

\item{...}{Parameters pass to \link[scider]{plotGrid} or
\link[scider]{plotSpatial}, depending on overlay.}
}
\value{
a ggplot object
}
\description{
Plotting LISA (e.g. moran)
}
\examples{
data("xenium_bc_spe")
spe <- gridDensity(spe, coi = "Breast cancer")
dat <- spe@metadata$grid_density$density_breast_cancer
spe <- findNbrsGrid(spe)
res <- localMoran(spe,data1=dat, at = "grid")
plotLISA(spe,lisa = res)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotImage.R
\name{update_bound}
\alias{update_bound}
\title{Update the x,y limits of a plot}
\usage{
update_bound(p, x = NULL, y = NULL)
}
\arguments{
\item{p}{A ggplot() object}

\item{x, y}{Vectors of new x and y limits.}
}
\value{
a ggplot object
}
\description{
Update the x,y limits of a plot
}
